unit Gl;

#define FULLFEATURES

{
  (*$ifdef _WIN32 *)
    (*$define WINGDIAPI attribute (stdcall) *)
  (*$else *)
}
    (*$define WINGDIAPI *)
{
  (*$endif *)
}

(****************************************************************************
*
*                       MegaGraph Graphics Library
*
*               Copyright (C) 1991-1997 SciTech Software, Inc.
*                            All rights reserved.
*
*  ======================================================================
*       This library is free software; you can use it and/or
*       modify it under the terms of the SciTech MGL Software License.
*
*       This library is distributed in the hope that it will be useful,
*       but WITHOUT ANY WARRANTY; without even the implied warranty of
*       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*       SciTech MGL Software License for more details.
*  ======================================================================
*
* Filename:     $Workfile:   MGLGL.PAS  $
* Version:      $Revision:   1.1  $
*
* Language:     Borland Delphi 2.0
* Environment:  Win32
* C Headers:    gl\gl.h
*
* Description:  Main OpenGL header file. This header file calls OpenGL
*               functions via function pointers stored in a global strcture
*               using macros. The structure is defined in the MGL libraries,
*               but if you are linking with the DLL version of the MGL code,
*               you will need to define a copy of this structure in your
*               main program and call MGL_setOpenGLFuncs() to let the
*               MGL know where you function pointer structure is.
*
*               Alternatively you can define NO_GL_MACROS and you will end
*               up calling the real function stubs that then call the
*               correct routines in the MGL libraries.
*
* $Date:   20 Oct 1997 12:20:50  $ $Author:   KendallB  $
*
****************************************************************************)

interface

{-- General type definitions -----------------------------------------------}

type
    (*
    Float       = Single;
    GLenum      = __unsigned__ Integer;
    GLboolean   = ByteBool; { uchar; }
    GLbitfield  = __unsigned__ Integer;
    GLbyte      = Char;
    GLshort     = ShortInt;
    GLint       = int;
    GLsizei     = Integer;
    GLubyte     = __unsigned__  Char;
    GLushort    = ShortCard;
    GLuint      = __unsigned__ Integer;
    GLfloat     = float;
    GLclampf    = float;
    GLdouble    = double;
    GLclampd    = double;
    *)

    GlEnum    = Integer;
    GLvoid    = Pointer; { ? }
    GLboolean = Boolean; { ? }
    GLbyte    = ByteInt;
    GLshort   = ShortInt;
    GLint     = Integer;
    GLubyte   = ByteCard;
    GLushort  = ShortCard;
    GLuint    = Cardinal;
    GLsizei   = Integer;
    GLfloat   = Single;
    GLclampf  = Single;
    GLdouble  = Double;
    GLclampd  = Double;
    GLbitfield= Integer;

    PGLEnum     = ^GLEnum;
    PGLboolean  = ^GLboolean;
    PGLbitfield = ^GLbitfield;
    PGLbyte     = ^GLbyte;
    PGLshort    = ^GLshort;
    PGLint      = ^GLint;
    PGLsizei    = ^GLsizei;
    PGLubyte    = ^GLubyte;
    PGLushort   = ^GLushort;
    PGLuint     = ^GLuint;
    PGLfloat    = ^GLfloat;
    PGLclampf   = ^GLclampf;
    PGLdouble   = ^GLdouble;
    PGLclampd   = ^GLclampd;

    PGLvoid     = Pointer;
    PPGLvoid    = ^PGLVoid;

const

{-- AttribMask -------------------------------------------------------------}

    GL_CURRENT_BIT                      = $00000001 ;
    GL_POINT_BIT                        = $00000002 ;
    GL_LINE_BIT                         = $00000004 ;
    GL_POLYGON_BIT                      = $00000008 ;
    GL_POLYGON_STIPPLE_BIT              = $00000010 ;
    GL_PIXEL_MODE_BIT                   = $00000020 ;
    GL_LIGHTING_BIT                     = $00000040 ;
    GL_FOG_BIT                          = $00000080 ;
    GL_DEPTH_BUFFER_BIT                 = $00000100 ;
    GL_ACCUM_BUFFER_BIT                 = $00000200 ;
    GL_STENCIL_BUFFER_BIT               = $00000400 ;
    GL_VIEWPORT_BIT                     = $00000800 ;
    GL_TRANSFORM_BIT                    = $00001000 ;
    GL_ENABLE_BIT                       = $00002000 ;
    GL_COLOR_BUFFER_BIT                 = $00004000 ;
    GL_HINT_BIT                         = $00008000 ;
    GL_EVAL_BIT                         = $00010000 ;
    GL_LIST_BIT                         = $00020000 ;
    GL_TEXTURE_BIT                      = $00040000 ;
    GL_SCISSOR_BIT                      = $00080000 ;
    GL_ALL_ATTRIB_BITS                  = $000fffff ;

{-- ClearBufferMask --------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_COLOR_BUFFER_BIT
    // GL_ACCUM_BUFFER_BIT
    // GL_STENCIL_BUFFER_BIT
    // GL_DEPTH_BUFFER_BIT
{$ENDIF}

{-- ClientAttribMask -------------------------------------------------------}

    GL_CLIENT_PIXEL_STORE_BIT           = $00000001 ;
    GL_CLIENT_VERTEX_ARRAY_BIT          = $00000002 ;
    GL_CLIENT_ALL_ATTRIB_BITS           = $FFFFFFFF ;

{-- Boolean ----------------------------------------------------------------}

    GL_FALSE                            = GLboolean(0) ;
    GL_TRUE                             = GLboolean(1) ;

{-- BeginMode --------------------------------------------------------------}

    GL_POINTS                           = $0000 ;
    GL_LINES                            = $0001 ;
    GL_LINE_LOOP                        = $0002 ;
    GL_LINE_STRIP                       = $0003 ;
    GL_TRIANGLES                        = $0004 ;
    GL_TRIANGLE_STRIP                   = $0005 ;
    GL_TRIANGLE_FAN                     = $0006 ;
    GL_QUADS                            = $0007 ;
    GL_QUAD_STRIP                       = $0008 ;
    GL_POLYGON                          = $0009 ;

#ifdef FULLFEATURES
{-- AccumOp ----------------------------------------------------------------}

    GL_ACCUM                            = $0100 ;
    GL_LOAD                             = $0101 ;
    GL_RETURN                           = $0102 ;
    GL_MULT                             = $0103 ;
    GL_ADD                              = $0104 ;

{-- AlphaFunction ----------------------------------------------------------}

    GL_NEVER                            = $0200 ;
    GL_LESS                             = $0201 ;
    GL_EQUAL                            = $0202 ;
    GL_LEQUAL                           = $0203 ;
    GL_GREATER                          = $0204 ;
    GL_NOTEQUAL                         = $0205 ;
    GL_GEQUAL                           = $0206 ;
    GL_ALWAYS                           = $0207 ;

{-- BlendingFactorDest -----------------------------------------------------}

    GL_ZERO                             = 0 ;
    GL_ONE                              = 1 ;
    GL_SRC_COLOR                        = $0300 ;
    GL_ONE_MINUS_SRC_COLOR              = $0301 ;
    GL_SRC_ALPHA                        = $0302 ;
    GL_ONE_MINUS_SRC_ALPHA              = $0303 ;
    GL_DST_ALPHA                        = $0304 ;
    GL_ONE_MINUS_DST_ALPHA              = $0305 ;
    GL_CONSTANT_COLOR                   = $8001 ;
    GL_ONE_MINUS_CONSTANT_COLOR         = $8002 ;
    GL_CONSTANT_ALPHA                   = $8003 ;
    GL_ONE_MINUS_CONSTANT_ALPHA         = $8004 ;

{-- BlendingFactorSrc ------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_ZERO
    // GL_ONE
{$ENDIF}
    GL_DST_COLOR                        = $0306 ;
    GL_ONE_MINUS_DST_COLOR              = $0307 ;
    GL_SRC_ALPHA_SATURATE               = $0308 ;
{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_SRC_ALPHA
    // GL_ONE_MINUS_SRC_ALPHA
    // GL_DST_ALPHA
    // GL_ONE_MINUS_DST_ALPHA
{$ENDIF}

{-- ColorMaterialFace ------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_FRONT
    // GL_BACK
    // GL_FRONT_AND_BACK
{$ENDIF}

{-- ColorMaterialParameter -------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_AMBIENT
    // GL_DIFFUSE
    // GL_SPECULAR
    // GL_EMISSION
    // GL_AMBIENT_AND_DIFFUSE
{$ENDIF}

{-- ColorPointerType -------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_BYTE
    // GL_UNSIGNED_BYTE
    // GL_SHORT
    // GL_UNSIGNED_SHORT
    // GL_INT
    // GL_UNSIGNED_INT
    // GL_FLOAT
    // GL_DOUBLE
{$ENDIF}

{-- CullFaceMode -----------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_FRONT
    // GL_BACK
    // GL_FRONT_AND_BACK
{$ENDIF}

{-- CullParameterSGI -------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_CULL_VERTEX_EYE_POSITION_SGI
    // GL_CULL_VERTEX_OBJECT_POSITION_SGI
{$ENDIF}

{-- DepthFunction ----------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_NEVER
    // GL_LESS
    // GL_EQUAL
    // GL_LEQUAL
    // GL_GREATER
    // GL_NOTEQUAL
    // GL_GEQUAL
    // GL_ALWAYS
{$ENDIF}
#endif

{-- DrawBufferMode ---------------------------------------------------------}

    GL_NONE                             = 0 ;
    GL_FRONT_LEFT                       = $0400 ;
    GL_FRONT_RIGHT                      = $0401 ;
    GL_BACK_LEFT                        = $0402 ;
    GL_BACK_RIGHT                       = $0403 ;
    GL_FRONT                            = $0404 ;
    GL_BACK                             = $0405 ;
    GL_LEFT                             = $0406 ;
    GL_RIGHT                            = $0407 ;
    GL_FRONT_AND_BACK                   = $0408 ;
    GL_AUX0                             = $0409 ;
    GL_AUX1                             = $040A ;
    GL_AUX2                             = $040B ;
    GL_AUX3                             = $040C ;

#ifdef FULLFEATURES
{-- EnableCap --------------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_FOG
    // GL_LIGHTING
    // GL_TEXTURE_1D
    // GL_TEXTURE_2D
    // GL_LINE_STIPPLE
    // GL_POLYGON_STIPPLE
    // GL_CULL_FACE
    // GL_ALPHA_TEST
    // GL_BLEND
    // GL_INDEX_LOGIC_OP
    // GL_COLOR_LOGIC_OP
    // GL_DITHER
    // GL_STENCIL_TEST
    // GL_DEPTH_TEST
    // GL_CLIP_PLANE0
    // GL_CLIP_PLANE1
    // GL_CLIP_PLANE2
    // GL_CLIP_PLANE3
    // GL_CLIP_PLANE4
    // GL_CLIP_PLANE5
    // GL_LIGHT0
    // GL_LIGHT1
    // GL_LIGHT2
    // GL_LIGHT3
    // GL_LIGHT4
    // GL_LIGHT5
    // GL_LIGHT6
    // GL_LIGHT7
    // GL_TEXTURE_GEN_S
    // GL_TEXTURE_GEN_T
    // GL_TEXTURE_GEN_R
    // GL_TEXTURE_GEN_Q
    // GL_MAP1_VERTEX_3
    // GL_MAP1_VERTEX_4
    // GL_MAP1_COLOR_4
    // GL_MAP1_INDEX
    // GL_MAP1_NORMAL
    // GL_MAP1_TEXTURE_COORD_1
    // GL_MAP1_TEXTURE_COORD_2
    // GL_MAP1_TEXTURE_COORD_3
    // GL_MAP1_TEXTURE_COORD_4
    // GL_MAP2_VERTEX_3
    // GL_MAP2_VERTEX_4
    // GL_MAP2_COLOR_4
    // GL_MAP2_INDEX
    // GL_MAP2_NORMAL
    // GL_MAP2_TEXTURE_COORD_1
    // GL_MAP2_TEXTURE_COORD_2
    // GL_MAP2_TEXTURE_COORD_3
    // GL_MAP2_TEXTURE_COORD_4
    // GL_POINT_SMOOTH
    // GL_LINE_SMOOTH
    // GL_POLYGON_SMOOTH
    // GL_SCISSOR_TEST
    // GL_COLOR_MATERIAL
    // GL_NORMALIZE
    // GL_AUTO_NORMAL
    // GL_POLYGON_OFFSET_POINT
    // GL_POLYGON_OFFSET_LINE
    // GL_POLYGON_OFFSET_FILL
    // GL_VERTEX_ARRAY
    // GL_NORMAL_ARRAY
    // GL_COLOR_ARRAY
    // GL_INDEX_ARRAY
    // GL_TEXTURE_COORD_ARRAY
    // GL_EDGE_FLAG_ARRAY
    // GL_CULL_VERTEX_SGI
    // GL_INDEX_MATERIAL_SGI
    // GL_INDEX_TEST_SGI
{$ENDIF}

{-- ErrorCode --------------------------------------------------------------}

    GL_NO_ERROR                         = 0 ;
    GL_INVALID_ENUM                     = $0500 ;
    GL_INVALID_VALUE                    = $0501 ;
    GL_INVALID_OPERATION                = $0502 ;
    GL_STACK_OVERFLOW                   = $0503 ;
    GL_STACK_UNDERFLOW                  = $0504 ;
    GL_OUT_OF_MEMORY                    = $0505 ;
{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_TABLE_TOO_LARGE_EXT
{$ENDIF}

{-- FeedbackType -----------------------------------------------------------}

    GL_2D                               = $0600 ;
    GL_3D                               = $0601 ;
    GL_3D_COLOR                         = $0602 ;
    GL_3D_COLOR_TEXTURE                 = $0603 ;
    GL_4D_COLOR_TEXTURE                 = $0604 ;

{-- FeedBackToken ----------------------------------------------------------}

    GL_PASS_THROUGH_TOKEN               = $0700 ;
    GL_POINT_TOKEN                      = $0701 ;
    GL_LINE_TOKEN                       = $0702 ;
    GL_POLYGON_TOKEN                    = $0703 ;
    GL_BITMAP_TOKEN                     = $0704 ;
    GL_DRAW_PIXEL_TOKEN                 = $0705 ;
    GL_COPY_PIXEL_TOKEN                 = $0706 ;
    GL_LINE_RESET_TOKEN                 = $0707 ;

{-- FogMode ----------------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_LINEAR
    GL_EXP                              = $0800 ;
    GL_EXP2                             = $0801 ;
{$ENDIF}

{-- FogParameter -----------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_FOG_COLOR
    // GL_FOG_DENSITY
    // GL_FOG_END
    // GL_FOG_INDEX
    // GL_FOG_MODE
    // GL_FOG_START
{$ENDIF}

{-- FrontFaceDirection -----------------------------------------------------}

    GL_CW                               = $0900 ;
    GL_CCW                              = $0901 ;

{-- GetColorTableParameterPNameEXT -----------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_COLOR_TABLE_FORMAT_EXT
    // GL_COLOR_TABLE_WIDTH_EXT
    // GL_COLOR_TABLE_RED_SIZE_EXT
    // GL_COLOR_TABLE_GREEN_SIZE_EXT
    // GL_COLOR_TABLE_BLUE_SIZE_EXT
    // GL_COLOR_TABLE_ALPHA_SIZE_EXT
    // GL_COLOR_TABLE_LUMINANCE_SIZE_EXT
    // GL_COLOR_TABLE_INTENSITY_SIZE_EXT
{$ENDIF}

{-- GetMapQuery ------------------------------------------------------------}

    GL_COEFF                            = $0A00 ;
    GL_ORDER                            = $0A01 ;
    GL_DOMAIN                           = $0A02 ;

{-- GetPixelMap ------------------------------------------------------------}

    GL_PIXEL_MAP_I_TO_I                 = $0C70 ;
    GL_PIXEL_MAP_S_TO_S                 = $0C71 ;
    GL_PIXEL_MAP_I_TO_R                 = $0C72 ;
    GL_PIXEL_MAP_I_TO_G                 = $0C73 ;
    GL_PIXEL_MAP_I_TO_B                 = $0C74 ;
    GL_PIXEL_MAP_I_TO_A                 = $0C75 ;
    GL_PIXEL_MAP_R_TO_R                 = $0C76 ;
    GL_PIXEL_MAP_G_TO_G                 = $0C77 ;
    GL_PIXEL_MAP_B_TO_B                 = $0C78 ;
    GL_PIXEL_MAP_A_TO_A                 = $0C79 ;

{-- GetPointervPName -------------------------------------------------------}

    GL_VERTEX_ARRAY_POINTER             = $808E ;
    GL_NORMAL_ARRAY_POINTER             = $808F ;
    GL_COLOR_ARRAY_POINTER              = $8090 ;
    GL_INDEX_ARRAY_POINTER              = $8091 ;
    GL_TEXTURE_COORD_ARRAY_POINTER      = $8092 ;
    GL_EDGE_FLAG_ARRAY_POINTER          = $8093 ;

{-- GetPName ---------------------------------------------------------------}

    GL_CURRENT_COLOR                    = $0B00 ;
    GL_CURRENT_INDEX                    = $0B01 ;
    GL_CURRENT_NORMAL                   = $0B02 ;
    GL_CURRENT_TEXTURE_COORDS           = $0B03 ;
    GL_CURRENT_RASTER_COLOR             = $0B04 ;
    GL_CURRENT_RASTER_INDEX             = $0B05 ;
    GL_CURRENT_RASTER_TEXTURE_COORDS    = $0B06 ;
    GL_CURRENT_RASTER_POSITION          = $0B07 ;
    GL_CURRENT_RASTER_POSITION_VALID    = $0B08 ;
    GL_CURRENT_RASTER_DISTANCE          = $0B09 ;
    GL_POINT_SMOOTH                     = $0B10 ;
    GL_POINT_SIZE                       = $0B11 ;
    GL_POINT_SIZE_RANGE                 = $0B12 ;
    GL_POINT_SIZE_GRANULARITY           = $0B13 ;
    GL_LINE_SMOOTH                      = $0B20 ;
    GL_LINE_WIDTH                       = $0B21 ;
    GL_LINE_WIDTH_RANGE                 = $0B22 ;
    GL_LINE_WIDTH_GRANULARITY           = $0B23 ;
    GL_LINE_STIPPLE                     = $0B24 ;
    GL_LINE_STIPPLE_PATTERN             = $0B25 ;
    GL_LINE_STIPPLE_REPEAT              = $0B26 ;
    GL_LIST_MODE                        = $0B30 ;
    GL_MAX_LIST_NESTING                 = $0B31 ;
    GL_LIST_BASE                        = $0B32 ;
    GL_LIST_INDEX                       = $0B33 ;
    GL_POLYGON_MODE                     = $0B40 ;
    GL_POLYGON_SMOOTH                   = $0B41 ;
    GL_POLYGON_STIPPLE                  = $0B42 ;
    GL_EDGE_FLAG                        = $0B43 ;
    GL_CULL_FACE                        = $0B44 ;
    GL_CULL_FACE_MODE                   = $0B45 ;
    GL_FRONT_FACE                       = $0B46 ;
    GL_LIGHTING                         = $0B50 ;
    GL_LIGHT_MODEL_LOCAL_VIEWER         = $0B51 ;
    GL_LIGHT_MODEL_TWO_SIDE             = $0B52 ;
    GL_LIGHT_MODEL_AMBIENT              = $0B53 ;
    GL_SHADE_MODEL                      = $0B54 ;
    GL_COLOR_MATERIAL_FACE              = $0B55 ;
    GL_COLOR_MATERIAL_PARAMETER         = $0B56 ;
    GL_COLOR_MATERIAL                   = $0B57 ;
    GL_FOG                              = $0B60 ;
    GL_FOG_INDEX                        = $0B61 ;
    GL_FOG_DENSITY                      = $0B62 ;
    GL_FOG_START                        = $0B63 ;
    GL_FOG_END                          = $0B64 ;
    GL_FOG_MODE                         = $0B65 ;
    GL_FOG_COLOR                        = $0B66 ;
    GL_DEPTH_RANGE                      = $0B70 ;
    GL_DEPTH_TEST                       = $0B71 ;
    GL_DEPTH_WRITEMASK                  = $0B72 ;
    GL_DEPTH_CLEAR_VALUE                = $0B73 ;
    GL_DEPTH_FUNC                       = $0B74 ;
    GL_ACCUM_CLEAR_VALUE                = $0B80 ;
    GL_STENCIL_TEST                     = $0B90 ;
    GL_STENCIL_CLEAR_VALUE              = $0B91 ;
    GL_STENCIL_FUNC                     = $0B92 ;
    GL_STENCIL_VALUE_MASK               = $0B93 ;
    GL_STENCIL_FAIL                     = $0B94 ;
    GL_STENCIL_PASS_DEPTH_FAIL          = $0B95 ;
    GL_STENCIL_PASS_DEPTH_PASS          = $0B96 ;
    GL_STENCIL_REF                      = $0B97 ;
    GL_STENCIL_WRITEMASK                = $0B98 ;
    GL_MATRIX_MODE                      = $0BA0 ;
    GL_NORMALIZE                        = $0BA1 ;
    GL_VIEWPORT                         = $0BA2 ;
    GL_MODELVIEW_STACK_DEPTH            = $0BA3 ;
    GL_PROJECTION_STACK_DEPTH           = $0BA4 ;
    GL_TEXTURE_STACK_DEPTH              = $0BA5 ;
    GL_MODELVIEW_MATRIX                 = $0BA6 ;
    GL_PROJECTION_MATRIX                = $0BA7 ;
    GL_TEXTURE_MATRIX                   = $0BA8 ;
    GL_ATTRIB_STACK_DEPTH               = $0BB0 ;
    GL_CLIENT_ATTRIB_STACK_DEPTH        = $0BB1 ;
    GL_ALPHA_TEST                       = $0BC0 ;
    GL_ALPHA_TEST_FUNC                  = $0BC1 ;
    GL_ALPHA_TEST_REF                   = $0BC2 ;
#endif
    GL_DITHER                           = $0BD0 ;
#ifdef FULLFEATURES
    GL_BLEND_DST                        = $0BE0 ;
    GL_BLEND_SRC                        = $0BE1 ;
    GL_BLEND                            = $0BE2 ;
    GL_LOGIC_OP_MODE                    = $0BF0 ;
    GL_INDEX_LOGIC_OP                   = $0BF1 ;
    GL_LOGIC_OP                         = GL_INDEX_LOGIC_OP ;
    GL_COLOR_LOGIC_OP                   = $0BF2 ;
    GL_AUX_BUFFERS                      = $0C00 ;
    GL_DRAW_BUFFER                      = $0C01 ;
    GL_READ_BUFFER                      = $0C02 ;
    GL_SCISSOR_BOX                      = $0C10 ;
    GL_SCISSOR_TEST                     = $0C11 ;
    GL_INDEX_CLEAR_VALUE                = $0C20 ;
    GL_INDEX_WRITEMASK                  = $0C21 ;
    GL_COLOR_CLEAR_VALUE                = $0C22 ;
    GL_COLOR_WRITEMASK                  = $0C23 ;
    GL_INDEX_MODE                       = $0C30 ;
    GL_RGBA_MODE                        = $0C31 ;
    GL_DOUBLEBUFFER                     = $0C32 ;
    GL_STEREO                           = $0C33 ;
    GL_RENDER_MODE                      = $0C40 ;
    GL_PERSPECTIVE_CORRECTION_HINT      = $0C50 ;
    GL_POINT_SMOOTH_HINT                = $0C51 ;
    GL_LINE_SMOOTH_HINT                 = $0C52 ;
    GL_POLYGON_SMOOTH_HINT              = $0C53 ;
    GL_FOG_HINT                         = $0C54 ;
    GL_TEXTURE_GEN_S                    = $0C60 ;
    GL_TEXTURE_GEN_T                    = $0C61 ;
    GL_TEXTURE_GEN_R                    = $0C62 ;
    GL_TEXTURE_GEN_Q                    = $0C63 ;
    GL_PIXEL_MAP_I_TO_I_SIZE            = $0CB0 ;
    GL_PIXEL_MAP_S_TO_S_SIZE            = $0CB1 ;
    GL_PIXEL_MAP_I_TO_R_SIZE            = $0CB2 ;
    GL_PIXEL_MAP_I_TO_G_SIZE            = $0CB3 ;
    GL_PIXEL_MAP_I_TO_B_SIZE            = $0CB4 ;
    GL_PIXEL_MAP_I_TO_A_SIZE            = $0CB5 ;
    GL_PIXEL_MAP_R_TO_R_SIZE            = $0CB6 ;
    GL_PIXEL_MAP_G_TO_G_SIZE            = $0CB7 ;
    GL_PIXEL_MAP_B_TO_B_SIZE            = $0CB8 ;
    GL_PIXEL_MAP_A_TO_A_SIZE            = $0CB9 ;
    GL_UNPACK_SWAP_BYTES                = $0CF0 ;
    GL_UNPACK_LSB_FIRST                 = $0CF1 ;
    GL_UNPACK_ROW_LENGTH                = $0CF2 ;
    GL_UNPACK_SKIP_ROWS                 = $0CF3 ;
    GL_UNPACK_SKIP_PIXELS               = $0CF4 ;
    GL_UNPACK_ALIGNMENT                 = $0CF5 ;
    GL_PACK_SWAP_BYTES                  = $0D00 ;
    GL_PACK_LSB_FIRST                   = $0D01 ;
    GL_PACK_ROW_LENGTH                  = $0D02 ;
    GL_PACK_SKIP_ROWS                   = $0D03 ;
    GL_PACK_SKIP_PIXELS                 = $0D04 ;
    GL_PACK_ALIGNMENT                   = $0D05 ;
    GL_MAP_COLOR                        = $0D10 ;
    GL_MAP_STENCIL                      = $0D11 ;
    GL_INDEX_SHIFT                      = $0D12 ;
    GL_INDEX_OFFSET                     = $0D13 ;
    GL_RED_SCALE                        = $0D14 ;
    GL_RED_BIAS                         = $0D15 ;
    GL_ZOOM_X                           = $0D16 ;
    GL_ZOOM_Y                           = $0D17 ;
    GL_GREEN_SCALE                      = $0D18 ;
    GL_GREEN_BIAS                       = $0D19 ;
    GL_BLUE_SCALE                       = $0D1A ;
    GL_BLUE_BIAS                        = $0D1B ;
    GL_ALPHA_SCALE                      = $0D1C ;
    GL_ALPHA_BIAS                       = $0D1D ;
    GL_DEPTH_SCALE                      = $0D1E ;
    GL_DEPTH_BIAS                       = $0D1F ;
    GL_MAX_EVAL_ORDER                   = $0D30 ;
    GL_MAX_LIGHTS                       = $0D31 ;
    GL_MAX_CLIP_PLANES                  = $0D32 ;
    GL_MAX_TEXTURE_SIZE                 = $0D33 ;
    GL_MAX_PIXEL_MAP_TABLE              = $0D34 ;
    GL_MAX_ATTRIB_STACK_DEPTH           = $0D35 ;
    GL_MAX_MODELVIEW_STACK_DEPTH        = $0D36 ;
    GL_MAX_NAME_STACK_DEPTH             = $0D37 ;
    GL_MAX_PROJECTION_STACK_DEPTH       = $0D38 ;
    GL_MAX_TEXTURE_STACK_DEPTH          = $0D39 ;
    GL_MAX_VIEWPORT_DIMS                = $0D3A ;
    GL_MAX_CLIENT_ATTRIB_STACK_DEPTH    = $0D3B ;
    GL_SUBPIXEL_BITS                    = $0D50 ;
    GL_INDEX_BITS                       = $0D51 ;
    GL_RED_BITS                         = $0D52 ;
    GL_GREEN_BITS                       = $0D53 ;
    GL_BLUE_BITS                        = $0D54 ;
    GL_ALPHA_BITS                       = $0D55 ;
    GL_DEPTH_BITS                       = $0D56 ;
    GL_STENCIL_BITS                     = $0D57 ;
    GL_ACCUM_RED_BITS                   = $0D58 ;
    GL_ACCUM_GREEN_BITS                 = $0D59 ;
    GL_ACCUM_BLUE_BITS                  = $0D5A ;
    GL_ACCUM_ALPHA_BITS                 = $0D5B ;
    GL_NAME_STACK_DEPTH                 = $0D70 ;
    GL_AUTO_NORMAL                      = $0D80 ;
    GL_MAP1_COLOR_4                     = $0D90 ;
    GL_MAP1_INDEX                       = $0D91 ;
    GL_MAP1_NORMAL                      = $0D92 ;
    GL_MAP1_TEXTURE_COORD_1             = $0D93 ;
    GL_MAP1_TEXTURE_COORD_2             = $0D94 ;
    GL_MAP1_TEXTURE_COORD_3             = $0D95 ;
    GL_MAP1_TEXTURE_COORD_4             = $0D96 ;
    GL_MAP1_VERTEX_3                    = $0D97 ;
    GL_MAP1_VERTEX_4                    = $0D98 ;
    GL_MAP2_COLOR_4                     = $0DB0 ;
    GL_MAP2_INDEX                       = $0DB1 ;
    GL_MAP2_NORMAL                      = $0DB2 ;
    GL_MAP2_TEXTURE_COORD_1             = $0DB3 ;
    GL_MAP2_TEXTURE_COORD_2             = $0DB4 ;
    GL_MAP2_TEXTURE_COORD_3             = $0DB5 ;
    GL_MAP2_TEXTURE_COORD_4             = $0DB6 ;
    GL_MAP2_VERTEX_3                    = $0DB7 ;
    GL_MAP2_VERTEX_4                    = $0DB8 ;
    GL_MAP1_GRID_DOMAIN                 = $0DD0 ;
    GL_MAP1_GRID_SEGMENTS               = $0DD1 ;
    GL_MAP2_GRID_DOMAIN                 = $0DD2 ;
    GL_MAP2_GRID_SEGMENTS               = $0DD3 ;
    GL_TEXTURE_1D                       = $0DE0 ;
    GL_TEXTURE_2D                       = $0DE1 ;
    GL_FEEDBACK_BUFFER_POINTER          = $0DF0 ;
    GL_FEEDBACK_BUFFER_SIZE             = $0DF1 ;
    GL_FEEDBACK_BUFFER_TYPE             = $0DF2 ;
    GL_SELECTION_BUFFER_POINTER         = $0DF3 ;
    GL_SELECTION_BUFFER_SIZE            = $0DF4 ;
    GL_POLYGON_OFFSET_UNITS             = $2A00 ;
    GL_POLYGON_OFFSET_POINT             = $2A01 ;
    GL_POLYGON_OFFSET_LINE              = $2A02 ;
    GL_POLYGON_OFFSET_FILL              = $8037 ;
    GL_POLYGON_OFFSET_FACTOR            = $8038 ;
    GL_TEXTURE_BINDING_1D               = $8068 ;
    GL_TEXTURE_BINDING_2D               = $8069 ;
    GL_VERTEX_ARRAY                     = $8074 ;
    GL_NORMAL_ARRAY                     = $8075 ;
    GL_COLOR_ARRAY                      = $8076 ;
    GL_INDEX_ARRAY                      = $8077 ;
    GL_TEXTURE_COORD_ARRAY              = $8078 ;
    GL_EDGE_FLAG_ARRAY                  = $8079 ;
    GL_VERTEX_ARRAY_SIZE                = $807A ;
    GL_VERTEX_ARRAY_TYPE                = $807B ;
    GL_VERTEX_ARRAY_STRIDE              = $807C ;
    GL_NORMAL_ARRAY_TYPE                = $807E ;
    GL_NORMAL_ARRAY_STRIDE              = $807F ;
    GL_COLOR_ARRAY_SIZE                 = $8081 ;
    GL_COLOR_ARRAY_TYPE                 = $8082 ;
    GL_COLOR_ARRAY_STRIDE               = $8083 ;
    GL_INDEX_ARRAY_TYPE                 = $8085 ;
    GL_INDEX_ARRAY_STRIDE               = $8086 ;
    GL_TEXTURE_COORD_ARRAY_SIZE         = $8088 ;
    GL_TEXTURE_COORD_ARRAY_TYPE         = $8089 ;
    GL_TEXTURE_COORD_ARRAY_STRIDE       = $808A ;
    GL_EDGE_FLAG_ARRAY_STRIDE           = $808C ;
{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_VERTEX_ARRAY_COUNT_EXT
    // GL_NORMAL_ARRAY_COUNT_EXT
    // GL_COLOR_ARRAY_COUNT_EXT
    // GL_INDEX_ARRAY_COUNT_EXT
    // GL_TEXTURE_COORD_ARRAY_COUNT_EXT
    // GL_EDGE_FLAG_ARRAY_COUNT_EXT
    // GL_ARRAY_ELEMENT_LOCK_COUNT_SGI
    // GL_ARRAY_ELEMENT_LOCK_FIRST_SGI
    // GL_INDEX_TEST_SGI
    // GL_INDEX_TEST_FUNC_SGI
    // GL_INDEX_TEST_REF_SGI
    // GL_INDEX_MATERIAL_SGI
    // GL_INDEX_MATERIAL_FACE_SGI
    // GL_INDEX_MATERIAL_PARAMETER_SGI
{$ENDIF}

{-- GetTextureParameter ----------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_TEXTURE_MAG_FILTER
    // GL_TEXTURE_MIN_FILTER
    // GL_TEXTURE_WRAP_S
    // GL_TEXTURE_WRAP_T
{$ENDIF}
    GL_TEXTURE_WIDTH                    = $1000 ;
    GL_TEXTURE_HEIGHT                   = $1001 ;
    GL_TEXTURE_INTERNAL_FORMAT          = $1003 ;
    GL_TEXTURE_COMPONENTS               = GL_TEXTURE_INTERNAL_FORMAT ;
    GL_TEXTURE_BORDER_COLOR             = $1004 ;
    GL_TEXTURE_BORDER                   = $1005 ;
    GL_TEXTURE_RED_SIZE                 = $805C ;
    GL_TEXTURE_GREEN_SIZE               = $805D ;
    GL_TEXTURE_BLUE_SIZE                = $805E ;
    GL_TEXTURE_ALPHA_SIZE               = $805F ;
    GL_TEXTURE_LUMINANCE_SIZE           = $8060 ;
    GL_TEXTURE_INTENSITY_SIZE           = $8061 ;
    GL_TEXTURE_PRIORITY                 = $8066 ;
    GL_TEXTURE_RESIDENT                 = $8067 ;

{-- HintMode ---------------------------------------------------------------}

    GL_DONT_CARE                        = $1100 ;
    GL_FASTEST                          = $1101 ;
    GL_NICEST                           = $1102 ;

{-- HintTarget -------------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_PERSPECTIVE_CORRECTION_HINT
    // GL_POINT_SMOOTH_HINT
    // GL_LINE_SMOOTH_HINT
    // GL_POLYGON_SMOOTH_HINT
    // GL_FOG_HINT
{$ENDIF}

{-- IndexMaterialParameterSGI ----------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_INDEX_OFFSET
{$ENDIF}

{-- IndexPointerType -------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_SHORT
    // GL_INT
    // GL_FLOAT
    // GL_DOUBLE
{$ENDIF}

{-- IndexFunctionSGI -------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_NEVER
    // GL_LESS
    // GL_EQUAL
    // GL_LEQUAL
    // GL_GREATER
    // GL_NOTEQUAL
    // GL_GEQUAL
    // GL_ALWAYS
{$ENDIF}

{-- LightModelParameter ----------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_LIGHT_MODEL_AMBIENT
    // GL_LIGHT_MODEL_LOCAL_VIEWER
    // GL_LIGHT_MODEL_TWO_SIDE
{$ENDIF}

{-- LightParameter ---------------------------------------------------------}

    GL_AMBIENT                          = $1200 ;
    GL_DIFFUSE                          = $1201 ;
    GL_SPECULAR                         = $1202 ;
    GL_POSITION                         = $1203 ;
    GL_SPOT_DIRECTION                   = $1204 ;
    GL_SPOT_EXPONENT                    = $1205 ;
    GL_SPOT_CUTOFF                      = $1206 ;
    GL_CONSTANT_ATTENUATION             = $1207 ;
    GL_LINEAR_ATTENUATION               = $1208 ;
    GL_QUADRATIC_ATTENUATION            = $1209 ;
#endif

{-- ListMode ---------------------------------------------------------------}

    GL_COMPILE                          = $1300 ;
    GL_COMPILE_AND_EXECUTE              = $1301 ;

{-- DataType ---------------------------------------------------------------}

    GL_BYTE                             = $1400 ;
    GL_UNSIGNED_BYTE                    = $1401 ;
    GL_SHORT                            = $1402 ;
    GL_UNSIGNED_SHORT                   = $1403 ;
    GL_INT                              = $1404 ;
    GL_UNSIGNED_INT                     = $1405 ;
    GL_FLOAT                            = $1406 ;
    GL_2_BYTES                          = $1407 ;
    GL_3_BYTES                          = $1408 ;
    GL_4_BYTES                          = $1409 ;
    GL_DOUBLE                           = $140A ;
    GL_DOUBLE_EXT                       = $140A ;

#ifdef FULLFEATURES
{-- ListNameType -----------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_BYTE
    // GL_UNSIGNED_BYTE
    // GL_SHORT
    // GL_UNSIGNED_SHORT
    // GL_INT
    // GL_UNSIGNED_INT
    // GL_FLOAT
    // GL_2_BYTES
    // GL_3_BYTES
    // GL_4_BYTES
{$ENDIF}

{-- LogicOp ----------------------------------------------------------------}

    GL_CLEAR                            = $1500 ;
    GL_AND                              = $1501 ;
    GL_AND_REVERSE                      = $1502 ;
    GL_COPY                             = $1503 ;
    GL_AND_INVERTED                     = $1504 ;
    GL_NOOP                             = $1505 ;
    GL_XOR                              = $1506 ;
    GL_OR                               = $1507 ;
    GL_NOR                              = $1508 ;
    GL_EQUIV                            = $1509 ;
    GL_INVERT                           = $150A ;
    GL_OR_REVERSE                       = $150B ;
    GL_COPY_INVERTED                    = $150C ;
    GL_OR_INVERTED                      = $150D ;
    GL_NAND                             = $150E ;
    GL_SET                              = $150F ;

{-- MapTarget --------------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_MAP1_COLOR_4
    // GL_MAP1_INDEX
    // GL_MAP1_NORMAL
    // GL_MAP1_TEXTURE_COORD_1
    // GL_MAP1_TEXTURE_COORD_2
    // GL_MAP1_TEXTURE_COORD_3
    // GL_MAP1_TEXTURE_COORD_4
    // GL_MAP1_VERTEX_3
    // GL_MAP1_VERTEX_4
    // GL_MAP2_COLOR_4
    // GL_MAP2_INDEX
    // GL_MAP2_NORMAL
    // GL_MAP2_TEXTURE_COORD_1
    // GL_MAP2_TEXTURE_COORD_2
    // GL_MAP2_TEXTURE_COORD_3
    // GL_MAP2_TEXTURE_COORD_4
    // GL_MAP2_VERTEX_3
    // GL_MAP2_VERTEX_4
{$ENDIF}

{-- MaterialFace -----------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_FRONT
    // GL_BACK
    // GL_FRONT_AND_BACK
{$ENDIF}

{-- MaterialParameter ------------------------------------------------------}

    GL_EMISSION                         = $1600 ;
    GL_SHININESS                        = $1601 ;
    GL_AMBIENT_AND_DIFFUSE              = $1602 ;
    GL_COLOR_INDEXES                    = $1603 ;
{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_AMBIENT
    // GL_DIFFUSE
    // GL_SPECULAR
{$ENDIF}
#endif

{-- MatrixMode -------------------------------------------------------------}

    GL_MODELVIEW                        = $1700 ;
    GL_PROJECTION                       = $1701 ;
    GL_TEXTURE                          = $1702 ;

{-- MeshMode1 --------------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_POINT
    // GL_LINE
{$ENDIF}

{-- MeshMode2 --------------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_POINT
    // GL_LINE
    // GL_FILL
{$ENDIF}

{-- NormalPointerType ------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_BYTE
    // GL_SHORT
    // GL_INT
    // GL_FLOAT
    // GL_DOUBLE
{$ENDIF}

{-- PixelCopyType ----------------------------------------------------------}

    GL_COLOR                            = $1800 ;
    GL_DEPTH                            = $1801 ;
    GL_STENCIL                          = $1802 ;

{-- PixelFormat ------------------------------------------------------------}

    GL_COLOR_INDEX                      = $1900 ;
    GL_STENCIL_INDEX                    = $1901 ;
    GL_DEPTH_COMPONENT                  = $1902 ;
    GL_RED                              = $1903 ;
    GL_GREEN                            = $1904 ;
    GL_BLUE                             = $1905 ;
    GL_ALPHA                            = $1906 ;
    GL_RGB                              = $1907 ;
    GL_RGBA                             = $1908 ;
    GL_LUMINANCE                        = $1909 ;
    GL_LUMINANCE_ALPHA                  = $190A ;
{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_ABGR_EXT
    // GL_BGR_EXT
    // GL_BGRA_EXT
{$ENDIF}


#ifdef FULLFEATURES
{-- PixelMap ---------------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_PIXEL_MAP_I_TO_I
    // GL_PIXEL_MAP_S_TO_S
    // GL_PIXEL_MAP_I_TO_R
    // GL_PIXEL_MAP_I_TO_G
    // GL_PIXEL_MAP_I_TO_B
    // GL_PIXEL_MAP_I_TO_A
    // GL_PIXEL_MAP_R_TO_R
    // GL_PIXEL_MAP_G_TO_G
    // GL_PIXEL_MAP_B_TO_B
    // GL_PIXEL_MAP_A_TO_A
{$ENDIF}

{-- PixelStoreParameter ----------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_UNPACK_SWAP_BYTES
    // GL_UNPACK_LSB_FIRST
    // GL_UNPACK_ROW_LENGTH
    // GL_UNPACK_SKIP_ROWS
    // GL_UNPACK_SKIP_PIXELS
    // GL_UNPACK_ALIGNMENT
    // GL_PACK_SWAP_BYTES
    // GL_PACK_LSB_FIRST
    // GL_PACK_ROW_LENGTH
    // GL_PACK_SKIP_ROWS
    // GL_PACK_SKIP_PIXELS
    // GL_PACK_ALIGNMENT
{$ENDIF}

{-- PixelTransferParameter -------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_MAP_COLOR
    // GL_MAP_STENCIL
    // GL_INDEX_SHIFT
    // GL_INDEX_OFFSET
    // GL_RED_SCALE
    // GL_RED_BIAS
    // GL_GREEN_SCALE
    // GL_GREEN_BIAS
    // GL_BLUE_SCALE
    // GL_BLUE_BIAS
    // GL_ALPHA_SCALE
    // GL_ALPHA_BIAS
    // GL_DEPTH_SCALE
    // GL_DEPTH_BIAS
{$ENDIF}

{-- PixelType --------------------------------------------------------------}

    GL_BITMAP                           = $1A00 ;
{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_BYTE
    // GL_UNSIGNED_BYTE
    // GL_SHORT
    // GL_UNSIGNED_SHORT
    // GL_INT
    // GL_UNSIGNED_INT
    // GL_FLOAT
    // GL_UNSIGNED_BYTE_3_3_2_EXT
    // GL_UNSIGNED_SHORT_4_4_4_4_EXT
    // GL_UNSIGNED_SHORT_5_5_5_1_EXT
    // GL_UNSIGNED_INT_8_8_8_8_EXT
    // GL_UNSIGNED_INT_10_10_10_2_EXT
{$ENDIF}

{-- PolygonMode ------------------------------------------------------------}

    GL_POINT                            = $1B00 ;
    GL_LINE                             = $1B01 ;
    GL_FILL                             = $1B02 ;

{-- ReadBufferMode ---------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_FRONT_LEFT
    // GL_FRONT_RIGHT
    // GL_BACK_LEFT
    // GL_BACK_RIGHT
    // GL_FRONT
    // GL_BACK
    // GL_LEFT
    // GL_RIGHT
    // GL_AUX0
    // GL_AUX1
    // GL_AUX2
    // GL_AUX3
{$ENDIF}
#endif
{-- RenderingMode ----------------------------------------------------------}

    GL_RENDER                           = $1C00 ;
    GL_FEEDBACK                         = $1C01 ;
    GL_SELECT                           = $1C02 ;

{-- ShadingModel -----------------------------------------------------------}

    GL_FLAT                             = $1D00 ;
    GL_SMOOTH                           = $1D01 ;

#ifdef FULLFEATURES
{-- StencilFunction --------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_NEVER
    // GL_LESS
    // GL_EQUAL
    // GL_LEQUAL
    // GL_GREATER
    // GL_NOTEQUAL
    // GL_GEQUAL
    // GL_ALWAYS
{$ENDIF}

{-- StencilOp --------------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_ZERO
{$ENDIF}
   GL_KEEP                             = $1E00 ;
    GL_REPLACE                          = $1E01 ;
    GL_INCR                             = $1E02 ;
    GL_DECR                             = $1E03 ;
{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_INVERT
{$ENDIF}

{-- StringName -------------------------------------------------------------}

    GL_VENDOR                           = $1F00 ;
    GL_RENDERER                         = $1F01 ;
    GL_VERSION                          = $1F02 ;
    GL_EXTENSIONS                       = $1F03 ;

{-- TexCoordPointerType ----------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_SHORT
    // GL_INT
    // GL_FLOAT
    // GL_DOUBLE
{$ENDIF}

{-- TextureCoordName -------------------------------------------------------}

    GL_S                                = $2000 ;
    GL_T                                = $2001 ;
    GL_R                                = $2002 ;
    GL_Q                                = $2003 ;

{-- TextureEnvMode ---------------------------------------------------------}

    GL_MODULATE                         = $2100 ;
    GL_DECAL                            = $2101 ;
{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_BLEND
    // GL_REPLACE
    // GL_ADD
{$ENDIF}

{-- TextureEnvParameter ----------------------------------------------------}

    GL_TEXTURE_ENV_MODE                 = $2200 ;
    GL_TEXTURE_ENV_COLOR                = $2201 ;

{-- TextureEnvTarget -------------------------------------------------------}

    GL_TEXTURE_ENV                      = $2300 ;

{-- TextureGenMode ---------------------------------------------------------}

    GL_EYE_LINEAR                       = $2400 ;
    GL_OBJECT_LINEAR                    = $2401 ;
    GL_SPHERE_MAP                       = $2402 ;

{-- TextureGenParameter ----------------------------------------------------}

    GL_TEXTURE_GEN_MODE                 = $2500 ;
    GL_OBJECT_PLANE                     = $2501 ;
    GL_EYE_PLANE                        = $2502 ;

{-- TextureMagFilter -------------------------------------------------------}

    GL_NEAREST                          = $2600 ;
    GL_LINEAR                           = $2601 ;

{-- TextureMinFilter -------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_NEAREST
    // GL_LINEAR
{$ENDIF}
    GL_NEAREST_MIPMAP_NEAREST           = $2700 ;
    GL_LINEAR_MIPMAP_NEAREST            = $2701 ;
    GL_NEAREST_MIPMAP_LINEAR            = $2702 ;
    GL_LINEAR_MIPMAP_LINEAR             = $2703 ;

{-- TextureParameterName ---------------------------------------------------}

    GL_TEXTURE_MAG_FILTER               = $2800 ;
    GL_TEXTURE_MIN_FILTER               = $2801 ;
    GL_TEXTURE_WRAP_S                   = $2802 ;
    GL_TEXTURE_WRAP_T                   = $2803 ;
{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_TEXTURE_BORDER_COLOR
    // GL_TEXTURE_PRIORITY
{$ENDIF}

{-- TextureTarget ----------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_TEXTURE_1D
    // GL_TEXTURE_2D
{$ENDIF}
    GL_PROXY_TEXTURE_1D                 = $8063 ;
    GL_PROXY_TEXTURE_2D                 = $8064 ;

{-- TextureWrapMode --------------------------------------------------------}

    GL_CLAMP                            = $2900 ;
    GL_REPEAT                           = $2901 ;

{-- PixelInternalFormat ----------------------------------------------------}

    GL_R3_G3_B2                         = $2A10 ;
    GL_ALPHA4                           = $803B ;
    GL_ALPHA8                           = $803C ;
    GL_ALPHA12                          = $803D ;
    GL_ALPHA16                          = $803E ;
    GL_LUMINANCE4                       = $803F ;
    GL_LUMINANCE8                       = $8040 ;
    GL_LUMINANCE12                      = $8041 ;
    GL_LUMINANCE16                      = $8042 ;
    GL_LUMINANCE4_ALPHA4                = $8043 ;
    GL_LUMINANCE6_ALPHA2                = $8044 ;
    GL_LUMINANCE8_ALPHA8                = $8045 ;
    GL_LUMINANCE12_ALPHA4               = $8046 ;
    GL_LUMINANCE12_ALPHA12              = $8047 ;
    GL_LUMINANCE16_ALPHA16              = $8048 ;
    GL_INTENSITY                        = $8049 ;
    GL_INTENSITY4                       = $804A ;
    GL_INTENSITY8                       = $804B ;
    GL_INTENSITY12                      = $804C ;
    GL_INTENSITY16                      = $804D ;
    GL_RGB4                             = $804F ;
    GL_RGB5                             = $8050 ;
    GL_RGB8                             = $8051 ;
    GL_RGB10                            = $8052 ;
    GL_RGB12                            = $8053 ;
    GL_RGB16                            = $8054 ;
    GL_RGBA2                            = $8055 ;
    GL_RGBA4                            = $8056 ;
    GL_RGB5_A1                          = $8057 ;
    GL_RGBA8                            = $8058 ;
    GL_RGB10_A2                         = $8059 ;
    GL_RGBA12                           = $805A ;
    GL_RGBA16                           = $805B ;
{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_COLOR_INDEX1_EXT
    // GL_COLOR_INDEX2_EXT
    // GL_COLOR_INDEX4_EXT
    // GL_COLOR_INDEX8_EXT
    // GL_COLOR_INDEX12_EXT
    // GL_COLOR_INDEX16_EXT
{$ENDIF}

{-- InterleavedArrayFormat -------------------------------------------------}

    GL_V2F                              = $2A20 ;
    GL_V3F                              = $2A21 ;
    GL_C4UB_V2F                         = $2A22 ;
    GL_C4UB_V3F                         = $2A23 ;
    GL_C3F_V3F                          = $2A24 ;
    GL_N3F_V3F                          = $2A25 ;
    GL_C4F_N3F_V3F                      = $2A26 ;
    GL_T2F_V3F                          = $2A27 ;
    GL_T4F_V4F                          = $2A28 ;
    GL_T2F_C4UB_V3F                     = $2A29 ;
    GL_T2F_C3F_V3F                      = $2A2A ;
    GL_T2F_N3F_V3F                      = $2A2B ;
    GL_T2F_C4F_N3F_V3F                  = $2A2C ;
    GL_T4F_C4F_N3F_V4F                  = $2A2D ;
{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_IUI_V2F_SGI
    // GL_IUI_V3F_SGI
    // GL_IUI_N3F_V2F_SGI
    // GL_IUI_N3F_V3F_SGI
    // GL_T2F_IUI_V2F_SGI
    // GL_T2F_IUI_V3F_SGI
    // GL_T2F_IUI_N3F_V2F_SGI
    // GL_T2F_IUI_N3F_V3F_SGI
{$ENDIF}

{-- VertexPointerType ------------------------------------------------------}

{$IFDEF NO_IS_NOT_DEFINED } { GPC DONT KNOW THIS // }
    // GL_SHORT
    // GL_INT
    // GL_FLOAT
    // GL_DOUBLE
{$ENDIF}

{-- ClipPlaneName ----------------------------------------------------------}

    GL_CLIP_PLANE0                      = $3000 ;
    GL_CLIP_PLANE1                      = $3001 ;
    GL_CLIP_PLANE2                      = $3002 ;
    GL_CLIP_PLANE3                      = $3003 ;
    GL_CLIP_PLANE4                      = $3004 ;
    GL_CLIP_PLANE5                      = $3005 ;

{-- LightName --------------------------------------------------------------}

    GL_LIGHT0                           = $4000 ;
    GL_LIGHT1                           = $4001 ;
    GL_LIGHT2                           = $4002 ;
    GL_LIGHT3                           = $4003 ;
    GL_LIGHT4                           = $4004 ;
    GL_LIGHT5                           = $4005 ;
    GL_LIGHT6                           = $4006 ;
    GL_LIGHT7                           = $4007 ;

{-- EXT_abgr ---------------------------------------------------------------}

    GL_ABGR_EXT                         = $8000 ;

{-- EXT_packed_pixels ------------------------------------------------------}

    GL_UNSIGNED_BYTE_3_3_2_EXT          = $8032 ;
    GL_UNSIGNED_SHORT_4_4_4_4_EXT       = $8033 ;
    GL_UNSIGNED_SHORT_5_5_5_1_EXT       = $8034 ;
    GL_UNSIGNED_INT_8_8_8_8_EXT         = $8035 ;
    GL_UNSIGNED_INT_10_10_10_2_EXT      = $8036 ;

{-- EXT_vertex_array -------------------------------------------------------}

    GL_VERTEX_ARRAY_EXT                 = $8074 ;
    GL_NORMAL_ARRAY_EXT                 = $8075 ;
    GL_COLOR_ARRAY_EXT                  = $8076 ;
    GL_INDEX_ARRAY_EXT                  = $8077 ;
    GL_TEXTURE_COORD_ARRAY_EXT          = $8078 ;
    GL_EDGE_FLAG_ARRAY_EXT              = $8079 ;
    GL_VERTEX_ARRAY_SIZE_EXT            = $807A ;
    GL_VERTEX_ARRAY_TYPE_EXT            = $807B ;
    GL_VERTEX_ARRAY_STRIDE_EXT          = $807C ;
    GL_VERTEX_ARRAY_COUNT_EXT           = $807D ;
    GL_NORMAL_ARRAY_TYPE_EXT            = $807E ;
    GL_NORMAL_ARRAY_STRIDE_EXT          = $807F ;
    GL_NORMAL_ARRAY_COUNT_EXT           = $8080 ;
    GL_COLOR_ARRAY_SIZE_EXT             = $8081 ;
    GL_COLOR_ARRAY_TYPE_EXT             = $8082 ;
    GL_COLOR_ARRAY_STRIDE_EXT           = $8083 ;
    GL_COLOR_ARRAY_COUNT_EXT            = $8084 ;
    GL_INDEX_ARRAY_TYPE_EXT             = $8085 ;
    GL_INDEX_ARRAY_STRIDE_EXT           = $8086 ;
    GL_INDEX_ARRAY_COUNT_EXT            = $8087 ;
    GL_TEXTURE_COORD_ARRAY_SIZE_EXT     = $8088 ;
    GL_TEXTURE_COORD_ARRAY_TYPE_EXT     = $8089 ;
    GL_TEXTURE_COORD_ARRAY_STRIDE_EXT   = $808A ;
    GL_TEXTURE_COORD_ARRAY_COUNT_EXT    = $808B ;
    GL_EDGE_FLAG_ARRAY_STRIDE_EXT       = $808C ;
    GL_EDGE_FLAG_ARRAY_COUNT_EXT        = $808D ;
    GL_VERTEX_ARRAY_POINTER_EXT         = $808E ;
    GL_NORMAL_ARRAY_POINTER_EXT         = $808F ;
    GL_COLOR_ARRAY_POINTER_EXT          = $8090 ;
    GL_INDEX_ARRAY_POINTER_EXT          = $8091 ;
    GL_TEXTURE_COORD_ARRAY_POINTER_EXT  = $8092 ;
    GL_EDGE_FLAG_ARRAY_POINTER_EXT      = $8093 ;

{-- EXT_color_table --------------------------------------------------------}

    GL_TABLE_TOO_LARGE_EXT              = $8031 ;
    GL_COLOR_TABLE_FORMAT_EXT           = $80D8 ;
    GL_COLOR_TABLE_WIDTH_EXT            = $80D9 ;
    GL_COLOR_TABLE_RED_SIZE_EXT         = $80DA ;
    GL_COLOR_TABLE_GREEN_SIZE_EXT       = $80DB ;
    GL_COLOR_TABLE_BLUE_SIZE_EXT        = $80DC ;
    GL_COLOR_TABLE_ALPHA_SIZE_EXT       = $80DD ;
    GL_COLOR_TABLE_LUMINANCE_SIZE_EXT   = $80DE ;
    GL_COLOR_TABLE_INTENSITY_SIZE_EXT   = $80DF ;

{-- EXT_bgra ---------------------------------------------------------------}

    GL_BGR_EXT                          = $80E0 ;
    GL_BGRA_EXT                         = $80E1 ;

{-- EXT_paletted_texture ---------------------------------------------------}

    GL_COLOR_INDEX1_EXT                 = $80E2 ;
    GL_COLOR_INDEX2_EXT                 = $80E3 ;
    GL_COLOR_INDEX4_EXT                 = $80E4 ;
    GL_COLOR_INDEX8_EXT                 = $80E5 ;
    GL_COLOR_INDEX12_EXT                = $80E6 ;
    GL_COLOR_INDEX16_EXT                = $80E7 ;

{-- SGI_compiled_vertex_array ----------------------------------------------}

    GL_ARRAY_ELEMENT_LOCK_FIRST_SGI     = $81A8 ;
    GL_ARRAY_ELEMENT_LOCK_COUNT_SGI     = $81A9 ;

{-- SGI_cull_vertex --------------------------------------------------------}

    GL_CULL_VERTEX_SGI                  = $81AA ;
    GL_CULL_VERTEX_EYE_POSITION_SGI     = $81AB ;
    GL_CULL_VERTEX_OBJECT_POSITION_SGI  = $81AC ;

{-- SGI_index_array_formats ------------------------------------------------}

    GL_IUI_V2F_SGI                      = $81AD ;
    GL_IUI_V3F_SGI                      = $81AE ;
    GL_IUI_N3F_V2F_SGI                  = $81AF ;
    GL_IUI_N3F_V3F_SGI                  = $81B0 ;
    GL_T2F_IUI_V2F_SGI                  = $81B1 ;
    GL_T2F_IUI_V3F_SGI                  = $81B2 ;
    GL_T2F_IUI_N3F_V2F_SGI              = $81B3 ;
    GL_T2F_IUI_N3F_V3F_SGI              = $81B4 ;

{-- SGI_index_func ---------------------------------------------------------}

    GL_INDEX_TEST_SGI                   = $81B5 ;
    GL_INDEX_TEST_FUNC_SGI              = $81B6 ;
    GL_INDEX_TEST_REF_SGI               = $81B7 ;

{-- SGI_index_material -----------------------------------------------------}

    GL_INDEX_MATERIAL_SGI               = $81B8 ;
    GL_INDEX_MATERIAL_PARAMETER_SGI     = $81B9 ;
    GL_INDEX_MATERIAL_FACE_SGI          = $81BA ;

{-- Mesa extensions --------------------------------------------------------}

    GL_CONSTANT_COLOR_EXT               = $8001 ;
    GL_ONE_MINUS_CONSTANT_COLOR_EXT     = $8002 ;
    GL_CONSTANT_ALPHA_EXT               = $8003 ;
    GL_ONE_MINUS_CONSTANT_ALPHA_EXT     = $8004 ;
    GL_BLEND_EQUATION_EXT               = $8009 ;
    GL_MIN_EXT                          = $8007 ;
    GL_MAX_EXT                          = $8008 ;
    GL_FUNC_ADD_EXT                     = $8006 ;
    GL_FUNC_SUBTRACT_EXT                = $800A ;
    GL_FUNC_REVERSE_SUBTRACT_EXT        = $800B ;
    GL_BLEND_COLOR_EXT                  = $8005 ;

{-- Polygon offset ext (Mesa) ----------------------------------------------}

    GL_POLYGON_OFFSET_EXT               = $8037 ;
    GL_POLYGON_OFFSET_FACTOR_EXT        = $8038 ;
    GL_POLYGON_OFFSET_BIAS_EXT          = $8039 ;

{-- GL_EXT_texture_object --------------------------------------------------}

    GL_TEXTURE_PRIORITY_EXT             = $8066 ;
    GL_TEXTURE_RESIDENT_EXT             = $8067 ;
    GL_TEXTURE_1D_BINDING_EXT           = $8068 ;
    GL_TEXTURE_2D_BINDING_EXT           = $8069 ;

{-- EXT_texture3D ----------------------------------------------------------}

    GL_PACK_SKIP_IMAGES_EXT             = $806B ;
    GL_PACK_IMAGE_HEIGHT_EXT            = $806C ;
    GL_UNPACK_SKIP_IMAGES_EXT           = $806D ;
    GL_UNPACK_IMAGE_HEIGHT_EXT          = $806E ;
    GL_TEXTURE_3D_EXT                   = $806F ;
    GL_PROXY_TEXTURE_3D_EXT             = $8070 ;
    GL_TEXTURE_DEPTH_EXT                = $8071 ;
    GL_TEXTURE_WRAP_R_EXT               = $8072 ;
    GL_MAX_3D_TEXTURE_SIZE_EXT          = $8073 ;
    GL_TEXTURE_3D_BINDING_EXT           = $806A ;
#endif

{== Functions ==============================================================}

procedure   glAccum(op: GLenum; value: GLfloat); asmname 'glAccum'; WINGDIAPI
procedure   glAlphaFunc(func: GLenum; ref: GLclampf); asmname 'glAlphaFunc'; WINGDIAPI
function    glAreTexturesResident(n: GLsizei; textures: PGLuint; residences: PGLboolean): GLboolean; asmname 'glAreTexturesResident'; WINGDIAPI
procedure   glArrayElement(i: GLint); asmname 'glArrayElement'; WINGDIAPI
procedure   glBegin(mode: GLenum); asmname 'glBegin'; WINGDIAPI
procedure   glBindTexture(target: GLenum; texture: GLuint); asmname 'glBindTexture'; WINGDIAPI
procedure   glBitmap(width: GLsizei; height: GLsizei; xorig: GLfloat; yorig: GLfloat; xmove: GLfloat; ymove: GLfloat; bitmap: PGLubyte); asmname 'glBitmap'; WINGDIAPI
procedure   glBlendFunc(sfactor: GLenum; dfactor: GLenum); asmname 'glBlendFunc'; WINGDIAPI
procedure   glCallList(list: GLuint); asmname 'glCallList'; WINGDIAPI
procedure   glCallLists(n: GLsizei; t_ype: GLenum; lists: PGLvoid); asmname 'glCallLists'; WINGDIAPI
procedure   glClear(mask: GLbitfield); asmname 'glClear'; WINGDIAPI
procedure   glClearAccum(red: GLfloat; green: GLfloat; blue: GLfloat; alpha: GLfloat); asmname 'glClearAccum'; WINGDIAPI
procedure   glClearColor(red: GLclampf; green: GLclampf; blue: GLclampf; alpha: GLclampf); asmname 'glClearColor'; WINGDIAPI
procedure   glClearDepth(depth: GLclampd); asmname 'glClearDepth'; WINGDIAPI
procedure   glClearIndex(c: GLfloat); asmname 'glClearIndex'; WINGDIAPI
procedure   glClearStencil(s: GLint); asmname 'glClearStencil'; WINGDIAPI
procedure   glClipPlane(plane: GLenum; equation: PGLdouble); asmname 'glClipPlane'; WINGDIAPI
procedure   glColor3b(red: GLbyte; green: GLbyte; blue: GLbyte); asmname 'glColor3b'; WINGDIAPI
procedure   glColor3bv(v: PGLbyte); asmname 'glColor3bv'; WINGDIAPI
procedure   glColor3d(red: GLdouble; green: GLdouble; blue: GLdouble); asmname 'glColor3d'; WINGDIAPI
procedure   glColor3dv(v: PGLdouble); asmname 'glColor3dv'; WINGDIAPI
procedure   glColor3f(red: GLfloat; green: GLfloat; blue: GLfloat); asmname 'glColor3f'; WINGDIAPI
procedure   glColor3fv(v: PGLfloat); asmname 'glColor3fv'; WINGDIAPI
procedure   glColor3i(red: GLint; green: GLint; blue: GLint); asmname 'glColor3i'; WINGDIAPI
procedure   glColor3iv(v: PGLint); asmname 'glColor3iv'; WINGDIAPI
procedure   glColor3s(red: GLshort; green: GLshort; blue: GLshort); asmname 'glColor3s'; WINGDIAPI
procedure   glColor3sv(v: PGLshort); asmname 'glColor3sv'; WINGDIAPI
procedure   glColor3ub(red: GLubyte; green: GLubyte; blue: GLubyte); asmname 'glColor3ub'; WINGDIAPI
procedure   glColor3ubv(v: PGLubyte); asmname 'glColor3ubv'; WINGDIAPI
procedure   glColor3ui(red: GLuint; green: GLuint; blue: GLuint); asmname 'glColor3ui'; WINGDIAPI
procedure   glColor3uiv(v: PGLuint); asmname 'glColor3uiv'; WINGDIAPI
procedure   glColor3us(red: GLushort; green: GLushort; blue: GLushort); asmname 'glColor3us'; WINGDIAPI
procedure   glColor3usv(v: PGLushort); asmname 'glColor3usv'; WINGDIAPI
procedure   glColor4b(red: GLbyte; green: GLbyte; blue: GLbyte; alpha: GLbyte); asmname 'glColor4b'; WINGDIAPI
procedure   glColor4bv(v: PGLbyte); asmname 'glColor4bv'; WINGDIAPI
procedure   glColor4d(red: GLdouble; green: GLdouble; blue: GLdouble; alpha: GLdouble); asmname 'glColor4d'; WINGDIAPI
procedure   glColor4dv(v: PGLdouble); asmname 'glColor4dv'; WINGDIAPI
procedure   glColor4f(red: GLfloat; green: GLfloat; blue: GLfloat; alpha: GLfloat); asmname 'glColor4f'; WINGDIAPI
procedure   glColor4fv(v: PGLfloat); asmname 'glColor4fv'; WINGDIAPI
procedure   glColor4i(red: GLint; green: GLint; blue: GLint; alpha: GLint); asmname 'glColor4i'; WINGDIAPI
procedure   glColor4iv(v: PGLint); asmname 'glColor4iv'; WINGDIAPI
procedure   glColor4s(red: GLshort; green: GLshort; blue: GLshort; alpha: GLshort); asmname 'glColor4s'; WINGDIAPI
procedure   glColor4sv(v: PGLshort); asmname 'glColor4sv'; WINGDIAPI
procedure   glColor4ub(red: GLubyte; green: GLubyte; blue: GLubyte; alpha: GLubyte); asmname 'glColor4ub'; WINGDIAPI
procedure   glColor4ubv(v: PGLubyte); asmname 'glColor4ubv'; WINGDIAPI
procedure   glColor4ui(red: GLuint; green: GLuint; blue: GLuint; alpha: GLuint); asmname 'glColor4ui'; WINGDIAPI
procedure   glColor4uiv(v: PGLuint); asmname 'glColor4uiv'; WINGDIAPI
procedure   glColor4us(red: GLushort; green: GLushort; blue: GLushort; alpha: GLushort); asmname 'glColor4us'; WINGDIAPI
procedure   glColor4usv(v: PGLushort); asmname 'glColor4usv'; WINGDIAPI
procedure   glColorMask(red: GLboolean; green: GLboolean; blue: GLboolean; alpha: GLboolean); asmname 'glColorMask'; WINGDIAPI
procedure   glColorMaterial(face: GLenum; mode: GLenum); asmname 'glColorMaterial'; WINGDIAPI
procedure   glColorPointer(size: GLint; t_ype: GLenum; stride: GLsizei; pointer: PGLvoid); asmname 'glColorPointer'; WINGDIAPI
procedure   glCopyPixels(x: GLint; y: GLint; width: GLsizei; height: GLsizei; t_ype: GLenum); asmname 'glCopyPixels'; WINGDIAPI
procedure   glCopyTexImage1D(target: GLenum; level: GLint; internalformat: GLenum; x: GLint; y: GLint; width: GLsizei; border: GLint); asmname 'glCopyTexImage1D'; WINGDIAPI
procedure   glCopyTexImage2D(target: GLenum; level: GLint; internalformat: GLenum; x: GLint; y: GLint; width: GLsizei; height: GLsizei; border: GLint); asmname 'glCopyTexImage2D'; WINGDIAPI
procedure   glCopyTexSubImage1D(target: GLenum; level: GLint; xoffset: GLint; x: GLint; y: GLint; width: GLsizei); asmname 'glCopyTexSubImage1D'; WINGDIAPI
procedure   glCopyTexSubImage2D(target: GLenum; level: GLint; xoffset: GLint; yoffset: GLint; x: GLint; y: GLint; width: GLsizei; height: GLsizei); asmname 'glCopyTexSubImage2D'; WINGDIAPI
procedure   glCullFace(mode: GLenum); asmname 'glCullFace'; WINGDIAPI
procedure   glDeleteLists(list: GLuint; range: GLsizei); asmname 'glDeleteLists'; WINGDIAPI
procedure   glDeleteTextures(n: GLsizei; textures: PGLuint); asmname 'glDeleteTextures'; WINGDIAPI
procedure   glDepthFunc(func: GLenum); asmname 'glDepthFunc'; WINGDIAPI
procedure   glDepthMask(flag: GLboolean); asmname 'glDepthMask'; WINGDIAPI
procedure   glDepthRange(zNear: GLclampd; zFar: GLclampd); asmname 'glDepthRange'; WINGDIAPI
procedure   glDisable(cap: GLenum); asmname 'glDisable'; WINGDIAPI
procedure   glDisableClientState(cap: GLenum); asmname 'glDisableClientState'; WINGDIAPI
procedure   glDrawArrays(mode: GLenum; first: GLint; count: GLsizei); asmname 'glDrawArrays'; WINGDIAPI
procedure   glDrawBuffer(mode: GLenum); asmname 'glDrawBuffer'; WINGDIAPI
procedure   glDrawElements(mode: GLenum; count: GLsizei; t_ype: GLenum; indices: PGLvoid); asmname 'glDrawElements'; WINGDIAPI
procedure   glDrawPixels(width: GLsizei; height: GLsizei; format: GLenum; t_ype: GLenum; pixels: PGLvoid); asmname 'glDrawPixels'; WINGDIAPI
procedure   glEdgeFlag(flag: GLboolean); asmname 'glEdgeFlag'; WINGDIAPI
procedure   glEdgeFlagPointer(stride: GLsizei; pointer: PGLboolean); asmname 'glEdgeFlagPointer'; WINGDIAPI
procedure   glEdgeFlagv(flag: PGLboolean); asmname 'glEdgeFlagv'; WINGDIAPI
procedure   glEnable(cap: GLenum); asmname 'glEnable'; WINGDIAPI
procedure   glEnableClientState(cap: GLenum); asmname 'glEnableClientState'; WINGDIAPI
procedure   glEnd; asmname 'glEnd;'; WINGDIAPI
procedure   glEndList; asmname 'glEndList;'; WINGDIAPI
procedure   glEvalCoord1d(u: GLdouble); asmname 'glEvalCoord1d'; WINGDIAPI
procedure   glEvalCoord1dv(u: PGLdouble); asmname 'glEvalCoord1dv'; WINGDIAPI
procedure   glEvalCoord1f(u: GLfloat); asmname 'glEvalCoord1f'; WINGDIAPI
procedure   glEvalCoord1fv(u: PGLfloat); asmname 'glEvalCoord1fv'; WINGDIAPI
procedure   glEvalCoord2d(u: GLdouble; v: GLdouble); asmname 'glEvalCoord2d'; WINGDIAPI
procedure   glEvalCoord2dv(u: PGLdouble); asmname 'glEvalCoord2dv'; WINGDIAPI
procedure   glEvalCoord2f(u: GLfloat; v: GLfloat); asmname 'glEvalCoord2f'; WINGDIAPI
procedure   glEvalCoord2fv(u: PGLfloat); asmname 'glEvalCoord2fv'; WINGDIAPI
procedure   glEvalMesh1(mode: GLenum; i1: GLint; i2: GLint); asmname 'glEvalMesh1'; WINGDIAPI
procedure   glEvalMesh2(mode: GLenum; i1: GLint; i2: GLint; j1: GLint; j2: GLint); asmname 'glEvalMesh2'; WINGDIAPI
procedure   glEvalPoint1(i: GLint); asmname 'glEvalPoint1'; WINGDIAPI
procedure   glEvalPoint2(i: GLint; j: GLint); asmname 'glEvalPoint2'; WINGDIAPI
procedure   glFeedbackBuffer(size: GLsizei; t_ype: GLenum; buffer: PGLfloat); asmname 'glFeedbackBuffer'; WINGDIAPI
procedure   glFinish; asmname 'glFinish;'; WINGDIAPI
procedure   glFlush; asmname 'glFlush;'; WINGDIAPI
procedure   glFogf(pname: GLenum; param: GLfloat); asmname 'glFogf'; WINGDIAPI
procedure   glFogfv(pname: GLenum; params: PGLfloat); asmname 'glFogfv'; WINGDIAPI
procedure   glFogi(pname: GLenum; param: GLint); asmname 'glFogi'; WINGDIAPI
procedure   glFogiv(pname: GLenum; params: PGLint); asmname 'glFogiv'; WINGDIAPI
procedure   glFrontFace(mode: GLenum); asmname 'glFrontFace'; WINGDIAPI
procedure   glFrustum(left: GLdouble; right: GLdouble; bottom: GLdouble; top: GLdouble; zNear: GLdouble; zFar: GLdouble); asmname 'glFrustum'; WINGDIAPI
function    glGenLists(range: GLsizei): GLuint; asmname 'glGenLists'; WINGDIAPI
procedure   glGenTextures(n: GLsizei; textures: PGLuint); asmname 'glGenTextures'; WINGDIAPI
procedure   glGetBooleanv(pname: GLenum; params: PGLboolean); asmname 'glGetBooleanv'; WINGDIAPI
procedure   glGetClipPlane(plane: GLenum; equation: PGLdouble); asmname 'glGetClipPlane'; WINGDIAPI
procedure   glGetDoublev(pname: GLenum; params: PGLdouble); asmname 'glGetDoublev'; WINGDIAPI
function    glGetError: GLenum; asmname 'glGetError:'; WINGDIAPI
procedure   glGetFloatv(pname: GLenum; params: PGLfloat); asmname 'glGetFloatv'; WINGDIAPI
procedure   glGetIntegerv(pname: GLenum; params: PGLint); asmname 'glGetIntegerv'; WINGDIAPI
procedure   glGetLightfv(light: GLenum; pname: GLenum; params: PGLfloat); asmname 'glGetLightfv'; WINGDIAPI
procedure   glGetLightiv(light: GLenum; pname: GLenum; params: PGLint); asmname 'glGetLightiv'; WINGDIAPI
procedure   glGetMapdv(target: GLenum; query: GLenum; v: PGLdouble); asmname 'glGetMapdv'; WINGDIAPI
procedure   glGetMapfv(target: GLenum; query: GLenum; v: PGLfloat); asmname 'glGetMapfv'; WINGDIAPI
procedure   glGetMapiv(target: GLenum; query: GLenum; v: PGLint); asmname 'glGetMapiv'; WINGDIAPI
procedure   glGetMaterialfv(face: GLenum; pname: GLenum; params: PGLfloat); asmname 'glGetMaterialfv'; WINGDIAPI
procedure   glGetMaterialiv(face: GLenum; pname: GLenum; params: PGLint); asmname 'glGetMaterialiv'; WINGDIAPI
procedure   glGetPixelMapfv(map: GLenum; values: PGLfloat); asmname 'glGetPixelMapfv'; WINGDIAPI
procedure   glGetPixelMapuiv(map: GLenum; values: PGLuint); asmname 'glGetPixelMapuiv'; WINGDIAPI
procedure   glGetPixelMapusv(map: GLenum; values: PGLushort); asmname 'glGetPixelMapusv'; WINGDIAPI
procedure   glGetPointerv(pname: GLenum; params: PPGLvoid); asmname 'glGetPointerv'; WINGDIAPI
procedure   glGetPolygonStipple(mask: PGLubyte); asmname 'glGetPolygonStipple'; WINGDIAPI
function    glGetString(name: GLenum): PGLubyte; asmname 'glGetString'; WINGDIAPI
procedure   glGetTexEnvfv(target: GLenum; pname: GLenum; params: PGLfloat); asmname 'glGetTexEnvfv'; WINGDIAPI
procedure   glGetTexEnviv(target: GLenum; pname: GLenum; params: PGLint); asmname 'glGetTexEnviv'; WINGDIAPI
procedure   glGetTexGendv(coord: GLenum; pname: GLenum; params: PGLdouble); asmname 'glGetTexGendv'; WINGDIAPI
procedure   glGetTexGenfv(coord: GLenum; pname: GLenum; params: PGLfloat); asmname 'glGetTexGenfv'; WINGDIAPI
procedure   glGetTexGeniv(coord: GLenum; pname: GLenum; params: PGLint); asmname 'glGetTexGeniv'; WINGDIAPI
procedure   glGetTexImage(target: GLenum; level: GLint; format: GLenum; t_ype: GLenum; pixels: PGLvoid); asmname 'glGetTexImage'; WINGDIAPI
procedure   glGetTexLevelParameterfv(target: GLenum; level: GLint; pname: GLenum; params: PGLfloat); asmname 'glGetTexLevelParameterfv'; WINGDIAPI
procedure   glGetTexLevelParameteriv(target: GLenum; level: GLint; pname: GLenum; params: PGLint); asmname 'glGetTexLevelParameteriv'; WINGDIAPI
procedure   glGetTexParameterfv(target: GLenum; pname: GLenum; params: PGLfloat); asmname 'glGetTexParameterfv'; WINGDIAPI
procedure   glGetTexParameteriv(target: GLenum; pname: GLenum; params: PGLint); asmname 'glGetTexParameteriv'; WINGDIAPI
procedure   glHint(target: GLenum; mode: GLenum); asmname 'glHint'; WINGDIAPI
procedure   glIndexMask(mask: GLuint); asmname 'glIndexMask'; WINGDIAPI
procedure   glIndexPointer(t_ype: GLenum; stride: GLsizei; pointer: PGLvoid); asmname 'glIndexPointer'; WINGDIAPI
procedure   glIndexd(c: GLdouble); asmname 'glIndexd'; WINGDIAPI
procedure   glIndexdv(c: PGLdouble); asmname 'glIndexdv'; WINGDIAPI
procedure   glIndexf(c: GLfloat); asmname 'glIndexf'; WINGDIAPI
procedure   glIndexfv(c: PGLfloat); asmname 'glIndexfv'; WINGDIAPI
procedure   glIndexi(c: GLint); asmname 'glIndexi'; WINGDIAPI
procedure   glIndexiv(c: PGLint); asmname 'glIndexiv'; WINGDIAPI
procedure   glIndexs(c: GLshort); asmname 'glIndexs'; WINGDIAPI
procedure   glIndexsv(c: PGLshort); asmname 'glIndexsv'; WINGDIAPI
procedure   glIndexub(c: GLubyte); asmname 'glIndexub'; WINGDIAPI
procedure   glIndexubv(c: PGLubyte); asmname 'glIndexubv'; WINGDIAPI
procedure   glInitNames; asmname 'glInitNames;'; WINGDIAPI
procedure   glInterleavedArrays(format: GLenum; stride: GLsizei; pointer: PGLvoid); asmname 'glInterleavedArrays'; WINGDIAPI
function    glIsEnabled(cap: GLenum): GLboolean; asmname 'glIsEnabled'; WINGDIAPI
function    glIsList(list: GLuint): GLboolean; asmname 'glIsList'; WINGDIAPI
function    glIsTexture(texture: GLuint): GLboolean; asmname 'glIsTexture'; WINGDIAPI
procedure   glLightModelf(pname: GLenum; param: GLfloat); asmname 'glLightModelf'; WINGDIAPI
procedure   glLightModelfv(pname: GLenum; params: PGLfloat); asmname 'glLightModelfv'; WINGDIAPI
procedure   glLightModeli(pname: GLenum; param: GLint); asmname 'glLightModeli'; WINGDIAPI
procedure   glLightModeliv(pname: GLenum; params: PGLint); asmname 'glLightModeliv'; WINGDIAPI
procedure   glLightf(light: GLenum; pname: GLenum; param: GLfloat); asmname 'glLightf'; WINGDIAPI
procedure   glLightfv(light: GLenum; pname: GLenum; params: PGLfloat); asmname 'glLightfv'; WINGDIAPI
procedure   glLighti(light: GLenum; pname: GLenum; param: GLint); asmname 'glLighti'; WINGDIAPI
procedure   glLightiv(light: GLenum; pname: GLenum; params: PGLint); asmname 'glLightiv'; WINGDIAPI
procedure   glLineStipple(factor: GLint; pattern: GLushort); asmname 'glLineStipple'; WINGDIAPI
procedure   glLineWidth(width: GLfloat); asmname 'glLineWidth'; WINGDIAPI
procedure   glListBase(base: GLuint); asmname 'glListBase'; WINGDIAPI
procedure   glLoadIdentity; asmname 'glLoadIdentity;'; WINGDIAPI
procedure   glLoadMatrixd(m: PGLdouble); asmname 'glLoadMatrixd'; WINGDIAPI
procedure   glLoadMatrixf(m: PGLfloat); asmname 'glLoadMatrixf'; WINGDIAPI
procedure   glLoadName(name: GLuint); asmname 'glLoadName'; WINGDIAPI
procedure   glLogicOp(opcode: GLenum); asmname 'glLogicOp'; WINGDIAPI
procedure   glMap1d(target: GLenum; u1: GLdouble; u2: GLdouble; stride: GLint; order: GLint; points: PGLdouble); asmname 'glMap1d'; WINGDIAPI
procedure   glMap1f(target: GLenum; u1: GLfloat; u2: GLfloat; stride: GLint; order: GLint; points: PGLfloat); asmname 'glMap1f'; WINGDIAPI
procedure   glMap2d(target: GLenum; u1: GLdouble; u2: GLdouble; ustride: GLint; uorder: GLint; v1: GLdouble; v2: GLdouble; vstride: GLint; vorder: GLint; points: PGLdouble); asmname 'glMap2d'; WINGDIAPI
procedure   glMap2f(target: GLenum; u1: GLfloat; u2: GLfloat; ustride: GLint; uorder: GLint; v1: GLfloat; v2: GLfloat; vstride: GLint; vorder: GLint; points: PGLfloat); asmname 'glMap2f'; WINGDIAPI
procedure   glMapGrid1d(un: GLint; u1: GLdouble; u2: GLdouble); asmname 'glMapGrid1d'; WINGDIAPI
procedure   glMapGrid1f(un: GLint; u1: GLfloat; u2: GLfloat); asmname 'glMapGrid1f'; WINGDIAPI
procedure   glMapGrid2d(un: GLint; u1: GLdouble; u2: GLdouble; vn: GLint; v1: GLdouble; v2: GLdouble); asmname 'glMapGrid2d'; WINGDIAPI
procedure   glMapGrid2f(un: GLint; u1: GLfloat; u2: GLfloat; vn: GLint; v1: GLfloat; v2: GLfloat); asmname 'glMapGrid2f'; WINGDIAPI
procedure   glMaterialf(face: GLenum; pname: GLenum; param: GLfloat); asmname 'glMaterialf'; WINGDIAPI
procedure   glMaterialfv(face: GLenum; pname: GLenum; params: PGLfloat); asmname 'glMaterialfv'; WINGDIAPI
procedure   glMateriali(face: GLenum; pname: GLenum; param: GLint); asmname 'glMateriali'; WINGDIAPI
procedure   glMaterialiv(face: GLenum; pname: GLenum; params: PGLint); asmname 'glMaterialiv'; WINGDIAPI
procedure   glMatrixMode(mode: GLenum); asmname 'glMatrixMode'; WINGDIAPI
procedure   glMultMatrixd(m: PGLdouble); asmname 'glMultMatrixd'; WINGDIAPI
procedure   glMultMatrixf(m: PGLfloat); asmname 'glMultMatrixf'; WINGDIAPI
procedure   glNewList(list: GLuint; mode: GLenum); asmname 'glNewList'; WINGDIAPI
procedure   glNormal3b(nx: GLbyte; ny: GLbyte; nz: GLbyte); asmname 'glNormal3b'; WINGDIAPI
procedure   glNormal3bv(v: PGLbyte); asmname 'glNormal3bv'; WINGDIAPI
procedure   glNormal3d(nx: GLdouble; ny: GLdouble; nz: GLdouble); asmname 'glNormal3d'; WINGDIAPI
procedure   glNormal3dv(v: PGLdouble); asmname 'glNormal3dv'; WINGDIAPI
procedure   glNormal3f(nx: GLfloat; ny: GLfloat; nz: GLfloat); asmname 'glNormal3f'; WINGDIAPI
procedure   glNormal3fv(v: PGLfloat); asmname 'glNormal3fv'; WINGDIAPI
procedure   glNormal3i(nx: GLint; ny: GLint; nz: GLint); asmname 'glNormal3i'; WINGDIAPI
procedure   glNormal3iv(v: PGLint); asmname 'glNormal3iv'; WINGDIAPI
procedure   glNormal3s(nx: GLshort; ny: GLshort; nz: GLshort); asmname 'glNormal3s'; WINGDIAPI
procedure   glNormal3sv(v: PGLshort); asmname 'glNormal3sv'; WINGDIAPI
procedure   glNormalPointer(t_ype: GLenum; stride: GLsizei; pointer: PGLvoid); asmname 'glNormalPointer'; WINGDIAPI
procedure   glOrtho(left: GLdouble; right: GLdouble; bottom: GLdouble; top: GLdouble; zNear: GLdouble; zFar: GLdouble); asmname 'glOrtho'; WINGDIAPI
procedure   glPassThrough(token: GLfloat); asmname 'glPassThrough'; WINGDIAPI
procedure   glPixelMapfv(map: GLenum; mapsize: GLint; values: PGLfloat); asmname 'glPixelMapfv'; WINGDIAPI
procedure   glPixelMapuiv(map: GLenum; mapsize: GLint; values: PGLuint); asmname 'glPixelMapuiv'; WINGDIAPI
procedure   glPixelMapusv(map: GLenum; mapsize: GLint; values: PGLushort); asmname 'glPixelMapusv'; WINGDIAPI
procedure   glPixelStoref(pname: GLenum; param: GLfloat); asmname 'glPixelStoref'; WINGDIAPI
procedure   glPixelStorei(pname: GLenum; param: GLint); asmname 'glPixelStorei'; WINGDIAPI
procedure   glPixelTransferf(pname: GLenum; param: GLfloat); asmname 'glPixelTransferf'; WINGDIAPI
procedure   glPixelTransferi(pname: GLenum; param: GLint); asmname 'glPixelTransferi'; WINGDIAPI
procedure   glPixelZoom(xfactor: GLfloat; yfactor: GLfloat); asmname 'glPixelZoom'; WINGDIAPI
procedure   glPointSize(size: GLfloat); asmname 'glPointSize'; WINGDIAPI
procedure   glPolygonMode(face: GLenum; mode: GLenum); asmname 'glPolygonMode'; WINGDIAPI
procedure   glPolygonOffset(factor: GLfloat; units: GLfloat); asmname 'glPolygonOffset'; WINGDIAPI
procedure   glPolygonStipple(mask: PGLubyte); asmname 'glPolygonStipple'; WINGDIAPI
procedure   glPopAttrib; asmname 'glPopAttrib;'; WINGDIAPI
procedure   glPopClientAttrib; asmname 'glPopClientAttrib;'; WINGDIAPI
procedure   glPopMatrix; asmname 'glPopMatrix;'; WINGDIAPI
procedure   glPopName; asmname 'glPopName;'; WINGDIAPI
procedure   glPrioritizeTextures(n: GLsizei; textures: PGLuint; priorities: PGLclampf); asmname 'glPrioritizeTextures'; WINGDIAPI
procedure   glPushAttrib(mask: GLbitfield); asmname 'glPushAttrib'; WINGDIAPI
procedure   glPushClientAttrib(mask: GLbitfield); asmname 'glPushClientAttrib'; WINGDIAPI
procedure   glPushMatrix; asmname 'glPushMatrix;'; WINGDIAPI
procedure   glPushName(name: GLuint); asmname 'glPushName'; WINGDIAPI
procedure   glRasterPos2d(x: GLdouble; y: GLdouble); asmname 'glRasterPos2d'; WINGDIAPI
procedure   glRasterPos2dv(v: PGLdouble); asmname 'glRasterPos2dv'; WINGDIAPI
procedure   glRasterPos2f(x: GLfloat; y: GLfloat); asmname 'glRasterPos2f'; WINGDIAPI
procedure   glRasterPos2fv(v: PGLfloat); asmname 'glRasterPos2fv'; WINGDIAPI
procedure   glRasterPos2i(x: GLint; y: GLint); asmname 'glRasterPos2i'; WINGDIAPI
procedure   glRasterPos2iv(v: PGLint); asmname 'glRasterPos2iv'; WINGDIAPI
procedure   glRasterPos2s(x: GLshort; y: GLshort); asmname 'glRasterPos2s'; WINGDIAPI
procedure   glRasterPos2sv(v: PGLshort); asmname 'glRasterPos2sv'; WINGDIAPI
procedure   glRasterPos3d(x: GLdouble; y: GLdouble; z: GLdouble); asmname 'glRasterPos3d'; WINGDIAPI
procedure   glRasterPos3dv(v: PGLdouble); asmname 'glRasterPos3dv'; WINGDIAPI
procedure   glRasterPos3f(x: GLfloat; y: GLfloat; z: GLfloat); asmname 'glRasterPos3f'; WINGDIAPI
procedure   glRasterPos3fv(v: PGLfloat); asmname 'glRasterPos3fv'; WINGDIAPI
procedure   glRasterPos3i(x: GLint; y: GLint; z: GLint); asmname 'glRasterPos3i'; WINGDIAPI
procedure   glRasterPos3iv(v: PGLint); asmname 'glRasterPos3iv'; WINGDIAPI
procedure   glRasterPos3s(x: GLshort; y: GLshort; z: GLshort); asmname 'glRasterPos3s'; WINGDIAPI
procedure   glRasterPos3sv(v: PGLshort); asmname 'glRasterPos3sv'; WINGDIAPI
procedure   glRasterPos4d(x: GLdouble; y: GLdouble; z: GLdouble; w: GLdouble); asmname 'glRasterPos4d'; WINGDIAPI
procedure   glRasterPos4dv(v: PGLdouble); asmname 'glRasterPos4dv'; WINGDIAPI
procedure   glRasterPos4f(x: GLfloat; y: GLfloat; z: GLfloat; w: GLfloat); asmname 'glRasterPos4f'; WINGDIAPI
procedure   glRasterPos4fv(v: PGLfloat); asmname 'glRasterPos4fv'; WINGDIAPI
procedure   glRasterPos4i(x: GLint; y: GLint; z: GLint; w: GLint); asmname 'glRasterPos4i'; WINGDIAPI
procedure   glRasterPos4iv(v: PGLint); asmname 'glRasterPos4iv'; WINGDIAPI
procedure   glRasterPos4s(x: GLshort; y: GLshort; z: GLshort; w: GLshort); asmname 'glRasterPos4s'; WINGDIAPI
procedure   glRasterPos4sv(v: PGLshort); asmname 'glRasterPos4sv'; WINGDIAPI
procedure   glReadBuffer(mode: GLenum); asmname 'glReadBuffer'; WINGDIAPI
procedure   glReadPixels(x: GLint; y: GLint; width: GLsizei; height: GLsizei; format: GLenum; t_ype: GLenum; pixels: PGLvoid); asmname 'glReadPixels'; WINGDIAPI
procedure   glRectd(x1: GLdouble; y1: GLdouble; x2: GLdouble; y2: GLdouble); asmname 'glRectd'; WINGDIAPI
procedure   glRectdv(v1: PGLdouble; v2: PGLdouble); asmname 'glRectdv'; WINGDIAPI
procedure   glRectf(x1: GLfloat; y1: GLfloat; x2: GLfloat; y2: GLfloat); asmname 'glRectf'; WINGDIAPI
procedure   glRectfv(v1: PGLfloat; v2: PGLfloat); asmname 'glRectfv'; WINGDIAPI
procedure   glRecti(x1: GLint; y1: GLint; x2: GLint; y2: GLint); asmname 'glRecti'; WINGDIAPI
procedure   glRectiv(v1: PGLint; v2: PGLint); asmname 'glRectiv'; WINGDIAPI
procedure   glRects(x1: GLshort; y1: GLshort; x2: GLshort; y2: GLshort); asmname 'glRects'; WINGDIAPI
procedure   glRectsv(v1: PGLshort; v2: PGLshort); asmname 'glRectsv'; WINGDIAPI
function    glRenderMode(mode: GLenum): GLint; asmname 'glRenderMode'; WINGDIAPI
procedure   glRotated(angle: GLdouble; x: GLdouble; y: GLdouble; z: GLdouble); asmname 'glRotated'; WINGDIAPI
procedure   glRotatef(angle: GLfloat; x: GLfloat; y: GLfloat; z: GLfloat); asmname 'glRotatef'; WINGDIAPI
procedure   glScaled(x: GLdouble; y: GLdouble; z: GLdouble); asmname 'glScaled'; WINGDIAPI
procedure   glScalef(x: GLfloat; y: GLfloat; z: GLfloat); asmname 'glScalef'; WINGDIAPI
procedure   glScissor(x: GLint; y: GLint; width: GLsizei; height: GLsizei); asmname 'glScissor'; WINGDIAPI
procedure   glSelectBuffer(size: GLsizei; buffer: PGLuint); asmname 'glSelectBuffer'; WINGDIAPI
procedure   glShadeModel(mode: GLenum); asmname 'glShadeModel'; WINGDIAPI
procedure   glStencilFunc(func: GLenum; ref: GLint; mask: GLuint); asmname 'glStencilFunc'; WINGDIAPI
procedure   glStencilMask(mask: GLuint); asmname 'glStencilMask'; WINGDIAPI
procedure   glStencilOp(fail: GLenum; zfail: GLenum; zpass: GLenum); asmname 'glStencilOp'; WINGDIAPI
procedure   glTexCoord1d(s: GLdouble); asmname 'glTexCoord1d'; WINGDIAPI
procedure   glTexCoord1dv(v: PGLdouble); asmname 'glTexCoord1dv'; WINGDIAPI
procedure   glTexCoord1f(s: GLfloat); asmname 'glTexCoord1f'; WINGDIAPI
procedure   glTexCoord1fv(v: PGLfloat); asmname 'glTexCoord1fv'; WINGDIAPI
procedure   glTexCoord1i(s: GLint); asmname 'glTexCoord1i'; WINGDIAPI
procedure   glTexCoord1iv(v: PGLint); asmname 'glTexCoord1iv'; WINGDIAPI
procedure   glTexCoord1s(s: GLshort); asmname 'glTexCoord1s'; WINGDIAPI
procedure   glTexCoord1sv(v: PGLshort); asmname 'glTexCoord1sv'; WINGDIAPI
procedure   glTexCoord2d(s: GLdouble; t: GLdouble); asmname 'glTexCoord2d'; WINGDIAPI
procedure   glTexCoord2dv(v: PGLdouble); asmname 'glTexCoord2dv'; WINGDIAPI
procedure   glTexCoord2f(s: GLfloat; t: GLfloat); asmname 'glTexCoord2f'; WINGDIAPI
procedure   glTexCoord2fv(v: PGLfloat); asmname 'glTexCoord2fv'; WINGDIAPI
procedure   glTexCoord2i(s: GLint; t: GLint); asmname 'glTexCoord2i'; WINGDIAPI
procedure   glTexCoord2iv(v: PGLint); asmname 'glTexCoord2iv'; WINGDIAPI
procedure   glTexCoord2s(s: GLshort; t: GLshort); asmname 'glTexCoord2s'; WINGDIAPI
procedure   glTexCoord2sv(v: PGLshort); asmname 'glTexCoord2sv'; WINGDIAPI
procedure   glTexCoord3d(s: GLdouble; t: GLdouble; r: GLdouble); asmname 'glTexCoord3d'; WINGDIAPI
procedure   glTexCoord3dv(v: PGLdouble); asmname 'glTexCoord3dv'; WINGDIAPI
procedure   glTexCoord3f(s: GLfloat; t: GLfloat; r: GLfloat); asmname 'glTexCoord3f'; WINGDIAPI
procedure   glTexCoord3fv(v: PGLfloat); asmname 'glTexCoord3fv'; WINGDIAPI
procedure   glTexCoord3i(s: GLint; t: GLint; r: GLint); asmname 'glTexCoord3i'; WINGDIAPI
procedure   glTexCoord3iv(v: PGLint); asmname 'glTexCoord3iv'; WINGDIAPI
procedure   glTexCoord3s(s: GLshort; t: GLshort; r: GLshort); asmname 'glTexCoord3s'; WINGDIAPI
procedure   glTexCoord3sv(v: PGLshort); asmname 'glTexCoord3sv'; WINGDIAPI
procedure   glTexCoord4d(s: GLdouble; t: GLdouble; r: GLdouble; q: GLdouble); asmname 'glTexCoord4d'; WINGDIAPI
procedure   glTexCoord4dv(v: PGLdouble); asmname 'glTexCoord4dv'; WINGDIAPI
procedure   glTexCoord4f(s: GLfloat; t: GLfloat; r: GLfloat; q: GLfloat); asmname 'glTexCoord4f'; WINGDIAPI
procedure   glTexCoord4fv(v: PGLfloat); asmname 'glTexCoord4fv'; WINGDIAPI
procedure   glTexCoord4i(s: GLint; t: GLint; r: GLint; q: GLint); asmname 'glTexCoord4i'; WINGDIAPI
procedure   glTexCoord4iv(v: PGLint); asmname 'glTexCoord4iv'; WINGDIAPI
procedure   glTexCoord4s(s: GLshort; t: GLshort; r: GLshort; q: GLshort); asmname 'glTexCoord4s'; WINGDIAPI
procedure   glTexCoord4sv(v: PGLshort); asmname 'glTexCoord4sv'; WINGDIAPI
procedure   glTexCoordPointer(size: GLint; t_ype: GLenum; stride: GLsizei; pointer: PGLvoid); asmname 'glTexCoordPointer'; WINGDIAPI
procedure   glTexEnvf(target: GLenum; pname: GLenum; param: GLfloat); asmname 'glTexEnvf'; WINGDIAPI
procedure   glTexEnvfv(target: GLenum; pname: GLenum; params: PGLfloat); asmname 'glTexEnvfv'; WINGDIAPI
procedure   glTexEnvi(target: GLenum; pname: GLenum; param: GLint); asmname 'glTexEnvi'; WINGDIAPI
procedure   glTexEnviv(target: GLenum; pname: GLenum; params: PGLint); asmname 'glTexEnviv'; WINGDIAPI
procedure   glTexGend(coord: GLenum; pname: GLenum; param: GLdouble); asmname 'glTexGend'; WINGDIAPI
procedure   glTexGendv(coord: GLenum; pname: GLenum; params: PGLdouble); asmname 'glTexGendv'; WINGDIAPI
procedure   glTexGenf(coord: GLenum; pname: GLenum; param: GLfloat); asmname 'glTexGenf'; WINGDIAPI
procedure   glTexGenfv(coord: GLenum; pname: GLenum; params: PGLfloat); asmname 'glTexGenfv'; WINGDIAPI
procedure   glTexGeni(coord: GLenum; pname: GLenum; param: GLint); asmname 'glTexGeni'; WINGDIAPI
procedure   glTexGeniv(coord: GLenum; pname: GLenum; params: PGLint); asmname 'glTexGeniv'; WINGDIAPI
procedure   glTexImage1D(target: GLenum; level: GLint; components: GLint; width: GLsizei; border: GLint; format: GLenum; t_ype: GLenum; pixels: PGLvoid); asmname 'glTexImage1D'; WINGDIAPI
procedure   glTexImage2D(target: GLenum; level: GLint; components: GLint; width: GLsizei; height: GLsizei; border: GLint; format: GLenum; t_ype: GLenum; pixels: PGLvoid); asmname 'glTexImage2D'; WINGDIAPI
procedure   glTexParameterf(target: GLenum; pname: GLenum; param: GLfloat); asmname 'glTexParameterf'; WINGDIAPI
procedure   glTexParameterfv(target: GLenum; pname: GLenum; params: PGLfloat); asmname 'glTexParameterfv'; WINGDIAPI
procedure   glTexParameteri(target: GLenum; pname: GLenum; param: GLint); asmname 'glTexParameteri'; WINGDIAPI
procedure   glTexParameteriv(target: GLenum; pname: GLenum; params: PGLint); asmname 'glTexParameteriv'; WINGDIAPI
procedure   glTexSubImage1D(target: GLenum; level: GLint; xoffset: GLint; width: GLsizei; format: GLenum; t_ype: GLenum; pixels: PGLvoid); asmname 'glTexSubImage1D'; WINGDIAPI
procedure   glTexSubImage2D(target: GLenum; level: GLint; xoffset: GLint; yoffset: GLint; width: GLsizei; height: GLsizei; format: GLenum; t_ype: GLenum; pixels: PGLvoid); asmname 'glTexSubImage2D'; WINGDIAPI
procedure   glTranslated(x: GLdouble; y: GLdouble; z: GLdouble); asmname 'glTranslated'; WINGDIAPI
procedure   glTranslatef(x: GLfloat; y: GLfloat; z: GLfloat); asmname 'glTranslatef'; WINGDIAPI
procedure   glVertex2d(x: GLdouble; y: GLdouble); asmname 'glVertex2d'; WINGDIAPI
procedure   glVertex2dv(v: PGLdouble); asmname 'glVertex2dv'; WINGDIAPI
procedure   glVertex2f(x: GLfloat; y: GLfloat); asmname 'glVertex2f'; WINGDIAPI
procedure   glVertex2fv(v: PGLfloat); asmname 'glVertex2fv'; WINGDIAPI
procedure   glVertex2i(x: GLint; y: GLint); asmname 'glVertex2i'; WINGDIAPI
procedure   glVertex2iv(v: PGLint); asmname 'glVertex2iv'; WINGDIAPI
procedure   glVertex2s(x: GLshort; y: GLshort); asmname 'glVertex2s'; WINGDIAPI
procedure   glVertex2sv(v: PGLshort); asmname 'glVertex2sv'; WINGDIAPI
procedure   glVertex3d(x: GLdouble; y: GLdouble; z: GLdouble); asmname 'glVertex3d'; WINGDIAPI
procedure   glVertex3dv(v: PGLdouble); asmname 'glVertex3dv'; WINGDIAPI
procedure   glVertex3f(x: GLfloat; y: GLfloat; z: GLfloat); asmname 'glVertex3f'; WINGDIAPI
procedure   glVertex3fv(v: PGLfloat); asmname 'glVertex3fv'; WINGDIAPI
procedure   glVertex3i(x: GLint; y: GLint; z: GLint); asmname 'glVertex3i'; WINGDIAPI
procedure   glVertex3iv(v: PGLint); asmname 'glVertex3iv'; WINGDIAPI
procedure   glVertex3s(x: GLshort; y: GLshort; z: GLshort); asmname 'glVertex3s'; WINGDIAPI
procedure   glVertex3sv(v: PGLshort); asmname 'glVertex3sv'; WINGDIAPI
procedure   glVertex4d(x: GLdouble; y: GLdouble; z: GLdouble; w: GLdouble); asmname 'glVertex4d'; WINGDIAPI
procedure   glVertex4dv(v: PGLdouble); asmname 'glVertex4dv'; WINGDIAPI
procedure   glVertex4f(x: GLfloat; y: GLfloat; z: GLfloat; w: GLfloat); asmname 'glVertex4f'; WINGDIAPI
procedure   glVertex4fv(v: PGLfloat); asmname 'glVertex4fv'; WINGDIAPI
procedure   glVertex4i(x: GLint; y: GLint; z: GLint; w: GLint); asmname 'glVertex4i'; WINGDIAPI
procedure   glVertex4iv(v: PGLint); asmname 'glVertex4iv'; WINGDIAPI
procedure   glVertex4s(x: GLshort; y: GLshort; z: GLshort; w: GLshort); asmname 'glVertex4s'; WINGDIAPI
procedure   glVertex4sv(v: PGLshort); asmname 'glVertex4sv'; WINGDIAPI
procedure   glVertexPointer(size: GLint; t_ype: GLenum; stride: GLsizei; pointer: PGLvoid); asmname 'glVertexPointer'; WINGDIAPI
procedure   glViewport(x: GLint; y: GLint; width: GLsizei; height: GLsizei); asmname 'glViewport'; WINGDIAPI

{-- EXT_vertex_array -------------------------------------------------------}

type
    PFNGLARRAYELEMENTEXTPROC                = procedure(i: GLint);
    PFNGLCOLORPOINTEREXTPROC                = procedure(size: GLint; t_ype: GLenum; stride: GLsizei; count: GLsizei; pointer: PGLvoid);
    PFNGLDRAWARRAYSEXTPROC                  = procedure(mode: GLenum; first: GLint; count: GLsizei);
    PFNGLEDGEFLAGPOINTEREXTPROC             = procedure(stride: GLsizei; count: GLsizei; pointer: PGLboolean);
    PFNGLGETPOINTERVEXTPROC                 = procedure(pname: GLenum; params: PPGLvoid);
    PFNGLINDEXPOINTEREXTPROC                = procedure(t_ype: GLenum; stride: GLsizei; count: GLsizei; pointer: PGLvoid);
    PFNGLNORMALPOINTEREXTPROC               = procedure(t_ype: GLenum; stride: GLsizei; count: GLsizei; pointer: PGLvoid);
    PFNGLTEXCOORDPOINTEREXTPROC             = procedure(size: GLint; t_ype: GLenum; stride: GLsizei; count: GLsizei; pointer: PGLvoid);
    PFNGLVERTEXPOINTEREXTPROC               = procedure(size: GLint; t_ype: GLenum; stride: GLsizei; count: GLsizei; pointer: PGLvoid);

{-- EXT_color_subtable -----------------------------------------------------}

    PFNGLCOLORSUBTABLEEXTPROC               = procedure(target: GLenum; start: GLsizei; count: GLsizei; format: GLenum; t_ype: GLenum; table: PGLvoid);

{-- EXT_color_table --------------------------------------------------------}

    PFNGLCOLORTABLEEXTPROC                  = procedure(target: GLenum; internalformat: GLenum; width: GLsizei; format: GLenum; t_ype: GLenum; table: PGLvoid);
    PFNGLCOPYCOLORTABLEEXTPROC              = procedure(target: GLenum; internalformat: GLenum; x: GLint; y: GLint; width: GLsizei);
    PFNGLGETCOLORTABLEEXTPROC               = procedure(target: GLenum; format: GLenum; t_ype: GLenum; table: PGLvoid);
    PFNGLGETCOLORTABLEPARAMETERFVEXTPROC    = procedure(target: GLenum; pname: GLenum; params: PGLfloat);
    PFNGLGETCOLORTABLEPARAMETERIVEXTPROC    = procedure(target: GLenum; pname: GLenum; params: PGLint);

{-- SGI_compiled_vertex_array ----------------------------------------------}

    PFNGLLOCKARRAYSSGIPROC                  = procedure(first: GLint; count: GLsizei);
    PFNGLUNLOCKARRAYSSGIPROC                = procedure;

{-- SGI_cull_vertex --------------------------------------------------------}

    PFNGLCULLPARAMETERDVSGIPROC             = procedure(pname: GLenum; params: PGLdouble);
    PFNGLCULLPARAMETERFVSGIPROC             = procedure(pname: GLenum; params: PGLfloat);

{-- SGI_index_func ---------------------------------------------------------}

    PFNGLINDEXFUNCSGIPROC                   = procedure(func: GLenum; ref: GLclampf);

{-- SGI_index_material -----------------------------------------------------}

    PFNGLINDEXMATERIALSGIPROC               = procedure(face: GLenum; mode: GLenum);

{-- WIN_swap_hint ----------------------------------------------------------}

    PFNGLADDSWAPHINTRECTWINPROC             = procedure(x: GLint; y: GLint; width: GLsizei; height: GLsizei);

{-- MESA extensions --------------------------------------------------------}

procedure   glWindowPos2iMESA(x: GLint; y: GLint); asmname 'glWindowPos2iMESA'; WINGDIAPI
procedure   glWindowPos2sMESA(x: GLshort; y: GLshort); asmname 'glWindowPos2sMESA'; WINGDIAPI
procedure   glWindowPos2fMESA(x: GLfloat; y: GLfloat); asmname 'glWindowPos2fMESA'; WINGDIAPI
procedure   glWindowPos2dMESA(x: GLdouble; y: GLdouble); asmname 'glWindowPos2dMESA'; WINGDIAPI

procedure   glWindowPos2ivMESA(p: PGLint); asmname 'glWindowPos2ivMESA'; WINGDIAPI
procedure   glWindowPos2svMESA(p: PGLshort); asmname 'glWindowPos2svMESA'; WINGDIAPI
procedure   glWindowPos2fvMESA(p: PGLfloat); asmname 'glWindowPos2fvMESA'; WINGDIAPI
procedure   glWindowPos2dvMESA(p: PGLdouble); asmname 'glWindowPos2dvMESA'; WINGDIAPI

procedure   glWindowPos3iMESA(x: GLint; y: GLint; z: GLint); asmname 'glWindowPos3iMESA'; WINGDIAPI
procedure   glWindowPos3sMESA(x: GLshort; y: GLshort; z: GLshort); asmname 'glWindowPos3sMESA'; WINGDIAPI
procedure   glWindowPos3fMESA(x: GLfloat; y: GLfloat; z: GLfloat); asmname 'glWindowPos3fMESA'; WINGDIAPI
procedure   glWindowPos3dMESA(x: GLdouble; y: GLdouble; z: GLdouble); asmname 'glWindowPos3dMESA'; WINGDIAPI

procedure   glWindowPos3ivMESA(p: PGLint); asmname 'glWindowPos3ivMESA'; WINGDIAPI
procedure   glWindowPos3svMESA(p: PGLshort); asmname 'glWindowPos3svMESA'; WINGDIAPI
procedure   glWindowPos3fvMESA(p: PGLfloat); asmname 'glWindowPos3fvMESA'; WINGDIAPI
procedure   glWindowPos3dvMESA(p: PGLdouble); asmname 'glWindowPos3dvMESA'; WINGDIAPI

procedure   glWindowPos4iMESA(x: GLint; y: GLint; z: GLint; w: GLint); asmname 'glWindowPos4iMESA'; WINGDIAPI
procedure   glWindowPos4sMESA(x: GLshort; y: GLshort; z: GLshort; w: GLshort); asmname 'glWindowPos4sMESA'; WINGDIAPI
procedure   glWindowPos4fMESA(x: GLfloat; y: GLfloat; z: GLfloat; w: GLfloat); asmname 'glWindowPos4fMESA'; WINGDIAPI
procedure   glWindowPos4dMESA(x: GLdouble; y: GLdouble; z: GLdouble; w: GLdouble); asmname 'glWindowPos4dMESA'; WINGDIAPI

procedure   glWindowPos4ivMESA(p: PGLint); asmname 'glWindowPos4ivMESA'; WINGDIAPI
procedure   glWindowPos4svMESA(p: PGLshort); asmname 'glWindowPos4svMESA'; WINGDIAPI
procedure   glWindowPos4fvMESA(p: PGLfloat); asmname 'glWindowPos4fvMESA'; WINGDIAPI
procedure   glWindowPos4dvMESA(p: PGLdouble); asmname 'glWindowPos4dvMESA'; WINGDIAPI

procedure   glResizeBuffersMESA; asmname 'glResizeBuffersMESA'; WINGDIAPI

{== Implementation =========================================================}

implementation

begin
end.
