unit parse;
{ Liest die Daten der Treppe ein }

(*$I-*)

interface

uses
  Tools, Objects,
  szene_3d;

Procedure Parse(FileName: Str255);

implementation

uses
  Treppe3d;

var
  InFile: tDosStream;
  InputZeile: Str255;
  VorderflaecheAktiv,
  KommandoErreicht: Boolean;
  EckZahlPruefung : Word;
  Form, Command : Char;

procedure GetZeile;
begin
  InFile.ReadLine ( InputZeile );
  { Fr Unix CR ausfiltern }
  if InputZeile[length(InputZeile)] = #13 then
    InputZeile := InputZeile[1..length(InputZeile)-1];
  Inc(Row)
end;

function GetNum(NurZahlen: Boolean): MyReal;
var
  RetVal : MyReal;
  Code   : Integer;
begin
{
  if eof(t) then
    begin
      Abbruch('Dateiende bei Anforderung eines numerischen Parameters erreicht');
      Exit;
    end (* if *);
}
  GetZeile;
  KommandoErreicht := False;
  val(InputZeile, RetVal, Code);
  if Code > 0 then
    if  NurZahlen then
      begin
        Abbruch('fehlerhafter Input bei Anforderung eines numerischen Parameters: ' + InputZeile);
        Exit;
      end (* if *)
    else
      KommandoErreicht := True
  else
    InputZeile := '';
  GetNum := RetVal;
end;

function Get_Nums(Anzahl: Word; var RealArray: Array of MyReal; var Form: Char): Word;
{ "Anzahl" Parameter sollen in das Array eingelesen werden }
{ Bei Anzahl = 0 wird bis zum nchsten Commando gelesen }
var i : Word;
begin
  for i := 1 to MaxPar do RealArray[i] := 0;
  if Anzahl > 0 then begin
    if Anzahl > MaxPar then
      begin
        Abbruch('maximale Parameteranzahl berschritten');
        Exit;
      end (* if *);
    for i := 1 to Anzahl do begin
      Anzahl := Anzahl;
      RealArray[i] := GetNum(True);
      Anzahl := Anzahl;
    end
  end else begin
    i := 0;
    KommandoErreicht := False;
    repeat
      Inc(i);
      if i > MaxPar then
        begin
          Abbruch('maximale Parameteranzahl berschritten');
          Exit;
        end (* if *);
      RealArray[i] := GetNum(False);
    until KommandoErreicht;
    Get_Nums := i - 1;
  end
end;

procedure GetNums(Anzahl: Word; var RealArray: Array of MyReal; var Form: Char);
{ existiert nur, um die Fehlermeldung function called as a statement }
var i: Word;
begin
  i := Get_Nums(Anzahl, RealArray, Form);
end;


Procedure GetMaterial ( Const MaterialName: String );

Var
  r: array [ 0..MaxPar ] of MyReal;

begin (* GetMaterial *)
{
  if eof ( t ) then
    begin
      Abbruch ( 'Dateiende bei Anforderung des Materialparameters erreicht' );
      Exit;
    end (* if *);
}
  GetZeile;
  if InputZeile [ 1 ] = 'h' then
    begin
      SetzeMaterial ( TreppeGetTextureIndex ( InputZeile, MaterialName ) );
      GetNums ( 3, r, Form );
      SetzeMaterialVektor ( r [ 1 ], r [ 2 ], r [ 3 ] )
    end (* if *)
  else
    begin
      SetzeMaterial ( TreppeGetTextureIndex ( InputZeile, MaterialName ) );
      SetzeMaterialVektor ( 0, 0, 0 )
    end (* else *);
  InputZeile:= '';
end (* GetMaterial *);


{
Var
  DebugHeap: external Boolean;
}

Procedure Parse(FileName: Str255);
const
  KreisEckZahl = 12;
var
  i : Integer;
  EckZahl: Word;
  r : Array[0..MaxPar] of MyReal;
  kp : Array[0..9] of MyReal;

Procedure BerechneKreis;

Var
  i: Integer;
  M, U, V: glDoubleVector;
  s, c: Real;

begin (* BerechneKreis *)
  M.x:= kp [ 1 ];
  M.y:= kp [ 2 ];
  M.z:= kp [ 3 ];
  U.x:= kp [ 4 ] - M.x;
  U.y:= kp [ 5 ] - M.y;
  U.z:= kp [ 6 ] - M.z;
  V.x:= kp [ 7 ] - M.x;
  V.y:= kp [ 8 ] - M.y;
  V.z:= kp [ 9 ] - M.z;
  for i:= 0 to KreisEckZahl - 1 do
    begin
      s:= sin ( 2 * pi * i / KreisEckZahl );
      c:= cos ( 2 * pi * i / KreisEckZahl );
      r [ 3 * i + 1 ]:= M.x + c * U.x + s * V.x;
      r [ 3 * i + 2 ]:= M.y + c * U.y + s * V.y;
      r [ 3 * i + 3 ]:= M.z + c * U.z + s * V.z;
    end (* for *);
end (* BerechneKreis *);

begin
  ParsenAbgebrochen:= false;
  ParseDateiname:= pString ( @FileName );
  InFile.Init ( FileName, stOpenRead );
  if InFile.Status <> stOK then
    begin
      Abbruch ( 'Datei ' + FileName + ' nicht gefunden' );
      Exit;
    end (* if *);

  row := 0;

  GetZeile;

  {$IFDEF WRITE_PARSE_FEEDBACK }
  Assign(o, '___Daten.3D');
  Rewrite(o);
  {$ENDIF }
  if Lauflinie <> Nil then
    Dispose ( Lauflinie );
  Lauflinie:= Nil;
  VorderFlaecheAktiv := False;

  repeat
    GetZeile;
    if InFile.Status = stReadError then
      InputZeile:= 'Q'  (* Vermutlich EOF :-/ *)
    else if InFile.Status <> stOK then
      (* abbrechen *)
    else if ( length ( InputZeile ) = 1 )
       or ( ( length ( InputZeile ) > 1 )
            and ( InputZeile [ 1 ] = 'S' )
            and ( InputZeile [ 2 ] = ' ' ) ) then
      (* alles okay *)
    else
      begin
        Abbruch ( 'Kommando ist ungltig (Lnge): ' + InputZeile );
        InFile.Done;
        Exit;
      end (* else *);
    { Falls beim Einlesen der Parameter bis zum nchsten Kommando gelesen werden mute }
    Command := InputZeile[1];
    case Command of
      'A': begin
             GetNums(3, r, Form);
             SetzeVonWo(r[1], r[2], r[3]);
             TreppeSetEye(r[1], r[2], r[3]);
           end;
      'B': begin
             GetNums(3, r, Form);
             SetzeNachWo(r[1], r[2], r[3]);
             TreppeSetCenter(r[1], r[2], r[3]);
           end;
      'C': begin
             GetNums(1, r, Form);
             EckZahl:= round(r[1]);
             if Lauflinie <> Nil then
               Dispose ( Lauflinie );
             New ( Lauflinie, EckZahl );
             for i:= 1 to EckZahl do
               begin
                 GetNums(3, r, Form);
                 Lauflinie^[i].x:= r[1];
                 Lauflinie^[i].y:= r[2];
                 Lauflinie^[i].z:= r[3];
               end (* for *);
           end;
      'G': begin
             GetNums(3, r, Form);
             SetzeHintergrund(r[1], r[2], r[3]);
           end;
      'L': begin
             GetNums(6, r, Form);
             SetzeLicht(r[1], r[2], r[3], r[4], r[5], r[6]);
           end;
      'V': begin
             GetZeile;
             if InputZeile = 'P' then  (* Polygon *)
               begin
                 GetNums(1, r, Form);
                 EckZahl := round(r[1]);
                 GetNums(EckZahl * 3, r, Form);
                 Vorderflaeche(EckZahl, r, 'P');
               end (* if *)
             else if InputZeile = 'K' then  (* Kreis *)
               begin
                 GetNums(9, kp, Form);
                 BerechneKreis;
                 Vorderflaeche(KreisEckZahl, r, 'K');
               end (* if *)
             else
               begin
                 Abbruch('ungltiger Formtyp in Vorderflche');
                 InFile.Done;
                 Exit;
               end (* if *);
           end;
      'H': begin
             GetZeile;
             if InputZeile = 'P' then  (* Polygon *)
               begin
                 GetNums(1, r, Form);
                 EckZahl := round(r[1]);
                 GetNums(EckZahl * 3, r, Form);
                 Hinterflaeche(EckZahl, r, 'P');
               end (* if *)
             else if InputZeile = 'K' then  (* Kreis *)
               begin
                 GetNums(9, kp, Form);
                 BerechneKreis;
                 Hinterflaeche(KreisEckZahl, r, 'K');
               end (* if *)
             else
               begin
                 Abbruch('ungltiger Formtyp in Hinterflche');
                 InFile.Done;
                 Exit;
               end (* if *);
           end;
      'M': begin
             GetZeile;
             if InputZeile = 'P' then  (* Polygon *)
               begin
                 GetNums(1, r, Form);
                 EckZahl := round(r[1]);
                 GetNums(EckZahl * 3, r, Form);
                 Mittelflaeche(EckZahl, r, 'P');
               end (* if *)
             else if InputZeile = 'K' then  (* Kreis *)
               begin
                 GetNums(9, kp, Form);
                 BerechneKreis;
                 Mittelflaeche(KreisEckZahl, r, 'K');
               end (* if *)
             else
               begin
                 Abbruch('ungltiger Formtyp in Mittelflche');
                 InFile.Done;
                 Exit;
               end (* if *);
           end;
      'S': begin
             if length ( InputZeile ) > 2 then
               GetMaterial ( SubStr ( InputZeile, 3 ) )
             else
               GetMaterial ( '' )
           end;
      (*
      'B': begin
             EckZahl := GetNums(2, r, Form);
             SetzeBildGroese(r[1], r[2]);
           end;
      *)
      'F': begin
             EckZahl := Get_Nums(1, r, Form);
             SetzeBrennweite(r[1]);
           end;
      'O': begin
             GetNums(3, r, Form);
             SetzeWoOben(r[1], r[2], r[3]);
           end;
      'Q': { Hier wird das Parsen abgebrochen };
      else
        Abbruch('Unbekanntes Kommando: ' + InputZeile);
        InFile.Done;
        Exit;
      end;
  until ( Command = 'Q' )
        or ( InFile.Status <> stOK )
        or ParsenAbgebrochen;

  {$IFDEF WRITE_PARSE_FEEDBACK }
  Close(o);
  {$ENDIF }
  InFIle.Done;
end;


end.
