Unit StudioMain;


(*$I CompOpts.icl *)

(*$GNU-Pascal *)  (* Do not try to preserve compatibility to BP *)
                  (* even if specified in CompOpts.icl          *)

(*$ifdef __DJGPP__ *)
  (*$L glut_grx_djgpp *)
  (*$L GLU *)
  (*$L GL *)
(*$else *)
(*$ifdef _WIN32 *)
  (*$L glut_grx_mingw32 *)
  (*$L MesaGLU *)
  (*$L MesaGL *)
  (*$L vfs.c *)
(*$else *)
  (*$L glut_grx_linux *)
  (*$L MesaGLU *)
  (*$L MesaGL *)
  (*$L Xi *)
  (*$L Xmu *)
(*$endif *)
(*$endif *)

(*$L m *)
(*$L gpc *)


Interface


uses
  GPC, System, GRX,
  Tools, Maths, Objects, Drivers, Views, Windows, Dialogs, StdDlg, Fields,
  Menus, App, StdApp, Editors, Graphics, gStdRes,
  TgaUnit2,
  Glut, GL,
  Treppe3d, Szene_3d;


(*$ifdef W32_WORKAROUND *)

Var
  SigList: array [ 0..1023 ] of Byte; asmname '_sys_siglist';

(*$endif *)


Const
  cmRaytrace = 5000;

  cmDrahtgitter     = 5100;
  cmVerdeckteLinien = 5101;
  cmFlaechen        = 5102;
  cmTexturen        = 5103;

  cm3dAnsicht       = 5201;
  cmGrundriss       = 5202;
  cmLicht           = 5203;
  cmOberflaechen    = 5204;
  cmQualitaet       = 5205;

  cmMesaView          = 6001;
  cmStudioGraphEditor = 6002;
  cmLightDialog       = 6003;
  cmFaceDialog        = 6004;
  cmQualDialog        = 6005;
  cmParcour           = 6006;


Const
  ColorMask = $F0;


Const
  fdaAus = 0;
  fdaFarbe = 1;
  fdaTextur = 2;
  fdaBeides = 3;

  cColorSelBox = cStrSelBox;


Type
  t3dPoint = record
    x, y, z: Real;
  end (* t3dPoint *);

  tLightData = record
    Nr: Integer;
    x, y, z, I, Ambient,
      rBackground, gBackground, bBackground,
      rForeground, gForeground, bForeground: SoftReal;
    Relative: WordBool;
  end (* tLightData *);

  tFaceData = record
    NrName: String [ 255 ];
    Art: Word;
    r, g, b: SoftReal;
    FileName: fNameStr;
    MatType: Char;
    MatName: String [ 255 ];
    Nr: Word;
  end (* tFaceData *);

  tQualData = record
    Qualitaet: Integer;
  end (* tQualData *);


Type
  pContextView = ^tContextView;
  pMesaView = ^tMesaView;
  pColorSelBox = ^tColorSelBox;
  pColorSel = ^tColorSel;
  pTextureSelBox = ^tTextureSelBox;
  pTextureSel = ^tTextureSel;
  pStudioGraphEditor = ^tStudioGraphEditor;
  pLightDialog = ^tLightDialog;
  pFaceDialog = ^tFaceDialog;
  pQualDialog = ^tQualDialog;
  pStudioApplication = ^tStudioApplication;

  tContextView = object ( tView )
    ContextSize, Delta: tPoint;
    Context: GrContext;
    Constructor Init ( Var Bounds: tRect );
    Procedure NewContext ( width, height: Integer ); virtual;
    Procedure ChangeBounds ( Var Bounds: tRect ); virtual;
    Procedure Draw; virtual;
{
    Function DataSize: Word; virtual;
    Procedure SetData ( Var Rec ); virtual;
}
    Procedure HandleEvent ( Var Event: tEvent ); virtual;
  end (* tContextView *);

  tMesaView = object ( tContextView )
    Eye, Center, Direction: t3dPoint;
    Constructor Init ( Var Bounds: tRect );
    Procedure TreppeNeuZeichnen; virtual;
    Procedure NewContext ( width, height: Integer ); virtual;
    Procedure HandleEvent ( Var Event: tEvent ); virtual;
  end (* tMesaView *);

  tColorSelBox = object ( tListBox )
    Constructor Init ( Var Bounds: tRect; aNumCols: Word; aScrollBar: pScrollBar );
    Function GetPalette: pPalette; virtual;
    Procedure NewList ( aList: pCollection ); virtual;
    Procedure Draw; virtual;
    Procedure HandleEvent ( Var Event: tEvent ); virtual;
  end (* tColorSelBox *);

  tColorSel = object ( tHistory )
    RLink, GLink, BLink: pSoftRealInputLine;
    Constructor Init ( Var Bounds: tRect; aRLink, aGLink, aBLink: pSoftRealInputLine );
    Constructor Load ( Var S: tStream );
    Procedure Store ( Var S: tStream );
    Function InitHistoryWindow ( Var Bounds: tRect ): pHistoryWindow; virtual;
    Procedure HandleEvent ( Var Event: tEvent ); virtual;
  end (* tColorSel *);

  tTextureSelBox = object ( tColorSelBox )
    Rep: tPoint;
    DeltaY: Integer;
    Context: GrContext;
    Constructor Init ( Var Bounds: tRect; aNumCols: Word; aScrollBar: pScrollBar;
                       Const aDirectory, aMask: String; xRep, yRep: Integer );
    Destructor Done; virtual;
    Procedure Draw; virtual;
    Procedure HandleEvent ( Var Event: tEvent ); virtual;
  end (* tTextureSelBox *);

  tTextureSel = object ( tHistory )
    Rep: tPoint;
    Directory, Mask: pString;
    Constructor Init ( Var Bounds: tRect; aLink: pInputLine;
                       Const aDirectory, aMask: String; xRep, yRep: Integer );
    Destructor Done; virtual;
    Function InitHistoryWindow ( Var Bounds: tRect ): pHistoryWindow; virtual;
    Procedure HandleEvent ( Var Event: tEvent ); virtual;
  end (* tTextureSel *);

  tStudioGraphEditor = object ( tRealGraphScroller )
    Constructor Init ( Var Bounds: tRect );
    Procedure DrawLightPos ( x, y, Intensity: Real );
    Procedure Draw; virtual;
    Procedure HandleEvent ( Var Event: tEvent ); virtual;
  end (* tStudioGraphEditor *);

  tLightDialog = object ( tDialog )
    Constructor Init ( Const aTitle: String; aNumber: Integer );
    Procedure HandleEvent ( Var Event: tEvent ); virtual;
  end (* tLightDialog *);

  tFaceDialog = object ( tDialog )
    NrNameField: pInputLine;
    ArtField: pRadioButtons;
    RField, GField, BField: pSoftRealInputLine;
    NameField: pInputLine;
    ColorSel: pColorSel;
    NrNameStrSel: pStrSel;
    NameTextureSel: pTextureSel;
    ContextView: pContextView;
    Constructor Init ( Const aTitle: String; aNumber: Integer );
    Procedure SetData ( Var Rec ); virtual;
    Procedure HandleEvent ( Var Event: tEvent ); virtual;
  end (* tFaceDialog *);

  tQualDialog = object ( tDialog )
    QualField: pIntInputLine;
    Constructor Init ( Const aTitle: String; aNumber: Integer );
    Procedure HandleEvent ( Var Event: tEvent ); virtual;
  end (* tQualDialog *);

  tStudioApplication = object ( tStdApplication )
    Constructor Init;
    Procedure DoLoadFile ( Var aFileName: fNameStr ); virtual;
    Procedure HandleEvent ( Var Event: tEvent ); virtual;
  end (* tStudioApplication *);


Var
  StudioApplication: tStudioApplication;
  GlobalLightData: tLightData value ( 1, 100, 100, 300, 100, 50, 50, 50, 100, 100, 100, 70 );
  GlobalFaceData: tFaceData value ( '', fdaTextur, 20, 20, 20, 'rauh1.tga' );
  GlobalQualData: tQualData value ( Qualitaet: 1 );
  PlaneFactor: Real = 1.0;
  

Implementation


Const
  lsYellow = 0;
  lsWhite = 1;
  lsGreen = 2;
  lsRed = 3;
  lsBlue = 4;


Const
  IntensityEye = -1.0;
{  IntensityWall = IntensityEye; }
  IntensityCenter = -2.0;


Const
  IntensityFactor = 100;


Procedure Zeichne3dAnsicht;

Var
  M: pMesaView;

begin (* Zeichne3dAnsicht *)
  M:= Message ( DeskTop, evBroadcast, cmMesaView, Nil );
  if M <> Nil then
    M^.Owner^.Select;
end (* Zeichne3dAnsicht *);


Procedure ZeichneGrundriss;

Var
  R: tRect;
  W: pWindow;
  G: pStudioGraphEditor;

begin (* ZeichneGrundriss *)
  G:= Message ( DeskTop, evBroadcast, cmStudioGraphEditor, Nil );
  if G <> Nil then
    G^.Owner^.Select
  else
    begin
      DeskTop^.GetExtent ( R );
      dec ( R.B.x, 25 * CharWidth );
      W:= New ( pWindow, Init ( R, 'Grundri', GetWinNumber ) );
      with W^ do
        begin
          Options:= Options or ofFirstClick;
          GetInterior ( R );
          G:= New ( pStudioGraphEditor, Init ( R ) );
          G^.Graphic.UseLineStyle ( lsGreen );
          TreppeProjection ( @G^.Graphic, 1, 0, 0, 0, 1, 0 );
          G^.AdjustSize;
          Insert ( G );
        end (* with *);
      DeskTop^.Insert ( W );
    end (* else *);
end (* ZeichneGrundriss *);


Procedure LichtDialog;

Var
  D: pLightDialog;

begin (* LichtDialog *)
  D:= Message ( DeskTop, evBroadcast, cmLightDialog, Nil );
  if D <> Nil then
    D^.Select
  else
    begin
      D:= New ( pLightDialog, Init ( 'Licht', GetWinNumber ) );
      D^.SetData ( GlobalLightData );
      DeskTop^.Insert ( D );
    end (* else *);
end (* LichtDialog *);


Procedure OberflaechenDialog;

Var
  D: pFaceDialog;

begin (* OberflaechenDialog *)
  D:= Message ( DeskTop, evBroadcast, cmFaceDialog, Nil );
  if D <> Nil then
    D^.Select
  else
    begin
      D:= New ( pFaceDialog, Init ( 'Oberflchen', GetWinNumber ) );
      D^.SetData ( GlobalFaceData );
      DeskTop^.Insert ( D );
    end (* else *);
end (* OberflaechenDialog *);


Procedure QualitaetDialog;

Var
  D: pQualDialog;

begin (* QualitaetDialog *)
  D:= Message ( DeskTop, evBroadcast, cmQualDialog, Nil );
  if D <> Nil then
    D^.Select
  else
    begin
      D:= New ( pQualDialog, Init ( 'Qualitt', GetWinNumber ) );
      D^.SetData ( GlobalQualData );
      DeskTop^.Insert ( D );
    end (* else *);
end (* QualitaetDialog *);


Constructor tContextView.Init ( Var Bounds: tRect );

begin (* tContextView.Init *)
  inherited Init ( Bounds );
  Options:= Options or ofSelectable;
  Delta.x:= 0;
  Delta.y:= 0;
  ContextSize.x:= 0;
  ContextSize.y:= 0;
end (* tContextView.Init *);


Procedure tContextView.NewContext ( width, height: Integer );
  
begin (* tContextView.NewContext *)
  Delta.x:= max ( 0, min ( ContextSize.x - width, Delta.x ) );
  Delta.y:= max ( 0, min ( ContextSize.y - height, Delta.y ) );
end (* tContextView.NewContext *);


Procedure tContextView.ChangeBounds ( Var Bounds: tRect );

begin (* tContextView.ChangeBounds *)
  with Bounds do
    NewContext ( B.x - A.x, B.y - A.y );
  inherited ChangeBounds ( Bounds );
end (* tContextView.ChangeBounds *);


{

Function tContextView.DataSize: Integer;

begin (* tContextView.DataSize *)
  DataSize:= SizeOf ( GrContextPtr );
end (* tContextView.DataSize *);


Procedure tContextView.SetData ( Var Rec );

begin (* tContextView.SetData *)
  GrBitBlt ( @Context, 0, 0, GrContextPtr ( Rec ),
             0, 0, ContextSize.x - 1, ContextSize.y - 1, GrWrite );
end (* tContextView.SetData *);

}


Procedure tContextView.HandleEvent ( Var Event: tEvent );

Var
  SaveName: fNameStr;
  TA: ^TexturArrayT;
  i, j: Integer;
  C: GrColor;
  SubContext: GrContextPtr;

Const
  Step: tPoint = ( 10, 10 );

begin (* tContextView.HandleEvent *)
  case Event.what of
    evCommand:
      case Event.Command of
        cmDown:
          begin
            Delta.y:= min ( ContextSize.y - Size.y, Delta.y + Step.y );
            DrawView;
            ClearEvent ( Event );
          end (* cmDown *);
        cmUp:
          begin
            Delta.y:= max ( 0, Delta.y - Step.y );
            DrawView;
            ClearEvent ( Event );
          end (* cmUp *);
        cmLeft:
          begin
            Delta.x:= max ( 0, Delta.x - Step.x );
            DrawView;
            ClearEvent ( Event );
          end (* cmLeft *);
        cmRight:
          begin
            Delta.x:= min ( ContextSize.x - Size.x, Delta.x + Step.x );
            DrawView;
            ClearEvent ( Event );
          end (* cmRight *);
        cmHome:
          begin
            Delta.x:= 0;
            Delta.y:= 0;
            DrawView;
            ClearEvent ( Event );
          end (* cmHome *);
        cmSave, cmSaveAs:
          begin
            SaveName:= '*.jpg';
            if ExecDialog ( 'NewName', @SaveName ) <> cmCancel then
              begin
                if Copy ( SaveName, length ( SaveName ) - 3, 4 ) = '.tga' then
                  begin
                    Delete ( SaveName, length ( SaveName ) - 3, 4 );
                    with ContextSize do
                      begin
                        New ( TA, x * y * 3 );
                        for i:= 0 to y - 1 do
                          for j:= 0 to x - 1 do
                            begin
                              C:= GrPixelC ( @Context, j, y - 1 - i );
                              TA^ [ i * x * 3 + j * 3 + 0 ]:= GrRGBColorRed ( C );
                              TA^ [ i * x * 3 + j * 3 + 1 ]:= GrRGBColorGreen ( C );
                              TA^ [ i * x * 3 + j * 3 + 2 ]:= GrRGBColorBlue ( C );
                            end (* for *);
                        SaveScreen2TGA ( SaveName, TA^, x, y );
                        Dispose ( TA );
                      end (* with *);
                  end (* if *)
{
                else if Copy ( SaveName, length ( SaveName ) - 3, 4 ) = '.tif' then
                  begin
                    SubContext:= GrCreateSubContext ( 0, 0, Size.x - 1, Size.y - 1, Context, Null );
                    SaveContextToTiff ( SubContext, SaveName, 0, SaveName );
                    GrDestroyContext ( SubContext^ );
                  end (* else if *)
}
                else
                  begin
                    SubContext:= GrCreateSubContext ( 0, 0, Size.x - 1, Size.y - 1, Context, Null );
                    if Copy ( SaveName, length ( SaveName ) - 3,4 ) <> '.jpg' then
                      SaveName:= SaveName + '.jpg';
{                    SaveContextToJpeg ( SubContext, SaveName, 75 ); !!!}
                    GrDestroyContext ( SubContext );
                  end (* else *);
              end (* if *);
            ClearEvent ( Event );
          end (* cmSave, cmSaveAs *);
      end (* case *);
    evBroadcast:
      case Event.Command of
        cmSave:
          ClearEvent ( Event );
      end (* case *);
  end (* case *);
  inherited HandleEvent ( Event );
end (* tContextView.HandleEvent *);


Procedure tContextView.Draw;

Var
  O: tPoint;
  x, y: Integer;

begin (* tContextView.Draw *)
  O.x:= 0;
  O.y:= 0;
  MakeGlobal ( O, O );
  with CurrentClipRect do
    if not empty then
      begin
        MakeLocal(A, O);
{        Peter!!! Bei Deiner Variante fehlt unten und rechts eine Pixelzeile!!!
        PutGRXcontext ( A.x, A.y, @Context,
                        O.x + Delta.x, O.y + Delta.y, O.x + B.x - A.x - 1,
                        O.y + B.y - A.y - 1,
                        GrWrite );
        (* = GrBitBlt ( GrScreenContext, ... ) mit BO4-Clipping *)
}
        GrBitBltNC( GrScreenContext, A.x, A.y, @Context,
                        O.x + Delta.x, O.y + Delta.y,
                        O.x + Delta.x + B.x - A.x - 1,
                        O.y + Delta.y + B.y - A.y - 1,
                        GrWrite ); 
      end (* if *);
end (* tContextView.Draw *);


Constructor tMesaView.Init ( Var Bounds: tRect );

begin (* tMesaView.Init *)
  inherited Init ( Bounds );
  Eye.x:= 0;
  Eye.y:= 0;
  Eye.z:= 0;
  Center.x:= 0;
  Center.y:= 0;
  Center.z:= 0;
  Direction.x:= 0;
  Direction.y:= 0;
  Direction.z:= 0;
end (* tMesaView.Init *);


Procedure tMesaView.TreppeNeuZeichnen;

Function DrawAbbruch: Boolean;

Const
  relevant = GR_M_KEYPRESS or GR_M_BUTTON_DOWN or GR_M_BUTTON_UP;

begin (* DrawAbbruch *)
{
  if PendingEvent.flags and relevant = 0 then
    GrMouseGetEventT ( GR_M_EVENT, @PendingEvent, 0 );
  DrawAbbruch:= PendingEvent.flags and relevant <> 0;
}
  DrawAbbruch:= false;
end (* DrawAbbruch *);

Procedure Phase ( Faktor: Integer );

Var
  TempSize: tPoint;
  TempContext: GrContextPtr;
  Color: GrColor;
  x, y, xx, yy, i, j, r, g, b: Integer;
  rS, gS, bS: Real;

begin (* Phase *)
  if Faktor < 1 then
    begin
      TempSize.x:= ( 2 - Faktor ) * ContextSize.x;
      TempSize.y:= ( 2 - Faktor ) * ContextSize.y;
    end (* if *)
  else
    begin
      TempSize.x:= ( ContextSize.x + Faktor - 1 ) div Faktor;
      TempSize.y:= ( ContextSize.y + Faktor - 1 ) div Faktor;
    end (* else *);
  TreppeReshape ( TempSize.x, TempSize.y );
  TreppeSetPlanes ( PlaneFactor );
  if Faktor = 1 then
    begin
      GrSetContext ( @Context );
      TreppeDraw;
    end (* if *)
  else if Faktor < 1 then
    begin
      TempContext:= GrCreateContext ( TempSize.x, TempSize.y, Nil, Null );
{      GRXSetFrontContext ( TempContext );  (* Ist wahrscheinlich unntig *) }
      GrSetContext ( TempContext );
      TreppeDraw;
{      GRXSetFrontContext ( @Context );  (* Ist wahrscheinlich unntig *) }
      GrSetContext ( @Context );
      for y:= 0 to ContextSize.y - 1 do
        for x:= 0 to ContextSize.x - 1 do
          begin
            xx:= ( 2 - Faktor ) * x;
            yy:= ( 2 - Faktor ) * y;
            rS:= 0;
            gS:= 0;
            bS:= 0;
            for j:= 0 to 1 - Faktor do
              for i:= 0 to 1 - Faktor do
                begin
                  Color:= GrPixelC ( TempContext, xx + i, yy + j );
                  GrQueryColor ( Color, r, g, b );
                  rS:= rS + r;
                  gS:= gS + g;
                  bS:= bS + b;
                end (* for *);
            rS:= rS / sqr ( 2 - Faktor );
            gS:= gS / sqr ( 2 - Faktor );
            bS:= bS / sqr ( 2 - Faktor );
            GrPlot ( x, y, GrAllocColor ( round ( rS ) and ColorMask,
                                          round ( gS ) and ColorMask,
                                          round ( bS ) and ColorMask ) );
          end (* for *);
      GrDestroyContext ( TempContext );
    end (* else if *)
  else
    begin
      TempContext:= GrCreateContext ( TempSize.x, TempSize.y, Nil, Null );
{      GRXSetFrontContext ( TempContext );  (* Ist wahrscheinlich unntig *) }
      GrSetContext ( TempContext );
      TreppeDraw;
{      GRXSetFrontContext ( @Context );  (* Ist wahrscheinlich unntig *) }
      GrSetContext ( @Context );
      for y:= 0 to TempSize.y - 1 do
        for x:= 0 to TempSize.x - 1 do
          GrFilledBox ( x * Faktor, y * Faktor,
                        x * Faktor + Faktor - 1, y * Faktor + Faktor - 1,
                        GrPixelC ( TempContext, x, y ) );
      GrDestroyContext ( TempContext );
    end (* else *);
  GrSetContext ( GrScreenContext );
  if not DrawAbbruch then
    DrawView;
end (* Phase *);

begin (* tMesaView.TreppeNeuZeichnen *)
  if not DrawAbbruch then
    Phase ( GlobalQualData.Qualitaet );
end (* tMesaView.TreppeNeuZeichnen *);


Procedure tMesaView.NewContext ( width, height: Integer );
  
Var
  RetPtr : GrContextPtr;
  
begin (* tMesaView.NewContext *)
  (* Neuen Kontext von der Gre (width,height) anlegen *)
  ContextSize.x:= width;
  ContextSize.y:= height;
  TreppeNeuZeichnen;
  inherited NewContext ( width, height );
end (* tMesaView.NewContext *);


Procedure tMesaView.HandleEvent ( Var Event: tEvent );

Const
  Step = 10;
  rStep = 0.9;
  wStep = 5 * pi / 180;

Var
  x, y, z, x0, y0, z0, dx, dy, dz, r, r2, sintheta1, theta1, sintheta2, theta2: Real;
  Mouse: tPoint;

begin (* tMesaView.HandleEvent *)
  case Event.what of
    evMouseDown:
      if PointInView ( Event.where ) then
        begin
          MakeLocal ( Event.where, Mouse );
          Treppe2dTo3d ( Mouse.x, Mouse.y, x0, y0, z0 );
          TreppeSetCenter ( x0, y0, z0 );
        end (* if *);
    evKeyDown:
      case UpCase [ Event.CharCode ] of
        'D':
          begin
            TreppeViewMode ( vmLine );
            PlaneFactor:= 3.0;
            ClearEvent ( Event );
          end (* 'D' *);
        'V':
          begin
            TreppeViewMode ( vmHidden );
            PlaneFactor:= 3.0;
            ClearEvent ( Event );
          end (* 'V' *);
        'F':
          begin
            TreppeViewMode ( vmFlat );
            PlaneFactor:= 1.0;
            ClearEvent ( Event );
          end (* 'F' *);
        'T':
          begin
            TreppeViewMode ( vmTextS );
            PlaneFactor:= 1.0;
            ClearEvent ( Event );
          end (* 'T' *);
        '+':
          begin
            TreppeGetEye ( x, y, z );
            TreppeGetCenter ( x0, y0, z0 );
            x:= x0 + ( x - x0 ) * rStep;
            y:= y0 + ( y - y0 ) * rStep;
            z:= z0 + ( z - z0 ) * rStep;
            TreppeSetEye ( x, y, z );
            ClearEvent ( Event );
          end (* '+' *);
        '-':
          begin
            TreppeGetEye ( x, y, z );
            TreppeGetCenter ( x0, y0, z0 );
            x:= x0 + ( x - x0 ) / rStep;
            y:= y0 + ( y - y0 ) / rStep;
            z:= z0 + ( z - z0 ) / rStep;
            TreppeSetEye ( x, y, z );
            ClearEvent ( Event );
          end (* '-' *);
        ' ':
          begin
            TreppeGetEye ( x, y, z );
            TreppeGetCenter ( x0, y0, z0 );
            dx:= x - x0;
            dy:= y - y0;
            r:= sqrt ( sqr ( dx ) + sqr ( dy ) );
            dx:= dx / r * Step;
            dy:= dy / r * Step;
            TreppeSetEye ( x - dx, y - dy, z );
            TreppeSetCenter ( x0 - dx, y0 - dy, z0 );
            ClearEvent ( Event );
          end (* ' ' *);

        { Alles nur testweise, kann dann wieder weg          }
        { wenn entschieden ist, wann und wie TreppeSetPlane  }
        { automatisch aufgerufen wird                        }
        { Man knnte auch eine manuelle Steuerung drinlassen }
        { und wahlweise eine Automatik ein- und ausschalten  }
        '!':
          begin
            TreppeSetPlanes(1.0);
            ClearEvent ( Event );
          end (* '!' SH *);
        '"':
          begin
            TreppeSetPlanes(1.5);
            ClearEvent ( Event );
          end (* '"' SH *);
        '':
          begin
            TreppeSetPlanes(2);
            ClearEvent ( Event );
          end (* '' SH *);
        '$':
          begin
            TreppeSetPlanes(3);
            ClearEvent ( Event );
          end (* '$' SH *);
        '%':
          begin
            TreppeSetPlanes(4);
            ClearEvent ( Event );
          end (* '%' SH *);
        '&':
          begin
            TreppeSetPlanes(5);
            ClearEvent ( Event );
          end (* '&' SH *);
      end (* case *);
{
        'x': TreppePos(-1,0,0);
        'X': TreppePos(+1,0,0);
        'y': TreppePos(0,-1,0);
        'Y': TreppePos(0,+1,0);
        'z': TreppePos(0,0,-1);
        'Z': TreppePos(0,0,+1);
        'e', 'E': TreppePosMode(pmEye);
        'c', 'C': TreppePosMode(pmCenter);
        'l', 'L': TreppePosMode(pmLight);
        'f', 'F': TreppeFilterMode(-1);
        '.': TreppeViewMode(-1);
        '!': TreppeSetPlanes(1);
        '"': TreppeSetPlanes(2);
        't', 'T': Treppe2TGA('TestTGA');
}
    evCommand:
      case Event.Command of
        cmDrahtgitter:
          begin
            TreppeViewMode ( vmLine );
            PlaneFactor:= 3.0;
            ClearEvent ( Event );
          end (* cmDrahtgitter *);
        cmVerdeckteLinien:
          begin
            TreppeViewMode ( vmHidden );
            PlaneFactor:= 3.0;
            ClearEvent ( Event );
          end (* cmVerdeckteLinien *);
        cmFlaechen:
          begin
            TreppeViewMode ( vmFlat );
            PlaneFactor:= 1.0;
            ClearEvent ( Event );
          end (* cmFlaechen *);
        cmTexturen:
          begin
            TreppeViewMode ( vmTextS );
            PlaneFactor:= 1.0;
            ClearEvent ( Event );
          end (* cmTexturen *);
        cmDown:
          begin
            TreppeGetEye ( x, y, z );
            TreppeSetEye ( x, y, z - Step );
            TreppeGetCenter ( x, y, z );
            TreppeSetCenter ( x, y, z - Step );
            ClearEvent ( Event );
          end (* cmDown *);
        cmUp:
          begin
            TreppeGetEye ( x, y, z );
            TreppeSetEye ( x, y, z + Step );
            TreppeGetCenter ( x, y, z );
            TreppeSetCenter ( x, y, z + Step );
            ClearEvent ( Event );
          end (* cmUp *);
        cmLeft:
          begin
            if Event.KeybFlag and kbCtrl <> 0 then
              begin
                TreppeGetEye ( x, y, z );
                TreppeGetCenter ( x0, y0, z0 );
                dx:= x - x0;
                dy:= y - y0;
                r:= sqrt ( sqr ( dx ) + sqr ( dy ) );
                dx:= dx / r * Step;
                dy:= dy / r * Step;
                TreppeSetEye ( x + dy, y - dx, z );
                TreppeSetCenter ( x0 + dy, y0 - dx, z0 );
              end (* if *)
            else
              begin
                TreppeGetCenter ( x0, y0, z0 );
                TreppeGetEye ( x, y, z );
                r:= sqrt ( sqr ( x - x0 ) + sqr ( y - y0 ) );
                if r < 100 then
                  begin
                    x0:= x + 100 / r * ( x0 - x );
                    y0:= y + 100 / r * ( y0 - y );
                    TreppeSetCenter ( x0, y0, z0 );
                  end (* if *);
                dx:= x - x0;
                dy:= y - y0;
                x:= x0 + cos ( wStep ) * dx + sin ( wStep ) * dy;
                y:= y0 + cos ( wStep ) * dy - sin ( wStep ) * dx;
                TreppeSetEye ( x, y, z );
              end (* else *);
            ClearEvent ( Event );
          end (* cmLeft *);
        cmRight:
          begin
            if Event.KeybFlag and kbCtrl <> 0 then
              begin
                TreppeGetEye ( x, y, z );
                TreppeGetCenter ( x0, y0, z0 );
                dx:= x - x0;
                dy:= y - y0;
                r:= sqrt ( sqr ( dx ) + sqr ( dy ) );
                dx:= dx / r * Step;
                dy:= dy / r * Step;
                TreppeSetEye ( x - dy, y + dx, z );
                TreppeSetCenter ( x0 - dy, y0 + dx, z0 );
              end (* if *)
            else
              begin
                TreppeGetCenter ( x0, y0, z0 );
                TreppeGetEye ( x, y, z );
                r:= sqrt ( sqr ( x - x0 ) + sqr ( y - y0 ) );
                if r < 100 then
                  begin
                    x0:= x + 100 / r * ( x0 - x );
                    y0:= y + 100 / r * ( y0 - y );
                    TreppeSetCenter ( x0, y0, z0 );
                  end (* if *);
                dx:= x - x0;
                dy:= y - y0;
                x:= x0 + cos ( wStep ) * dx - sin ( wStep ) * dy;
                y:= y0 + cos ( wStep ) * dy + sin ( wStep ) * dx;
                TreppeSetEye ( x, y, z );
              end (* else *);
            ClearEvent ( Event );
          end (* cmRight *);
        cmBackSpace:
          begin
            TreppeGetEye ( x, y, z );
            TreppeGetCenter ( x0, y0, z0 );
            dx:= x - x0;
            dy:= y - y0;
            r:= sqrt ( sqr ( dx ) + sqr ( dy ) );
            dx:= dx / r * Step;
            dy:= dy / r * Step;
            TreppeSetEye ( x + dx, y + dy, z );
            TreppeSetCenter ( x0 + dx, y0 + dy, z0 );
            ClearEvent ( Event );
          end (* cmBackSpace *);
        cmHome:
          begin
            TreppeSetEye ( Eye.x, Eye.y, Eye.z );
            TreppeSetCenter ( Center.x, Center.y, Center.z );
            ClearEvent ( Event );
          end (* cmHome *);
        cmPgUp:
          begin
            TreppeGetCenter ( x0, y0, z0 );
            TreppeGetEye ( x, y, z );
            dx:= x - x0;
            dy:= y - y0;
            dz:= z - z0;
            r2:= sqr ( dx ) + sqr ( dy ) + sqr ( dz );
            if r2 > 0 then
              begin
                r:= sqrt ( r2 );
                sintheta1:= sqrt ( ( sqr ( dx ) + sqr ( dy ) ) / r2 );
                theta1:= arcsin ( sintheta1 );
                if dz < 0 then
                  theta1:= pi - theta1;
                theta2:= max ( pi / 180, theta1 - wStep );
                sintheta2:= sin ( theta2 );
                x:= x0 + dx * sintheta2 / sintheta1;
                y:= y0 + dy * sintheta2 / sintheta1;
                z:= z0 + r * cos ( theta2 );
                TreppeSetEye ( x, y, z );
              end (* if *);
            ClearEvent ( Event );
          end (* cmPgUp *);
        cmPgDn:
          begin
            TreppeGetCenter ( x0, y0, z0 );
            TreppeGetEye ( x, y, z );
            dx:= x - x0;
            dy:= y - y0;
            dz:= z - z0;
            r2:= sqr ( dx ) + sqr ( dy ) + sqr ( dz );
            if r2 > 0 then
              begin
                r:= sqrt ( r2 );
                sintheta1:= sqrt ( ( sqr ( dx ) + sqr ( dy ) ) / r2 );
                theta1:= arcsin ( sintheta1 );
                if dz < 0 then
                  theta1:= pi - theta1;
                theta2:= min ( pi - pi / 180, theta1 + wStep );
                sintheta2:= sin ( theta2 );
                x:= x0 + dx * sintheta2 / sintheta1;
                y:= y0 + dy * sintheta2 / sintheta1;
                z:= z0 + r * cos ( theta2 );
                TreppeSetEye ( x, y, z );
              end (* if *);
            ClearEvent ( Event );
          end (* cmPgDn *);
      end (* case *);
    evBroadcast:
      case Event.Command of
        cmUpdate:
          if TreppeChanged then
            TreppeNeuZeichnen;
        cmMesaView:
          ClearEvent ( Event );
      end (* evBroadcast *);
  end (* case *);
  inherited HandleEvent ( Event );
end (* tMesaView.HandleEvent *);


Constructor tColorSelBox.Init ( Var Bounds: tRect; aNumCols: Word;
                                aScrollBar: pScrollBar );

begin (* tColorSelBox.Init *)
  inherited Init ( Bounds, aNumCols, aScrollBar );
  SetRange ( 64 );
end (* tColorSelBox.Init *);


Function tColorSelBox.GetPalette: pPalette;

Const
  P: String [ length ( cColorSelBox ) ] = cColorSelBox;

begin (* tColorSelBox.GetPalette *)
  GetPalette:= pPalette ( @P );
end (* tColorSelBox.GetPalette *);


Procedure tColorSelBox.NewList ( aList: pCollection );

Var
  i: Integer;

begin (* tColorSelBox.NewList *)
  if List <> Nil then
    Dispose ( List, Done );
  List:= aList;
  if Range > 0 then
    FocusItem ( 0 );
  if Selector <> Nil then
    Dispose ( Selector, Done );
  Selector:= Nil;
  DrawView;
end (* tColorSelBox.NewList *);


Function SelectedColor ( Index: Integer ): GrColor;

Const
  T: array [ 0..3 ] of Integer = ( 0, 85, 169, 255 );

begin (* SelectedColor *)
  SelectedColor:= GrAllocColor ( T [ Index and $03 ] and ColorMask,
                                 T [ ( Index shr 2 ) and $03 ] and ColorMask,
                                 T [ ( Index shr 4 ) and $03 ] and ColorMask );
end (* SelectedColor *);


Procedure tColorSelBox.Draw;

Var
  B: tDrawBuffer;
  i, j, k: Integer;
  SelColor, NormColor, TlgColor: Byte;
  P, D: tPoint;

begin (* tColorSelBox.Draw *)
  if GetState ( sfSelected ) then
    begin
      SelColor:= GetColor ( 3 );
      NormColor:= GetColor ( 1 );
    end (* if *)
  else
    begin
      SelColor:= GetColor ( 4 );
      NormColor:= GetColor ( 2 );
    end (* else *);
  TlgColor:= GetColor ( 5 );
  D.x:= Size.x div 8;
  D.y:= Size.y div 8;
  for i:= 0 to 7 do
    for j:= 0 to 7 do
      begin
        P.x:= j * D.x;
        P.y:= i * D.y;
        MakeGlobal ( P, P );
        k:= 8 * i + j;
        GrFilledBox ( P.x, P.y, P.x + D.x - 1, P.y + D.y - 1, SelectedColor ( k ) );
        if k = Focused then
          begin
            GrFilledBox ( P.x, P.y, P.x + D.x - 1, P.y + 1, SelColor );
            GrFilledBox ( P.x, P.y + 2, P.x + 1, P.y + D.y - 3, SelColor );
            GrFilledBox ( P.x, P.y + D.y - 2, P.x + D.x - 1, P.y + D.y - 1, NormColor );
            GrFilledBox ( P.x + D.x - 2, P.y + 2, P.x + D.x - 1, P.y + D.y - 3, NormColor );
          end (* if *);
      end (* for *);
  SetCursor ( ( Focused mod 8 ) * D.x + D.x div 2 - CharWidth div 2,
              ( Focused div 8 ) * D.y + D.y div 2 - CharHeight + 2 );
end (* tColorSelBox.Draw *);


Procedure tColorSelBox.HandleEvent ( Var Event: tEvent );

Var
  P, D: tPoint;

begin (* tColorSelBox.HandleEvent *)
  if ( ( Event.what = evMouseDown ) and ( Event.Double ) )
     or ( ( Event.what = evCommand ) and ( Event.Command = cmEnter ) ) then
    begin
      EndModal ( cmOk );
      ClearEvent ( Event );
    end (* if *)
  else if ( Event.what = evCommand ) and ( Event.Command = cmCancel ) then
    begin
      EndModal ( cmCancel );
      ClearEvent ( Event );
    end (* else if *)
  else if ( Event.what = evMouseDown ) and PointInView ( Event.where ) then
    begin
      MakeLocal ( Event.where, P );
      D.x:= Size.x div 8;
      D.y:= Size.y div 8;
      Focused:= 8 * ( P.y div D.y ) + P.x div D.x;
      DrawView;
    end (* else if *)
  else
    tListBox.HandleEvent ( Event );
end (* tColorSelBox.HandleEvent *);


Constructor tColorSel.Init ( Var Bounds: tRect; aRLink, aGLink, aBLink: pSoftRealInputLine );

begin (* tColorSel.Init *)
  inherited Init ( Bounds, aRLink, 0 );
  RLink:= aRLink;
  GLink:= aGLink;
  BLink:= aBLink;
end (* tColorSel.Init *);


Constructor tColorSel.Load ( Var S: tStream );

begin (* tColorSel.Load *)
  inherited Load ( S );
  GetPeerViewPtr ( S, RLink );
  GetPeerViewPtr ( S, GLink );
  GetPeerViewPtr ( S, BLink );
end (* tColorSel.Load *);


Procedure tColorSel.Store ( Var S: tStream );

begin (* tColorSel.Store *)
  inherited Store ( S );
  PutPeerViewPtr ( S, RLink );
  PutPeerViewPtr ( S, GLink );
  PutPeerViewPtr ( S, BLink );
end (* tColorSel.Store *);


Function tColorSel.InitHistoryWindow ( Var Bounds: tRect ): pHistoryWindow;

Var
  R: tRect;
  P: pHistoryWindow;

begin (* tColorSel.InitHistoryWindow *)
  P:= New ( pHistoryWindow, Init ( Bounds, HistoryID ) );
  P^.HelpCtx:= Link^.HelpCtx;
  P^.HelpStr:= CopyStr ( HistoryHelpStr );
  P^.Palette:= wpBlackWindow;
  with P^ do
    begin
      GetInterior ( R );
      Insert ( New ( pColorSelBox, Init ( R, 1, Nil ) ) );
    end (* with *);
  Message ( P, evBroadcast, cmCheckFrame, Nil );
  InitHistoryWindow:= P;
end (* tColorSel.InitHistoryWindow *);


Procedure tColorSel.HandleEvent ( Var Event: tEvent );

Var
  HistoryWindow: pWindow;
  R: tRect;
  C: Word;
  ResultColor: GrColor;
  ResultReal: SoftReal;
  ListBoxData: tListBoxData;

begin (* tColorSel.HandleEvent *)
  tView.HandleEvent ( Event );  (* *nicht* tHistory.HandleEvent! *)
  if ( Event.what = evMouseDown )
     or ( ( Event.what = evCommand )
          and ( Event.Command = cmDown )
          and ( Link^.State and sfFocused <> 0 ) ) then
    begin
      Link^.Select;
      R.Assign ( 0, 0, ( 8 * 4 + 2 ) * CharWidth, ( 8 * 2 + 2 ) * CharHeight );
      HistoryWindow:= InitHistoryWindow ( R );
      if HistoryWindow <> Nil then
        begin
          ListBoxData.List:= Nil;
          ListBoxData.Selection:= 0;
          with HistoryWindow^ do
            begin
              Options:= Options or ofCentered;
              SetData ( ListBoxData );
            end (* with *);
          C:= DeskTop^.ExecView ( HistoryWindow );
          if C = cmOk then
            begin
              HistoryWindow^.GetData ( ListBoxData );
              ResultColor:= SelectedColor ( ListBoxData.Selection );
              ResultReal:= 100 * GrRGBColorRed ( ResultColor ) / 255;
              RLink^.SetData ( ResultReal );
              ResultReal:= 100 * GrRGBColorGreen ( ResultColor ) / 255;
              GLink^.SetData ( ResultReal );
              ResultReal:= 100 * GrRGBColorBlue ( ResultColor ) / 255;
              BLink^.SetData ( ResultReal );
              Message ( Application, evBroadcast, cmChanged, @Self );
            end (* if *);
          Dispose ( HistoryWindow, Done );
        end (* if *);
      ClearEvent ( Event );
    end (* if *)
  else if Event.What = evBroadcast then
    if Event.Command = cmHistory then
      ClearEvent ( Event );
end (* tColorSel.HandleEvent *);


Constructor tTextureSelBox.Init ( Var Bounds: tRect; aNumCols: Word; aScrollBar: pScrollBar;
                                  Const aDirectory, aMask: String; xRep, yRep: Integer );

Var
  DD: tPoint;
  D: DirPtr;
  S: String255;
  i, ymax: Integer;
  TempList: pCollection;


Procedure ReadTexture ( Nr: Integer; Const Name: String );

Var
  x, y: LongInt;
  dx, dy, i, j: Integer;
  TA: ^TexturArrayT;
  pName: pString;

begin (* ReadTexture *)
  (* TGA-Datei laden *)
  x:= 0;
  y:= 0;
  (* Der erste Aufruf ermittelt nur die Ausmae *)
  ReadTGAFile ( Name, Null, x, y );
  if x + y > 0 then
    begin
      (* 3 Byte pro Pixel reservieren *)
      New ( TA, x * y * 3 );
      if not ReadTGAFile ( Name, TA^, x, y ) then
        begin
          pName:= pString ( @Name );
          ExecDialog ( 'ReadErr', @pName );
        end (* if *)
      else
        begin
          dx:= ( Nr mod Rep.x ) * DD.x;
          dy:= ( Nr div Rep.x ) * DD.y;
          GrSetContext ( @Context );
          for i:= 0 to min ( DD.y, y ) - 1 do
            for j:= 0 to min ( DD.x, x ) - 1 do      
              GrPlot ( dx + j, dy + i,
                       GrAllocColor ( TA^ [ i * x * 3 + j * 3 + 0 ] and ColorMask,
                                      TA^ [ i * x * 3 + j * 3 + 1 ] and ColorMask,
                                      TA^ [ i * x * 3 + j * 3 + 2 ] and ColorMask ) );
          GrSetContext ( GrScreenContext );
        end (* else *);
      Dispose(TA);
    end (* if *);
end (* ReadTexture *);


begin (* tTextureSelBox.Init *)
  tListBox.Init ( Bounds, aNumCols, aScrollBar );
  Rep.x:= xRep;
  Rep.y:= yRep;
  DeltaY:= 0;
  DD.x:= Size.x div Rep.x;
  DD.y:= Size.y div Rep.y;
  D:= OpenDir ( aDirectory );
  i:= 0;
  if D <> Nil then
    begin
      repeat
        S:= ReadDir ( D );
        if FileNameMatch ( aMask, S ) then
          inc ( i );
      until S = '';
      CloseDir ( D );
    end (* if *);
  ymax:= ( i + Rep.x - 1 ) div Rep.x * DD.y;
  GrCreateContext ( Size.x, max ( Size.y, ymax ), Nil, Context );
  GrSetContext ( @Context );
  GrFilledBox ( 0, 0, Size.x - 1, max ( Size.y, ymax ) - 1, GRXcolor [ lightgray ] );
  GrSetContext ( GrScreenContext );
  TempList:= New ( pCollection, Init ( 16, 16, coStrings ) );
  D:= OpenDir ( aDirectory );
  i:= 0;
  if D <> Nil then
    begin
      repeat
        S:= ReadDir ( D );
        if FileNameMatch ( aMask, S ) then
          begin
            TempList^.Insert ( NewStr ( S ) );
            ReadTexture ( i, S );
            inc ( i );
          end (* if *);
      until S = '';
      CloseDir ( D );
    end (* if *);
  NewList ( TempList );
  if vScrollBar <> Nil then
    vScrollBar^.SetParams ( 0, 0, max ( 0, ymax - Size.y ),
                            max ( DD.y, Size.y - DD.y ), DD.y );
end (* tTextureSelBox.Init *);


Destructor tTextureSelBox.Done;

begin (* tTextureSelBox.Done *)
  GrDestroyContext ( @Context );
  inherited Done;
end (* tTextureSelBox.Done *);


Procedure tTextureSelBox.Draw;

Var
  i, j, k: Integer;
  SelColor, NormColor, TlgColor: Byte;
  O, P, D: tPoint;

begin (* tTextureSelBox.Draw *)
  D.x:= Size.x div Rep.x;
  D.y:= Size.y div Rep.y;
  with CurrentClipRect do
    if not empty then
      begin
        MakeLocal ( A, O );
        inc ( O.y, DeltaY );
        GrBitBltNC ( GrScreenContext, A.x, A.y, @Context,
                     O.x, O.y,
                     O.x + B.x - A.x - 1,
                     O.y + B.y - A.y - 1,
                     GrWrite ); 
      end (* if *);
  if GetState ( sfSelected ) then
    begin
      SelColor:= GetColor ( 3 );
      NormColor:= GetColor ( 1 );
    end (* if *)
  else
    begin
      SelColor:= GetColor ( 4 );
      NormColor:= GetColor ( 2 );
    end (* else *);
  TlgColor:= GetColor ( 5 );
  for i:= 0 to ( List^.Count + Rep.x - 1 ) div Rep.x do
    for j:= 0 to Rep.x - 1 do
      begin
        P.x:= j * D.x;
        P.y:= i * D.y;
        MakeGlobal ( P, P );
        dec ( P.y, DeltaY );
        k:= Rep.x * i + j;
        if k = Focused then
          begin
            GrFilledBox ( P.x, P.y, P.x + D.x - 1, P.y + 1, SelColor );
            GrFilledBox ( P.x, P.y + 2, P.x + 1, P.y + D.y - 3, SelColor );
            GrFilledBox ( P.x, P.y + D.y - 2, P.x + D.x - 1, P.y + D.y - 1, NormColor );
            GrFilledBox ( P.x + D.x - 2, P.y + 2, P.x + D.x - 1, P.y + D.y - 3, NormColor );
          end (* if *);
      end (* for *);
  SetCursor ( ( Focused mod Rep.x ) * D.x + D.x div 2 - CharWidth div 2,
              ( Focused div Rep.x ) * D.y + D.y div 2 - CharHeight + 2 - DeltaY );
end (* tTextureSelBox.Draw *);


Procedure tTextureSelBox.HandleEvent ( Var Event: tEvent );

Var
  P, D: tPoint;

begin (* tTextureSelBox.HandleEvent *)
  if ( ( Event.what = evMouseDown ) and ( Event.Double ) )
     or ( ( Event.what = evCommand ) and ( Event.Command = cmEnter ) ) then
    begin
      EndModal ( cmOk );
      ClearEvent ( Event );
    end (* if *)
  else if ( Event.what = evCommand ) and ( Event.Command = cmCancel ) then
    begin
      EndModal ( cmCancel );
      ClearEvent ( Event );
    end (* else if *)
  else if ( Event.what = evMouseDown ) and PointInView ( Event.where ) then
    begin
      MakeLocal ( Event.where, P );
      inc ( P.y, DeltaY );
      D.x:= Size.x div Rep.x;
      D.y:= Size.y div Rep.y;
      Focused:= 8 * ( P.y div D.y ) + P.x div D.x;
      DrawView;
    end (* else if *)
  else if ( Event.what = evBroadcast )
          and ( Event.Command = cmChanged )  
          and ( Event.InfoPtr = vScrollBar ) then
    begin
      DeltaY:= vScrollBar^.SBValue;
      DrawView;
    end
  else
    tListBox.HandleEvent ( Event );
end (* tTextureSelBox.HandleEvent *);


Constructor tTextureSel.Init ( Var Bounds: tRect; aLink: pInputLine;
                               Const aDirectory, aMask: String; xRep, yRep: Integer );

begin (* tTextureSel.Init *)
  inherited Init ( Bounds, aLink, 0 );
  Directory:= NewStr ( aDirectory );
  Mask:= NewStr ( aMask );
  Rep.x:= xRep;
  Rep.y:= yRep;
end (* tTextureSel.Init *);


Destructor tTextureSel.Done;

begin (* tTextureSel.Done *)
  DisposeStr ( Directory );
  DisposeStr ( Mask );
  inherited Done;
end (* tTextureSel.Done *);


(* Load und Store braucht man normalerweise auch noch. *)


Function tTextureSel.InitHistoryWindow ( Var Bounds: tRect ): pHistoryWindow;

Var
  R: tRect;
  P: pHistoryWindow;

begin (* tTextureSel.InitHistoryWindow *)
  P:= New ( pHistoryWindow, Init ( Bounds, HistoryID ) );
  P^.HelpCtx:= Link^.HelpCtx;
  P^.HelpStr:= CopyStr ( HistoryHelpStr );
  P^.Palette:= wpBlackWindow;
  with P^ do
    begin
      GetInterior ( R );
      Insert ( New ( pTextureSelBox,
        Init ( R, 1, StandardScrollBar ( sbVertical ), Directory^, Mask^, Rep.x, Rep.y ) ) );
    end (* with *);
  Message ( P, evBroadcast, cmCheckFrame, Nil );
  InitHistoryWindow:= P;
end (* tTextureSel.InitHistoryWindow *);


Procedure tTextureSel.HandleEvent ( Var Event: tEvent );

Var
  HistoryWindow: pWindow;
  R: tRect;
  C: Word;
  ListBoxData: tListBoxData;

begin (* tTextureSel.HandleEvent *)
  tView.HandleEvent ( Event );  (* *nicht* tHistory.HandleEvent! *)
  if ( Event.what = evMouseDown )
     or ( ( Event.what = evCommand )
          and ( Event.Command = cmDown )
          and ( Link^.State and sfFocused <> 0 ) ) then
    begin
      Link^.Select;
      R.Assign ( 0, 0,
                 ( ScreenWidth * 8 div 10 ) div Rep.x * Rep.x + 2 * CharWidth,
                 ( ScreenHeight * 8 div 10 ) div Rep.y * Rep.y + 2 * CharHeight );
      HistoryWindow:= InitHistoryWindow ( R );
      if HistoryWindow <> Nil then
        begin
          ListBoxData.List:= Nil;
          ListBoxData.Selection:= 0;
          with HistoryWindow^ do
            begin
              Options:= Options or ofCentered;
{              SetData ( ListBoxData ); }
            end (* with *);
          C:= DeskTop^.ExecView ( HistoryWindow );
          if C = cmOk then
            begin
              HistoryWindow^.GetData ( ListBoxData );
              with ListBoxData do
                Link^.SetData ( pString ( List^.At ( Selection ) )^ );
              Message ( Application, evBroadcast, cmChanged, @Self );
            end (* if *);
          Dispose ( HistoryWindow, Done );
        end (* if *);
      ClearEvent ( Event );
    end (* if *)
  else if Event.What = evBroadcast then
    if Event.Command = cmHistory then
      ClearEvent ( Event );
end (* tTextureSel.HandleEvent *);


Constructor tStudioGraphEditor.Init ( Var Bounds: tRect );

begin (* tStudioGraphEditor.Init *)
  inherited Init ( Bounds, Nil, Nil );
  DefLineStyle ( lsYellow, 1, lsSolid, 1, 1 );
  DefLineStyle ( lsWhite, 2, lsSolid, 1, 1 );
  DefLineStyle ( lsGreen, 3, lsSolid, 1, 1 );
  DefLineStyle ( lsRed, 5, lsSolid, 1, 1 );
  DefLineStyle ( lsBlue, 4, lsSolid, 1, 1 );
end (* tStudioGraphEditor.Init *);


Procedure tStudioGraphEditor.DrawLightPos ( x, y, Intensity: Real );

Const
  d = 5.0;

begin (* tStudioGraphEditor.DrawLightPos *)
  if Intensity = IntensityEye then
    UseLineStyle ( lsWhite )
  else if Intensity = IntensityCenter then
    UseLineStyle ( lsBlue )
  else if Intensity > 0 then
    UseLineStyle ( lsYellow )
  else
    UseLineStyle ( lsRed );
  Line ( x - d, y, x + d, y );
  Line ( x, y - d, x, y + d );
end (* tStudioGraphEditor.DrawLightPos *);


Procedure tStudioGraphEditor.Draw;

Var
  i: Integer;
  x0, y0, x, y, z, Intensity: Real;

begin (* tStudioGraphEditor.Draw *)
  inherited Draw;
  TreppeGetEye ( x, y, z );
  DrawLightPos ( x, y, IntensityEye );
  TreppeGetCenter ( x, y, z );
  DrawLightPos ( x, y, IntensityCenter );
  for i:= 0 to MaxLightPos do
    begin
      TreppeGetLightPos ( i, x, y, z, Intensity );
      DrawLightPos ( x, y, Intensity );
    end (* for *);
  TreppeGetRoom ( 0, x0, y0 );
end (* tStudioGraphEditor.Draw *);


Procedure tStudioGraphEditor.HandleEvent ( Var Event: tEvent );

Const
  delta = 10;

Var
  found, DIsave: Boolean;
  j: Integer;
  x, y, z, I: Real;
  Mouse: tPoint;
  MouseReal: tRealPoint;

begin (* tStudioGraphEditor.HandleEvent *)
  case Event.what of
    evMouseDown:
      begin
        MakeLocal ( Event.where, Mouse );
        IntToReal ( Mouse, MouseReal );
        j:= 0;
        found:= false;
        while ( j <= MaxLightPos ) and not found do
          begin
            TreppeGetLightPos ( j, x, y, z, I );
            if sqr ( MouseReal.x - x ) + sqr ( MouseReal.y - y ) < sqr ( delta ) then
              found:= true
            else
              inc ( j );
          end (* while *);
        if found then
          begin
            GlobalLightData.Nr:= j + 1;
            GlobalLightData.I:= I * IntensityFactor;
            DIsave:= DrawInvers;
            (*$W-*) DrawInvers:= true; (*$W+*)
            repeat
              DrawLightPos ( x, y, I );
              MakeLocal ( Event.where, Mouse );
              IntToReal ( Mouse, MouseReal );
              x:= MouseReal.x;
              y:= MouseReal.y;
              DrawLightPos ( x, y, I );
            until not MouseEvent ( Event, evMouseMove );
            DrawInvers:= DIsave;
            DrawLightPos ( x, y, I );
            TreppeSetLightPos ( j, x, y, z, I );
            GlobalLightData.x:= x;
            GlobalLightData.y:= y;
            Message ( Application, evBroadcast, cmChanged, @GlobalLightData );
            ClearEvent ( Event );
          end (* if *)
        else
          begin
{
            j:= 0;
            found:= false;
            while ( j < GlobalQualData.Punkte ) and not found do
              begin
                TreppeGetRoom ( j, x, y );
                if sqr ( MouseReal.x - x ) + sqr ( MouseReal.y - y ) < sqr ( delta ) then
                  found:= true
                else
                  inc ( j );
              end (* while *);
            if found then
              begin
                GlobalWallData.Nr:= j;
                DIsave:= DrawInvers;
                (*$W-*) DrawInvers:= true; (*$W+*)
                repeat
                  DrawLightPos ( x, y, IntensityWall );
                  MakeLocal ( Event.where, Mouse );
                  IntToReal ( Mouse, MouseReal );
                  x:= MouseReal.x;
                  y:= MouseReal.y;
                  DrawLightPos ( x, y, IntensityWall );
                until not MouseEvent ( Event, evMouseMove );
                DrawInvers:= DIsave;
                TreppeSetRoom ( j, x, y );
                GlobalWallData.x:= x;
                GlobalWallData.y:= y;
                Message ( Application, evBroadcast, cmChanged, @GlobalWallData );
                DrawView;
                ClearEvent ( Event );
              end (* if *)
            else
              begin
}
                TreppeGetEye ( x, y, z );
                if sqr ( MouseReal.x - x ) + sqr ( MouseReal.y - y ) < sqr ( delta ) then
                  begin
                    DIsave:= DrawInvers;
                    (*$W-*) DrawInvers:= true; (*$W+*)
                    repeat
                      DrawLightPos ( x, y, IntensityEye );
                      MakeLocal ( Event.where, Mouse );
                      IntToReal ( Mouse, MouseReal );
                      x:= MouseReal.x;
                      y:= MouseReal.y;
                      DrawLightPos ( x, y, IntensityEye );
                    until not MouseEvent ( Event, evMouseMove );
                    DrawInvers:= DIsave;
                    DrawLightPos ( x, y, IntensityEye );
                    TreppeSetEye ( x, y, z );
                    DrawView;
                    ClearEvent ( Event );
                  end (* if *)
                else
                  begin
                    TreppeGetCenter ( x, y, z );
                    if sqr ( MouseReal.x - x ) + sqr ( MouseReal.y - y ) < sqr ( delta ) then
                      begin
                        DIsave:= DrawInvers;
                        (*$W-*) DrawInvers:= true; (*$W+*)
                        repeat
                          DrawLightPos ( x, y, IntensityCenter );
                          MakeLocal ( Event.where, Mouse );
                          IntToReal ( Mouse, MouseReal );
                          x:= MouseReal.x;
                          y:= MouseReal.y;
                          DrawLightPos ( x, y, IntensityCenter );
                        until not MouseEvent ( Event, evMouseMove );
                        DrawInvers:= DIsave;
                        DrawLightPos ( x, y, IntensityCenter );
                        TreppeSetCenter ( x, y, z );
                        DrawView;
                        ClearEvent ( Event );
                      end (* if *);
                  end (* else *);
{
              end (* else *);
}
          end (* else *);
      end (* evMouseDown *);
    evBroadcast:
      case Event.Command of
        cmChanged:
          if Event.InfoPtr = @GlobalLightData then
            DrawView;
        cmStudioGraphEditor:
          ClearEvent ( Event );
      end (* case *);
  end (* case *);
  inherited HandleEvent ( Event );
end (* tStudioGraphEditor.HandleEvent *);


Constructor tLightDialog.Init ( Const aTitle: String; aNumber: Integer );

Var 
  IntensityField, AmbientIntensityField, NameField: pInputLine;
  RField, GField, BField: pSoftRealInputLine;
  ColorSel: pColorSel;
  xx, yy, zz, II: Real;

begin (* tLightDialog.Init *)
  BeginRectData;
  RectData ( '*************************' );
  RectData ( '*                       *' );
  RectData ( '*aaaaaaaaaaaaaAAAAAAAAA *' );
  RectData ( '*                       *' );
  RectData ( '* jjjjjjjjjjjjjjjjjjjjj *' );
  RectData ( '*xxxxxxxxxxxxxXXXXXXXXX *' );
  RectData ( '*yyyyyyyyyyyyyYYYYYYYYY *' );
  RectData ( '*zzzzzzzzzzzzzZZZZZZZZZ *' );
  RectData ( '*                       *' );
  RectData ( '*iiiiiiiiiiiiiIIIIIIIII *' );
  RectData ( '*JJJJJJJJJJJJJJJJJJJJJJ *' );
  RectData ( '*                       *' );
  RectData ( '*kkkkkkkkkkkkkkkkkkkkkk *' );
  RectData ( '*lllllllllllllLLLLLLLLL *' );
  RectData ( '*MMMMMMMMMMMMMMMMMMMMMM *' );
  RectData ( '*                       *' );
  RectData ( '* fffffffffffffffffffff *' );
  RectData ( '*  FFF  rrrrrrRRRRRRRRR *' );
  RectData ( '*       ggggggGGGGGGGGG *' );
  RectData ( '*       bbbbbbBBBBBBBBB *' );
  RectData ( '*                       *' );
  RectData ( '* hhhhhhhhhhhhhhhhhhhhh *' );
  RectData ( '*  HHH  nnnnnnNNNNNNNNN *' );
  RectData ( '*       ooooooOOOOOOOOO *' );
  RectData ( '*       ppppppPPPPPPPPP *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*************************' );
  EndRectData;
  inherited Init ( GetRect ( '*' )^, aTitle );
  Number:= aNumber;
  Options:= ( Options and not ofCentered ) or ( ofRight or ofFirstClick );
  Insert ( New ( pIntInputLine, Init ( GetRect ( 'A' )^, 10, 1, 8 ) ) );
  AddLabel ( @Self, 'a', '~L~icht Nr.:' );
  Insert ( New ( pStaticText, Init ( GetRect ( 'j' )^, 'Koordinaten:' ) ) );
  Insert ( New ( pSoftRealInputLine, Init ( GetRect ( 'X' )^, 10, 2 ) ) );
  AddLabel ( @Self, 'x', '~x~:' );
  Insert ( New ( pSoftRealInputLine, Init ( GetRect ( 'Y' )^, 10, 2 ) ) );
  AddLabel ( @Self, 'y', '~y~:' );
  Insert ( New ( pSoftRealInputLine, Init ( GetRect ( 'Z' )^, 10, 2 ) ) );
  AddLabel ( @Self, 'z', '~H~he:' );
  IntensityField:= New ( pSoftRealInputLine, Init ( GetRect ( 'I' )^, 10, 2 ) );
  Insert ( IntensityField );
  AddLabel ( @Self, 'i', '~I~ntensitt:' );
  Insert ( New ( pSoftRealScrollBar, Init ( GetRect ( 'J' )^, 0, 100, IntensityField ) ) );
  AmbientIntensityField:= New ( pSoftRealInputLine, Init ( GetRect ( 'L' )^, 10, 2 ) );
  Insert ( AmbientIntensityField );
  AddLabel ( @Self, 'k', '~A~mbiente Beleuchtung' );
  AddLabel ( @Self, 'l', 'Intensitt:' );
  Insert ( New ( pSoftRealScrollBar, Init ( GetRect ( 'M' )^, 0, 100, AmbientIntensityField ) ) );
  Insert ( New ( pStaticText, Init ( GetRect ( 'f' )^, 'Hintergrundfarbe:' ) ) );
  RField:= New ( pSoftRealInputLine, Init ( GetRect ( 'R' )^, 10, 2 ) );
  Insert ( RField );
  AddLabel ( @Self, 'r', '~R~ot:' );
  GField:= New ( pSoftRealInputLine, Init ( GetRect ( 'G' )^, 10, 2 ) );
  Insert ( GField );
  AddLabel ( @Self, 'g', '~G~rn:' );
  BField:= New ( pSoftRealInputLine, Init ( GetRect ( 'B' )^, 10, 2 ) );
  Insert ( BField );
  AddLabel ( @Self, 'b', '~B~lau:' );
  ColorSel:= New ( pColorSel, Init ( GetRect ( 'F' )^, RField, GField, BField ) );
  Insert ( ColorSel );
  Insert ( New ( pStaticText, Init ( GetRect ( 'h' )^, 'Vordergrundfarbe:' ) ) );
  RField:= New ( pSoftRealInputLine, Init ( GetRect ( 'N' )^, 10, 2 ) );
  Insert ( RField );
  AddLabel ( @Self, 'n', '~R~ot:' );
  GField:= New ( pSoftRealInputLine, Init ( GetRect ( 'O' )^, 10, 2 ) );
  Insert ( GField );
  AddLabel ( @Self, 'o', '~G~rn:' );
  BField:= New ( pSoftRealInputLine, Init ( GetRect ( 'P' )^, 10, 2 ) );
  Insert ( BField );
  AddLabel ( @Self, 'p', '~B~lau:' );
  ColorSel:= New ( pColorSel, Init ( GetRect ( 'H' )^, RField, GField, BField ) );
  Insert ( ColorSel );
  with GlobalLightData do
    begin
      Nr:= 1;
      TreppeGetLightPos ( 0, xx, yy, zz, II );
      x:= xx;
      y:= yy;
      z:= zz;
      I:= II * IntensityFactor;
    end (* with *);
  SetData ( GlobalLightData );
end (* tLightDialog.Init *);


Procedure tLightDialog.HandleEvent ( Var Event: tEvent );


Procedure UpdateGlobalLightData;

begin (* UpdateGlobalLightData *)
  GetData ( GlobalLightData );
  with GlobalLightData do
    begin
      TreppeSetLightPos ( Nr - 1, x, y, z, I / IntensityFactor );
      TreppeSetLightAmbient ( Ambient / IntensityFactor );
      TreppeSetBackgroundColor ( rBackground / IntensityFactor,
                                 gBackground / IntensityFactor,
                                 bBackground / IntensityFactor );
      TreppeSetForegroundColor ( rForeground / IntensityFactor,
                                 gForeground / IntensityFactor,
                                 bForeground / IntensityFactor );
    end (* with *);
  Message ( Application, evBroadcast, cmChanged, @GlobalLightData );
end (* UpdateGlobalLightData *);


begin (* tLightDialog.HandleEvent *)
  inherited HandleEvent ( Event );
  case Event.what of
    evBroadcast:
      case Event.Command of
        cmBye:
          UpdateGlobalLightData;
        cmLightDialog:
          ClearEvent ( Event );
        cmChanged:
          if Event.InfoPtr = @GlobalLightData then
            SetData ( GlobalLightData )
          else if IndexOf ( Event.InfoPtr ) > 0 then
            UpdateGlobalLightData;
      end (* case *);      
  end (* case *);
end (* tLightDialog.HandleEvent *);


Function TexDataName ( Index: Integer ) = Result: String255;

Var
  Art: Word;
  r, g, b: Real;
  MatType: Char;
  MatName, FileName: String255;

begin (* TexDataName *)
  TreppeGetTexture ( Index, Art, r, g, b, MatType, MatName, FileName );
  if MatName = '' then
    Result:= MatType
  else
    Result:= MatName;
end (* TexDataName *);


Constructor tFaceDialog.Init ( Const aTitle: String; aNumber: Integer );

Var
  i: Integer;
  rr, gg, bb: Real;

begin (* tFaceDialog.Init *)
  BeginRectData;
  RectData ( '*************************' );
  RectData ( '*                       *' );
  RectData ( '* AAAAAAAAAAAAAAAAAAaaa *' );
  RectData ( '*                       *' );
  RectData ( '* CCCCCCCCCCCCCCCCCCCCC *' );
  RectData ( '* CCCCCCCCCCCCCCCCCCCCC *' );
  RectData ( '* CCCCCCCCCCCCCCCCCCCCC *' );
  RectData ( '* CCCCCCCCCCCCCCCCCCCCC *' );
  RectData ( '*                       *' );
  RectData ( '* ffffffrrrrrrRRRRRRRRR *' );
  RectData ( '*  FFF  ggggggGGGGGGGGG *' );
  RectData ( '*       bbbbbbBBBBBBBBB *' );
  RectData ( '*                       *' );
  RectData ( '*nnnnnnnnnnnnnnnnnnnnnn *' );
  RectData ( '* NNNNNNNNNNNNNNNNNNmmm *' );
  RectData ( '*                       *' );
  RectData ( '* XXXXXXXXXXXXXXXXXXXXX *' );
  RectData ( '* X                   X *' );
  RectData ( '* X                   X *' );
  RectData ( '* X                   X *' );
  RectData ( '* X                   X *' );
  RectData ( '* X                   X *' );
  RectData ( '* X                   X *' );
  RectData ( '* X                   X *' );
  RectData ( '* X                   X *' );
  RectData ( '* X                   X *' );
  RectData ( '* XXXXXXXXXXXXXXXXXXXXX *' );
  RectData ( '*************************' );
  EndRectData;
  inherited Init ( GetRect ( '*' )^, aTitle );
  Number:= aNumber;
  Options:= ( Options and not ofCentered ) or ( ofRight or ofFirstClick );
{
  NrField:= New ( pRadioButtons, Init ( GetRect ( 'A' )^,
    NewSItem ( TexDataName ( 0 ),
    NewSItem ( TexDataName ( 1 ),
    NewSItem ( TexDataName ( 2 ),
    NewSItem ( TexDataName ( 3 ),
    NewSItem ( TexDataName ( 4 ),
    NewSItem ( TexDataName ( 5 ),
    NewSItem ( TexDataName ( 6 ),
    NewSItem ( TexDataName ( 7 ),
    Nil ) ) ) ) ) ) ) ) ) );
  Insert ( NrField );
}
  NrNameField:= New ( pInputLine, Init ( GetRect ( 'A' )^, 255 ) );
  Insert ( NrNameField );
  NrNameStrSel:= New ( pStrSel, Init ( GetRect ( 'a' )^, NrNameField ) );
  Insert ( NrNameStrSel );
  for i:= 0 to TexDataCount - 1 do
    NrNameStrSel^.Strings^.Insert ( NewStr ( TexDataName ( i ) ) );
  ArtField:= New ( pRadioButtons, Init ( GetRect ( 'C' )^,
    NewSItem ( '~A~us',
    NewSItem ( '~F~arbe',
    NewSItem ( '~T~extur',
    NewSItem ( '~B~eides',
    Nil ) ) ) ) ) );
  Insert ( ArtField );
  Insert ( New ( pStaticText, Init ( GetRect ( 'f' )^, 'Farbe:' ) ) );
  RField:= New ( pSoftRealInputLine, Init ( GetRect ( 'R' )^, 10, 2 ) );
  Insert ( RField );
  AddLabel ( @Self, 'r', '~R~ot:' );
  GField:= New ( pSoftRealInputLine, Init ( GetRect ( 'G' )^, 10, 2 ) );
  Insert ( GField );
  AddLabel ( @Self, 'g', '~G~rn:' );
  BField:= New ( pSoftRealInputLine, Init ( GetRect ( 'B' )^, 10, 2 ) );
  Insert ( BField );
  AddLabel ( @Self, 'b', '~B~lau:' );
  ColorSel:= New ( pColorSel, Init ( GetRect ( 'F' )^, RField, GField, BField ) );
  Insert ( ColorSel );
  NameField:= New ( pInputLine, Init ( GetRect ( 'N' )^, fNameStrCapacity ) );
  Insert ( NameField );
  AddLabel ( @Self, 'n', '~D~ateiname:' );
  NameTextureSel:= New ( pTextureSel,
                         Init ( GetRect ( 'm' )^, NameField, '.', '*.tga', 8, 6 ) );
  Insert ( NameTextureSel );
  ContextView:= New ( pContextView, Init ( GetRect ( 'X' )^ ) );
  with ContextView^ do
    begin
      GrCreateContext ( Size.x, Size.y, Nil, Context );
      GrSetContext ( @Context );
      GrFilledBox ( 0, 0, Size.x - 1, Size.y - 1, GRXcolor [ 7 ] );
      GrSetContext ( GrScreenContext );
    end (* with *);
  Insert ( ContextView );
  with GlobalFaceData do
    begin
      Nr:= 0;
      NrName:= TexDataName ( 0 );
      TreppeGetTexture ( Nr, Art, rr, gg, bb, MatType, MatName, FileName );
      r:= 100 * rr;
      g:= 100 * gg;
      b:= 100 * bb;
    end (* with *);
  SetData ( GlobalFaceData );
  SelectNext ( false );
  SelectNext ( false );
end (* tFaceDialog.Init *);


Procedure tFaceDialog.SetData ( Var Rec );

Var
  Textur: Boolean;
  FileName: fNameStr;
  i, j, x, y: LongInt;
  TA: ^TexturArrayT;

begin (* tFaceDialog.SetData *)
  with tFaceData ( Rec ) do
    begin
      Nr:= 0;
      while ( Nr < TexDataCount ) and ( TexDataName ( Nr ) <> NrName ) do
        inc ( Nr );
      Textur:= Art = fdaTextur;
    end (* with *);
  inherited SetData ( Rec );
  RField^.SetState ( sfDisabled, Textur );
  GField^.SetState ( sfDisabled, Textur );
  BField^.SetState ( sfDisabled, Textur );
  NameField^.SetState ( sfDisabled, not Textur );
  NameField^.GetData ( FileName );
  x:= 0;
  y:= 0;
  GrSetContext ( @ContextView^.Context );
  if not Textur then
    with ContextView^, GlobalFaceData do
      GrFilledBox ( 0, 0, Size.x - 1, Size.y - 1,
                    GrAllocColor ( Trunc ( 255.99 / 100 * r ) and ColorMask,
                                   Trunc ( 255.99 / 100 * g ) and ColorMask,
                                   Trunc ( 255.99 / 100 * b ) and ColorMask ) )
  else
    begin
      with ContextView^, GlobalFaceData do
        GrFilledBox ( 0, 0, Size.x - 1, Size.y - 1, GRXcolor [ 7 ] );
      if FileName <> '' then
        begin
          if ReadTGAFile ( FileName, Null, x, y ) then;
          New ( TA, x * y * 3 );
          ReadTGAFile ( FileName, TA^, x, y );
          for i:= 0 to y - 1 do
            for j:= 0 to x - 1 do      
              GrPlot ( j, i, GrAllocColor ( TA^ [ i * x * 3 + j * 3 + 0 ] and ColorMask,
                                            TA^ [ i * x * 3 + j * 3 + 1 ] and ColorMask,
                                            TA^ [ i * x * 3 + j * 3 + 2 ] and ColorMask ) );
          Dispose ( TA );
        end (* if *);
    end (* else *);
  GrSetContext ( GrScreenContext );
  ContextView^.DrawView;
end (* tFaceDialog.SetData *);


Procedure tFaceDialog.HandleEvent ( Var Event: tEvent );

Var
  rr, gg, bb: Real;


Procedure UpdateGlobalFaceData;

begin (* UpdateGlobalFaceData *)
  with GlobalFaceData do
    begin
      GetData ( GlobalFaceData );
      Nr:= 0;
      while ( Nr < TexDataCount ) and ( TexDataName ( Nr ) <> NrName ) do
        inc ( Nr );
      TreppeSetTexture ( Nr, Art, 0.01 * r, 0.01 * g, 0.01 * b, MatType, MatName, FileName );
    end (* with *);
  Message ( Application, evBroadcast, cmChanged, @GlobalFaceData );
end (* UpdateGlobalFaceData *);


begin (* tFaceDialog.HandleEvent *)
  inherited HandleEvent ( Event );
  case Event.what of
    evBroadcast:
      case Event.Command of
        cmBye:
          UpdateGlobalFaceData;
        cmFaceDialog:
          ClearEvent ( Event );
        cmChanged:
          if Event.InfoPtr = @GlobalFaceData then
            SetData ( GlobalFaceData )
          else if ( Event.InfoPtr = NrNameField ) or ( Event.InfoPtr = NrNameStrSel ) then
            begin
              GetData ( GlobalFaceData );
              with GlobalFaceData do
                begin
                  Nr:= 0;
                  while ( Nr < TexDataCount ) and ( TexDataName ( Nr ) <> NrName ) do
                    inc ( Nr );
                  TreppeGetTexture ( Nr, Art, rr, gg, bb, MatType, MatName, FileName );
                  r:= 100 * rr;
                  g:= 100 * gg;
                  b:= 100 * bb;
                end (* with *);
              SetData ( GlobalFaceData );
              UpdateGlobalFaceData;
            end (* if *)
          else if IndexOf ( Event.InfoPtr ) > 0 then
            UpdateGlobalFaceData;
      end (* case *);      
  end (* case *);
end (* tFaceDialog.HandleEvent *);


Constructor tQualDialog.Init ( Const aTitle: String; aNumber: Integer );

begin (* tQualDialog.Init *)
  BeginRectData;
  RectData ( '*************************' );
  RectData ( '*                       *' );
  RectData ( '*qqqqqqqqqqqqqQQQQQQQQQ *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*                       *' );
  RectData ( '*************************' );
  EndRectData;
  inherited Init ( GetRect ( '*' )^, aTitle );
  QualField:= New ( pIntInputLine, Init ( GetRect ( 'Q' )^, 10, 0, 8 ) );
  Insert ( QualField );
  AddLabel ( @Self, 'q', '~Q~ualitt' );
  Number:= aNumber;
  Options:= ( Options and not ofCentered ) or ( ofRight or ofFirstClick );
  SetData ( GlobalQualData );
end (* tQualDialog.Init *);


Procedure tQualDialog.HandleEvent ( Var Event: tEvent );


Procedure UpdateGlobalQualData;

Var
  x, y, z: Real;

begin (* UpdateGlobalQualData *)
  GetData ( GlobalQualData );
  TreppeGetEye ( x, y, z );  (* Nur klarstellen, da neu gezeichnet wird *)
  TreppeSetEye ( x, y, z );
  Message ( Application, evBroadcast, cmChanged, @GlobalQualData );
end (* UpdateGlobalQualData *);


begin (* tQualDialog.HandleEvent *)
  inherited HandleEvent ( Event );
  case Event.what of
    evBroadcast:
      case Event.Command of
        cmBye:
          UpdateGlobalQualData;
        cmQualDialog:
          ClearEvent ( Event );
        cmChanged:
          if Event.InfoPtr = @GlobalQualData then
            SetData ( GlobalQualData )
          else if IndexOf ( Event.InfoPtr ) > 0 then
            UpdateGlobalQualData;
      end (* case *);      
  end (* case *);
end (* tQualDialog.HandleEvent *);


Constructor tStudioApplication.Init;

begin (* tStudioApplication.Init *)
  inherited Init ( 'STUDIO 1.0', 'Ressourcen-Datei `studio.res'' nicht gefunden.', true );
end (* tStudioApplication.Init *);


Procedure tStudioApplication.DoLoadFile ( Var aFileName: fNameStr );

Var
  R: tRect;
  D: tPoint;
  C: pContextView;
  W: pWindow;
  pFileName: pString;

  TA: ^TexturArrayT;
  i, j, x, y: LongInt;
  Ctx: GrContextPtr;
  RetPtr: GrContextPtr;

  Dir, Name, Ext: String255;
  isMesa: Boolean;

  rr: Real;

begin (* tStudioApplication.DoLoadFile *)
  DeskTop^.GetExtent ( R );
  R.B.x:= min ( R.B.x, DeskTop^.Size.x - 25 * CharWidth );
  W:= New ( pWindow, Init ( R, ShortTitle ( aFileName ), GetWinNumber ) );
  fSplit ( aFileName, Dir, Name, Ext );
  isMesa:= Ext = '.3d';
  if not isMesa then
    begin
      { TGA-Datei laden }
      x := 0;
      y := 0;

      { Der erste Aufruf ermittelt nur die Ausmae }
      if ReadTGAFile(aFileName, Null, x, y ) then;
      if x + y > 0 then
        begin
          { 3 Byte pro Pixel reservieren }
          New(TA, x * y * 3);
          if not ReadTGAFile(aFileName, TA^, x, y ) then
            begin
              pFileName:= pString ( @aFileName );
              ExecDialog ( 'ReadErr', @pFileName );
              Dispose ( W, Done );
              Exit;
            end (* if *)
          else
            begin
              Ctx := GrCreateContext(x, y, Nil, Null);
              RetPtr := Ctx;
              GrSetContext(Ctx);
              for i := 0 to y - 1 do
                for j := 0 to x - 1 do      
                  GrPlot(j, i, GrAllocColor ( TA^[i * x * 3 + j * 3 + 0] and ColorMask,
                                              TA^[i * x * 3 + j * 3 + 1] and ColorMask,
                                              TA^[i * x * 3 + j * 3 + 2] and ColorMask));
                                              GrSetContext(GrScreenContext);
            end (* else *);
          Dispose(TA);

          (* Fenstergre so anpassen, da das Interior die Gre (x,y) hat. *)
          W^.GetInterior ( R );
          D.x:= R.B.x - R.A.x - x;
          D.y:= R.B.y - R.A.y - y;
          W^.GetBounds ( R );
          if D.x > 0 then  (* Nicht das Fenster aus dem Bildschirm hinausschieben. *)
            dec ( R.B.x, D.x )
          else
            R.A.x:= max ( 0, R.A.x + D.x );
          if D.y > 0 then
            dec ( R.B.y, D.y )
          else
            R.A.y:= max ( 0, R.A.y + D.y );
          W^.ChangeBounds ( R );  (* Nicht stattdessen die Low-Level-Routine 'SetBounds' *)
                                  (* verwenden! (Borland-Erbe)                           *)
        end (* if *)
      else
        begin
          pFileName:= pString ( @aFileName );
          ExecDialog ( 'FileNotFound', @pFileName );
          Dispose ( W, Done );
          Exit;
        end (* else *);
    end (* if *);

  W^.GetInterior ( R );
  if isMesa then
    C:= New ( pMesaView, Init ( R ) )
  else
    C:= New ( pContextView, Init ( R ) );
  with C^ do
    or ( GrowMode, gfGrowHiX or gfGrowHiY );
  if not isMesa then
    with C^ do begin
      ContextSize.x:= x;
      ContextSize.y:= y;
      { Context := Ctx; }
      { Kopie anlegen }
      RetPtr := GrCreateContext(ContextSize.x, ContextSize.y, Nil, Context);
      GrBitBlt(@Context, 0, 0, Ctx, 0, 0, ContextSize.x-1, ContextSize.y-1, GrWrite);
      GrDestroyContext(Ctx);
    end (* if *)
  else
    with pMesaView ( C )^ do begin
      ContextSize.x:= R.B.x - R.A.x;
      ContextSize.y:= R.B.y - R.A.y;
      { RetPtr := GrCreateContext(ContextSize.x, ContextSize.y, Nil, Context); }
      RetPtr := GrCreateContext(MaxTreppeX, MaxTreppeY, Nil, Context);
{      GRXSetFrontContext(@Context);  (* Ist wahrscheinlich unnoetig *) }
      glutInitWindowSize(MaxTreppeX, MaxTreppeY);
      glutInitDisplayMode(GLUT_SINGLE or GLUT_RGB or GLUT_DEPTH);
{
      glDisable ( GL_DEPTH_TEST );
      glEnable ( GL_BLEND );
      glEnable ( GL_POLYGON_SMOOTH );
}
      if glutCreateWindow('Treppe') = 0 then
        Abbruch ( 'GlutCreateWindow fehlgeschlagen!' );
      TreppeInitTextures ( 16 );
      TreppeSetup ( aFileName );
      if ParsenAbgebrochen then
        begin
          Dispose ( W, Done );
          Exit;
        end (* if *);
      TreppeInitRoom ( 3, 500, 500 );
      TreppeGetEye ( Eye.x, Eye.y, Eye.z );
      TreppeSetLightPos ( 0, Eye.x + 30.0, Eye.y, Eye.z, 1.0 );
      TreppeGetCenter ( Center.x, Center.y, Center.z );
      TreppeGetDirection ( Direction.x, Direction.y, Direction.z );
      TreppeViewMode ( vmFlat );
      TreppeSetPlanes ( 1.0 );
      TreppeNeuZeichnen;
    end (* else *);
  W^.Insert ( C );
  if isMesa then
    begin
{
      ZeichneGrundriss;
      LichtDialog;
      OberflaechenDialog;
}
    end (* if *);
  DeskTop^.Insert ( W );
end (* tStudioApplication.DoLoadFile *);


Var
  Resolution: tPoint = ( 800, 600 );


Function CSystem ( CmdLine: CString ): Integer; AsmName 'system';


Procedure tStudioApplication.HandleEvent ( Var Event: tEvent );


Function Raytrace: Boolean;

Var
  D: pDialog;
  ResStrX, ResStrY: NumStr;

begin (* Raytrace *)
  BeginRectData;
  RectData ( '************************' );
  RectData ( '*                      *' );
  RectData ( '* aaaaaaaaaaaaaaaaaaaa *' );
  RectData ( '* xxxxxxxxxxxXXXXXXXXX *' );
  RectData ( '* yyyyyyyyyyyYYYYYYYYY *' );
  RectData ( '*                      *' );
  RectData ( '*                      *' );
  RectData ( '*                      *' );
  RectData ( '************************' );
  EndRectData;
  D:= New ( pDialog, Init ( GetRect ( '*' )^, 'Raytracen' ) );
  with D^ do
    begin
      Insert ( New ( pStaticText, Init ( GetRect ( 'a' )^, 'Auflsung' ) ) );
      Insert ( New ( pIntInputLine, Init ( GetRect ( 'X' )^, 10, 10, 10000 ) ) );
      AddLabel ( D, 'x', '~x~' );
      Insert ( New ( pIntInputLine, Init ( GetRect ( 'Y' )^, 10, 10, 10000 ) ) );
      AddLabel ( D, 'y', '~y~' );
      InsertButtons ( D, 'weiter' + chrOK + 'Abbruch' + chrCancel );
      SelectNext ( false );
    end (* with *);
  D^.SetData ( Resolution );
  if ExecView ( D ) = cmCancel then
    begin
      Dispose ( D, Done );
      Raytrace:= false;
    end (* if *)
  else
    begin
      D^.GetData ( Resolution );
      Dispose ( D, Done );
      Str ( Resolution.x, ResStrX );
      Str ( Resolution.y, ResStrY );
      (* POV-Datei abspeichern, POVray aufrufen und *)
      (* anschlieend die entstandene Datei laden.  *)
      Treppe2POV ( 'studio' );
      (*$ifdef __OS_DOS__ *)
        Lock;
        DoneSysError;
        DriversSetScreenParams ( StartUpMode, Nil );
        DoneVideo;
        DoneEvents;
        CSystem ( 'c:\command.com /c ray.bat studio.pov ' + ResStrX + ' ' + ResStrY );
        InitEvents;
        InitVideo;
        DriversSetScreenParams ( detect, Nil );
        InitSysError;
        UnLock;
      (*$else *)
        CSystem ( 'ray studio.pov ' + ResStrX + ' ' + ResStrY );
      (*$endif *)
      Raytrace:= true;
    end (* else *);
end (* Raytrace *);


Procedure Parcour;

Var
  E: tEvent;
  i, j, Step: Integer;
  z0: Real;

begin (* Parcour *)
  if Lauflinie = Nil then
    Exit;
  Step:= 1;
  i:= 1;
  repeat
    with Lauflinie^ [ i ] do
      begin
        z0:= z;
        TreppeSetEye ( x, y, z );
      end (* with *);
    j:= min ( Lauflinie^.n, max ( 1, i + 7 * Step ) );
    with Lauflinie^ [ j ] do
      TreppeSetCenter ( x, y, min ( z, z0 ) - 0.5 * abs ( z - z0 ) );
    i:= ( i - 1 + Lauflinie^.n + Step ) mod Lauflinie^.n + 1;
    if ( i + Step <= 1 ) or ( i + Step >= Lauflinie^.n - 1 ) then
      Step:= - Step;
    Message ( Application, evBroadcast, cmUpdate, Nil );
    DriversGetEvent ( E, 0 );
  until E.what and ( evKeyDown or evMouseDown ) <> 0;
end (* Parcour *);


begin (* tStudioApplication.HandleEvent *)
  inherited HandleEvent ( Event );
  case Event.what of
    evKeyDown:
      case UpCase [ Event.CharCode ] of
        'A':
          begin
            Zeichne3dAnsicht;
            ClearEvent ( Event );
          end (* cmGrundriss *);
        'G':
          begin
            ZeichneGrundriss;
            ClearEvent ( Event );
          end (* 'G' *);
        'L':
          begin
            LichtDialog;
            ClearEvent ( Event );
          end (* 'L' *);
        'O':
          begin
            OberflaechenDialog;
            ClearEvent ( Event );
          end (* 'O' *);
        'Q':
          begin
            QualitaetDialog;
            ClearEvent ( Event );
          end (* 'O' *);
        'P':
          begin
            Parcour;
            ClearEvent ( Event );
          end (* 'O' *);
      end (* case *);
    evCommand:
      case Event.Command of
        cm3dAnsicht:
          begin
            Zeichne3dAnsicht;
            ClearEvent ( Event );
          end (* cmGrundriss *);
        cmGrundriss:
          begin
            ZeichneGrundriss;
            ClearEvent ( Event );
          end (* cmGrundriss *);
        cmLicht:
          begin
            LichtDialog;
            ClearEvent ( Event );
          end (* cmLicht *);
        cmOberflaechen:
          begin
            OberflaechenDialog;
            ClearEvent ( Event );
          end (* cmOberflaechen *);
        cmQualitaet:
          begin
            QualitaetDialog;
            ClearEvent ( Event );
          end (* cmOberflaechen *);
        cmRaytrace:
          begin
            if Raytrace then
              StudioApplication.LoadFile ( cmLoad, 'studio.tga', false );
            ClearEvent ( Event );
          end (* cmRaytrace *);
        cmParcour:
          begin
            Parcour;
            ClearEvent ( Event );
          end (* cmOberflaechen *);
      end (* case *);
  end (* case *);
end (* tStudioApplication.HandleEvent *);


end.
