Unit Treppe3D;

interface

uses
  (*$ifdef __DJGPP__ *)
    dpmi,
  (*$endif *)
  GRX,
  Drivers, Graphics, gl,
  glu, glut,
  parse, szene_3d, tgaunit2, povunit;

const
  MaxTreppeX = 1280;
  MaxTreppeY = 1024;

  MaxLightPos = 7;
  MaxTexData = 100;

  { ViewModes }
  vmLine   = 0;
  vmLine2  = 1;
  vmHidden = 2;
  vmFlat   = 3;
  vmSmooth = 4;
  vmTextF  = 5; { Texturiert Flat }
  vmTextS  = 6; { Texturiert Smooth }
  MaxViewMode = 6;

var
  TexDataCount: Integer value 0;
  Lauflinie: pDynArrVector value Nil;

procedure TreppeSetup(FileName: Str255);
procedure TreppeDraw;
Procedure TreppeProjection ( Tafel: pGraphic; ux, uy, uz, vx, vy, vz: Real );
procedure TreppeReshape(w, h: Integer);
procedure Treppe;
procedure TreppeSetEye(x, y, z: Real);
procedure TreppeSetEyeD(x, y, z: Real);
procedure TreppeSetLightPos(i: Integer; x, y, z, Intensity: Real);
procedure TreppeSetLightAmbient(Intensity: Real);
procedure TreppeSetBackgroundColor ( r, g, b: Real );
procedure TreppeSetForegroundColor ( r, g, b: Real );
procedure TreppeSetCenter(x, y, z: Real);
procedure TreppeSetDirection(x, y, z: Real);
procedure TreppeGetEye(Var x, y, z: Real);
procedure TreppeGetLightPos(i: Integer; Var x, y, z, Intensity: Real);
procedure TreppeGetCenter(Var x, y, z: Real);
procedure TreppeGetDirection(Var x, y, z: Real);
procedure Treppe2dTo3d(u, v: Integer; Var x, y, z: Real);
procedure TreppeViewMode(n: Integer);
function  TreppeChanged: Boolean;
procedure Treppe2TGA(SaveName: Str255);
procedure Treppe2POV(SaveName: Str255);
procedure TreppeSetPlanes(Faktor: Real);
procedure TreppeFilterMode(n: Integer);
procedure TreppeInitTextures(n: Integer);
procedure TreppeSetTexture(i: Integer; aEnable: Word; r, g, b: Real;
                           aMatType: Char; Const aMatName, aFileName: String);
procedure TreppeGetTexture(i: Integer; Var aEnable: Word; Var r, g, b: Real;
                           Var aMatType: Char; Var aMatName, aFileName: String);
function  TreppeGetTextureIndex(Const MaterialType, MaterialName: String): Integer;
function  TreppeGetTextureCount: Integer;
procedure TreppeInitRoom(n: Integer; d, h: Real);
procedure TreppeSetRoomGlobals(n: Integer; d, h: Real);
procedure TreppeSetRoom(i: Integer; x, y: Real);
procedure TreppeGetRoom(i: Integer; Var x, y: Real);


implementation

uses
  Maths;

type
  Array3f      = array[1..3] of GLfloat;
  {
  TexturArrayT = array[0..1] of Byte;
  }
  {
  TexturArrayT(n:Integer) = array[0..n] of Byte;
  }

const
  LightPosName : array [0..MaxLightPos] of GLenum
    = ( GL_LIGHT0, GL_LIGHT1, GL_LIGHT2, GL_LIGHT3,
        GL_LIGHT4, GL_LIGHT5, GL_LIGHT6, GL_LIGHT7 );
  IntensityFactor = 0.5;

  teOff = 0;
  teColor = 1;
  teTexture = 2;
  teBoth = 3;

var { global }
  RotX, RotY, RotZ, scale, scale2, scale3 : GLfloat;
  NearP, FarP, TempWinkel : GLfloat;
  PolyOn, VorderOn, HinterOn, NormalOn, TextureOn, LookOn   : Boolean;

  SizeX, SizeY : Integer;
  Eye, Center, Up, MaxRoom, MinRoom, NorVec : GLDoubleVector;
  MaxRadius: Real;
  DRoom: Real value 500;
  HRoom: Real value 500;
  WRoom: array [ 0..7 ] of record
    x, y: Real;
  end (* WRoom *)
  value ( ( -20, -20 ), ( -20, 200 ), ( 300, 200 ), ( 300, -20 ), 
          ( 0, 0 ), ( 0, 0 ), ( 0, 0 ), ( 0, 0 ) );
  nWRoom: Integer value 2;

  { Flaeche            : Array[0..4] of GLDoubleVector; }
  Flaeche              : PDynArrVector;
  FilterMode, ViewMode : Integer;
  (* currentGenMode    : GLint; *)
  TexObj               : array[0..MaxTexData - 1] of GLuint;
  TexData              : array[0..MaxTexData - 1] of record
                           MatType: Char;
                           MatName, FileName: String[255];
                           red, green, blue: Real;
                           enable: Word;
                         end (* TexData *);
  LightPos             : array [0..MaxLightPos, 1..4] of GLfloat
    = ( ( -100, -100, 450, 1.0 ),
        ( 400, -100, 450, 1.0 ),
        ( 400, 400, 450, 1.0 ),
        ( -100, 400, 450, 1.0 ),
        ( 100, 100, 450, 1.0 ),
        ( 200, 100, 450, 1.0 ),
        ( 200, 200, 450, 1.0 ),
        ( 100, 200, 450, 1.0 ) );
  LightIntensity      : array [0..MaxLightPos] of GLfloat
    = ( 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 );
  LightAmbientIntensity: glFloat = 0.5;
  BackgroundColor: array [ 1..3 ] of glFloat = ( 0.5, 0.5, 0.7 );
  ForegroundColor: array [ 1..3 ] of glFloat = ( 0.0, 1.0, 0.0 );
  v1,v2,v3            : Array3f;

  ContextHeight,
  SaveNum     : Integer;
  SaveName    : Str255;
  TexturArray : ^TexturArrayT;
  MaxTextur   : Integer;

  #ifdef __DJGPP__
    MemInfo     : dpmi_free_mem_info;
  #endif

  bChanged    : Boolean;


function VectMul(a,b:Array3f):Array3f;
var c : Array3f;
begin
  c[1] := a[2] * b[3] - a[3] * b[2];
  c[2] := a[3] * b[1] - a[1] * b[3];
  c[3] := a[1] * b[2] - a[2] * b[1];
  VectMul := c;
end;


function VectSub(a,b:Array3f):Array3f;
var c : Array3f;
begin
  c[1] := a[1] - b[1];
  c[2] := a[2] - b[2];
  c[3] := a[3] - b[3];
  VectSub := c;
end;


procedure TreppeSetEye(x, y, z: Real);
begin
  Eye.x := x;
  Eye.y := y;
  Eye.z := z;
  bChanged := True;
end;


procedure TreppeSetEyeD(x, y, z: Real);
var dx, dy, dz: Real;
begin
  dx := Center.x - Eye.x;
  dy := Center.y - Eye.y;
  dz := Center.z - Eye.z;
  Eye.x := x;
  Eye.y := y;
  Eye.z := z;
  Center.x := Eye.x + dx;
  Center.y := Eye.y + dy;
  Center.z := Eye.z + dz;
  bChanged := True;
end;


procedure TreppeSetCenter(x, y, z: Real);
begin
  Center.x := x;
  Center.y := y;
  Center.z := z;
  bChanged := True;
end;
  

procedure TreppeSetDirection(x, y, z: Real);
begin
  Center.x := Eye.x + x;
  Center.y := Eye.y + y;
  Center.z := Eye.z + z;
  bChanged := True;
end;


procedure TreppeSetLightPos(i: Integer; x, y, z, Intensity: Real);
begin
  LightPos[i,1] := x;
  LightPos[i,2] := y;
  LightPos[i,3] := z;
  LightIntensity[i] := Intensity;
  bChanged := True;
end;


Procedure TreppeSetLightAmbient ( Intensity: Real );

begin (* TreppeSetLightPos *)
  LightAmbientIntensity:= Intensity;
  bChanged := True;
end (* TreppeSetLightPos *);


Procedure TreppeSetBackgroundColor ( r, g, b: Real );

begin (* TreppeSetBackgroundColor *)
  BackgroundColor [ 1 ]:= r;
  BackgroundColor [ 2 ]:= g;
  BackgroundColor [ 3 ]:= b;
  bChanged := True;
end (* TreppeSetBackgroundColor *);


Procedure TreppeSetForegroundColor ( r, g, b: Real );

begin (* TreppeSetForegroundColor *)
  ForegroundColor [ 1 ]:= r;
  ForegroundColor [ 2 ]:= g;
  ForegroundColor [ 3 ]:= b;
  bChanged := True;
end (* TreppeSetForegroundColor *);


procedure TreppeGetEye(Var x, y, z: Real);
begin
  x := Eye.x;
  y := Eye.y;
  z := Eye.z;
end;


procedure TreppeGetCenter(Var x, y, z: Real);
begin
  x := Center.x;
  y := Center.y;
  z := Center.z;
end;
  

procedure TreppeGetDirection(Var x, y, z: Real);
var r: Real;
begin
  x := Center.x - Eye.x;
  y := Center.y - Eye.y;
  z := Center.z - Eye.z;
  r := sqrt(sqr(x) + sqr(y) + sqr(z));
  x := x / r;
  y := y / r;
  z := z / r;
end;
  

procedure TreppeGetLightPos(i: Integer; Var x, y, z, Intensity: Real);
begin
  x := LightPos[i,1];
  y := LightPos[i,2];
  z := LightPos[i,3];
  Intensity := LightIntensity[i];
end;


Procedure Treppe2dTo3d ( u, v: Integer; Var x, y, z: Real );

Var
  Pixels: ShortWord;
  left, right, bottom, top,
    x0, y0, z0, x1, y1, z1, x2, y2, z2,
    x3, y3, z3, x4, y4, z4, r: Real;

begin (* Treppe2dTo3d *)
{  writeln; }
  Pixels:= 0;
  glReadPixels ( u, MaxTreppeY - 1 - v, 1, 1, GL_DEPTH_COMPONENT, GL_UNSIGNED_SHORT, @Pixels );
{  writeln ( Pixels : 10 ); }
  left:= - ( SizeX / SizeY ) * 0.5 * NearP;
  right:= ( SizeX / SizeY ) * 0.5 * NearP;
  bottom:= - 0.5 * NearP;
  top:= 0.5 * NearP;
  x0:= left + ( u / SizeX ) * ( right - left );
  y0:= top + ( v / SizeY ) * ( bottom - top );
  z0:= NearP + ( Pixels / 65536.0 ) * ( FarP - NearP );
{  writeln ( x0 : 10 : 2, y0 : 10 : 2, z0 : 10 : 2 ); }

  x1:= Center.x - Eye.x;
  y1:= Center.y - Eye.y;
  z1:= Center.z - Eye.z;
  r:= sqrt ( sqr ( x1 ) + sqr ( y1 ) + sqr ( z1 ) );
  x1:= NearP * ( x1 / r );
  y1:= NearP * ( y1 / r );
  z1:= NearP * ( z1 / r );
{  writeln ( x1 : 10 : 2, y1 : 10 : 2, z1 : 10 : 2 ); }

  x2:= y1;
  y2:= -x1;
  z2:= 0;
  r:= sqrt ( sqr ( x2 ) + sqr ( y2 ) + sqr ( z2 ) );
  x2:= x2 / r;
  y2:= y2 / r;
  z2:= z2 / r;
{  writeln ( x2 : 10 : 2, y2 : 10 : 2, z2 : 10 : 2 ); }

  x3:= y1 * z2 - y2 * z1;
  y3:= x2 * z1 - x1 * z2;
  z3:= x1 * y2 - x2 * y1;
  r:= - sqrt ( sqr ( x3 ) + sqr ( y3 ) + sqr ( z3 ) );
  x3:= x3 / r;
  y3:= y3 / r;
  z3:= z3 / r;
{  writeln ( x3 : 10 : 2, y3 : 10 : 2, z3 : 10 : 2 ); }

  x4:= x1 + x0 * x2 + y0 * x3;
  y4:= y1 + x0 * y2 + y0 * y3;
  z4:= z1 + x0 * z2 + y0 * z3;
  r:= sqrt ( sqr ( x4 ) + sqr ( y4 ) + sqr ( z4 ) );
{  writeln ( x4 : 10 : 2, y4 : 10 : 2, z4 : 10 : 2 ); }
  x:= Eye.x + z0 / r * x4;
  y:= Eye.y + z0 / r * y4;
  z:= Eye.z + z0 / r * z4;
{  writeln ( x : 10 : 2, y : 10 : 2, z : 10 : 2 ); }
end (* Treppe2dTo3d *);
  


procedure TreppeViewMode(n: Integer);
begin
  if n < 0 then begin
    inc(ViewMode);
    if ViewMode > MaxViewMode then ViewMode := vmLine;
  end else
    ViewMode := n;
  bChanged := True;
end;  


procedure TreppeFilterMode(n: Integer);
var
  i : Integer;
begin
  if n < 0 then begin
    if      FilterMode = GL_NEAREST then FilterMode := GL_NEAREST_MIPMAP_NEAREST
    else if FilterMode = GL_NEAREST_MIPMAP_NEAREST then FilterMode := GL_LINEAR
    else if FilterMode = GL_LINEAR                 then FilterMode := GL_LINEAR_MIPMAP_NEAREST
    else if FilterMode = GL_LINEAR_MIPMAP_NEAREST  then FilterMode := GL_LINEAR_MIPMAP_LINEAR
    else    FIlterMode := GL_NEAREST;
  end else
    FilterMode := n;

  { FilterModus fr jede Textur setzen }
  for i := 0 to 15 do begin
    glBindTexture(GL_TEXTURE_2D, TexObj[i]);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, FilterMode);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, FilterMode);
  end;

  bChanged := True;
end;


function  TreppeChanged: Boolean;
begin
  TreppeChanged := bChanged;
end;  


procedure Treppe2TGA(SaveName: Str255);
var
  w, h: Integer;
begin
  w := (SizeX div 4) * 4; { Es gibt wahrscheinlich einen Bug in glReadPixels }
  h := SizeY;
  New(TexturArray, w * h * 3);
  glReadPixels(0,MaxTreppeY-h,w,h,GL_RGB,GL_UNSIGNED_BYTE,TexturArray);
  if SaveScreen2TGA(SaveName, TexturArray^, w, h) then;
  Dispose(TexturArray);
end;

procedure TreppeSetPlanes(Faktor: Real);
var
  i: Integer;
  MinCenter, MaxCenter, Center : GLDoubleVector;
begin
  { Berechnen der maximalen Entfernung }
  { Mittelpunkt der Szene }
  MinCenter:= MinRoom;
  MaxCenter:= MaxRoom;
  for i:= 1 to nWRoom do
    with WRoom [ i ] do
      begin
        MinCenter.x:= min ( MinCenter.x, x );
        MinCenter.y:= min ( MinCenter.y, y );
      end (* with *);
  Center.x := (MaxCenter.x + MinCenter.x) / 2;
  Center.y := (MaxCenter.y + MinCenter.y) / 2;
  Center.z := (MaxCenter.z + MinCenter.z) / 2;

  { Entfernung vom Betrachter zum Mittelpunkt der Szene }
  FarP := sqrt(sqr(Center.x - Eye.x) + sqr(Center.y - Eye.y) + sqr(Center.z - Eye.z));
  { Writeln('Entfernung zum Mittelpunkt der Szene', FarP:8:3); }

  { Mittelpunkt +/- (MaxRadius * Faktor)}
  NearP := FarP - MaxRadius * Faktor;
  FarP  := FarP + MaxRadius * Faktor;

  { NearPlane sollt nicht <= 0 sein }
  { Mindestabstand zum Betrachter setzen }
  NearP := max(1.0, NearP);

  { Setzen der neuen Planes }
  TreppeReshape(SizeX, SizeY);

  bChanged := True;
end;


Procedure TreppeInitTextures ( n: Integer );

begin (* TreppeInitTextures *)

  TexDataCount:= 0;

  { Setup texture }
  glDisable(GL_DITHER);

  { Setup texturing }
  glEnable(GL_TEXTURE_2D);
  {
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
  }
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  { glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST); }
  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);

  { generate texture object IDs }
  glGenTextures(16, @TexObj[0]);

end (* TreppeInitTextures *);


procedure TreppeSetTexture (i: Integer; aEnable: Word; r, g, b: Real;
                            aMatType: Char; Const aMatName, aFileName: String);
var
  TextHoch, TextBreit : LongInt;
  Dummy: Integer;
begin
  if aFileName = '' then
    aEnable:= min ( aEnable, teColor );
  with TexData [ i ] do
    begin
      MatType:= aMatType;
      MatName:= aMatName;
      FileName:= aFileName;
      red:= r;
      green:= g;
      blue:= b;
      enable:= aEnable;
    end (* with *);
  if aFileName <> '' then
    begin
      { setup first texture object }
      glBindTexture(GL_TEXTURE_2D, TexObj[i]);
      TextBreit:= 0;
      TextHoch:= 0;
      if ReadTGAFile(aFileName, Null, TextBreit, TextHoch) then;
      if TextBreit * TextHoch > 0 then
        begin
          New(TexturArray, TextBreit * TextHoch * 3);
          if ReadTGAFile(aFileName, TexturArray^, TextBreit, TextHoch) then
            Dummy:= gluBuild2DMipmaps(GL_TEXTURE_2D, 3, TextBreit, TextHoch,
                                      GL_RGB, GL_UNSIGNED_BYTE, TexturArray);
          Dispose(TexturArray);
        end (* if *);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, FilterMode);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, FilterMode);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
      { end of texture object }
    end (* if *);
  bChanged:= true;
end;


Procedure TreppeGetTexture ( i: Integer; Var aEnable: Word; Var r, g, b: Real;
                             Var aMatType: Char; Var aMatName, aFileName: String );

begin (* TreppeGetTexture *)
  with TexData [ i ] do
    begin
      aMatType:= MatType;
      aMatName:= MatName;
      aFileName:= FileName;
      r:= red;
      g:= green;
      b:= blue;
      aEnable:= enable;
    end (* with *);
end (* TreppeGetTexture *);


Function TreppeGetTextureIndex ( Const MaterialType, MaterialName: String ): Integer;

Var
  i, j, k, TE: Integer;
  r, g, b: Real;
  aFileName: Str255;

begin (* TreppeGetTextureIndex *)
  i:= 0;
  while ( i < TexDataCount ) and ( TexData [ i ].MatName <> MaterialName ) do
    inc ( i );
  if i >= TexDataCount then
    begin
      TE:= teTexture;
      if i >= MaxTexData then
        Abbruch ('Zu viele Texturen');
      case MaterialType [ 1 ] of
        'm': begin
               r:= 0.2;
               g:= 0.2;
               b:= 0.2;
               aFileName:= 'rauh1.tga';
             end (* 'm' *);
        'h': begin
               r:= 0.5;
               g:= 0.3;
               b:= 0.05;
               aFileName:= 'holz4.tga';
             end (* 'h' *);
        'a': begin
               r:= 0.9;
               g:= 0.9;
               b:= 0.9;
               aFileName:= 'punkte.tga';
             end (* 'a' *);
        'g': begin
               r:= 0.35;
               g:= 0.25;
               b:= 0.2;
               aFileName:= 'boden4.tga';
             end (* 'a' *);
      else
        r:= 1.0;
        g:= 1.0;
        b:= 1.0;
        aFileName:= 'punkte.tga';
      end (* case *);
      if length ( MaterialType ) > 1 then
        begin
          j:= 2;
          while ( j <= length ( MaterialType ) ) and ( MaterialType [ j ] = ' ' ) do
            inc ( j );
          case UpCase ( MaterialType [ j ] ) of
            'A': TE:= teOff;
            'F': TE:= teColor;
            'T': TE:= teTexture;
            'B': TE:= teBoth;
          end (* case *);
          inc ( j );
          while ( j <= length ( MaterialType ) ) and ( MaterialType [ j ] = ' ' ) do
            inc ( j );
          if j <= length ( MaterialType ) then
            begin
              k:= j;
              while ( k <= length ( MaterialType ) ) and ( MaterialType [ k ] <> ' ' ) do
                inc ( k );
              aFileName:= Copy ( MaterialType, j, k - j ) + '.tga';
              j:= k;
            end (* if *);
          while ( j <= length ( MaterialType ) ) and ( MaterialType [ j ] = ' ' ) do
            inc ( j );
          if j <= length ( MaterialType ) then
            begin
              k:= j;
              while ( k <= length ( MaterialType ) ) and ( MaterialType [ k ] <> ' ' ) do
                inc ( k );
              ReadStr ( Copy ( MaterialType, j, k - j ), r );
              j:= k;
            end (* if *);
          while ( j <= length ( MaterialType ) ) and ( MaterialType [ j ] = ' ' ) do
            inc ( j );
          if j <= length ( MaterialType ) then
            begin
              k:= j;
              while ( k <= length ( MaterialType ) ) and ( MaterialType [ k ] <> ' ' ) do
                inc ( k );
              ReadStr ( Copy ( MaterialType, j, k - j ), g );
              j:= k;
            end (* if *);
          while ( j <= length ( MaterialType ) ) and ( MaterialType [ j ] = ' ' ) do
            inc ( j );
          if j <= length ( MaterialType ) then
            begin
              k:= j;
              while ( k <= length ( MaterialType ) ) and ( MaterialType [ k ] <> ' ' ) do
                inc ( k );
              ReadStr ( Copy ( MaterialType, j, k - j ), b );
            end (* if *);
        end (* if *);
      TreppeSetTexture ( TexDataCount, TE, r, g, b,
                         MaterialType [ 1 ], MaterialName, aFileName );
      TreppeGetTextureIndex:= TexDataCount;
      inc ( TexDataCount )
    end (* if *)
  else
    TreppeGetTextureIndex:= i
end (* TreppeGetTextureIndex *);


Function TreppeGetTextureCount: Integer;

begin (* TreppeGetTextureCount *)
  TreppeGetTextureCount:= TexDataCount;
end (* TreppeGetTextureCount *);


Procedure TreppeInitRoom ( n: Integer; d, h: Real );

begin (* TreppeInitRoom *)
  nWRoom:= n;
  DRoom:= d;
  HRoom:= h;
  WRoom [ 0 ].x:= MinRoom.x;
  WRoom [ 0 ].y:= MinRoom.y - DRoom;
  WRoom [ 1 ].x:= MinRoom.x;
  WRoom [ 1 ].y:= MaxRoom.y;
  WRoom [ 2 ].x:= MaxRoom.x + DRoom;
  WRoom [ 2 ].y:= MaxRoom.y;
  WRoom [ 3 ].x:= 0;
  WRoom [ 3 ].y:= 0;
  WRoom [ 4 ]:= WRoom [ 3 ];
  WRoom [ 5 ]:= WRoom [ 3 ];
  WRoom [ 6 ]:= WRoom [ 3 ];
  WRoom [ 7 ]:= WRoom [ 3 ];
  bChanged:= true;
end (* TreppeInitRoom *);


Procedure TreppeSetRoomGlobals ( n: Integer; d, h: Real );

begin (* TreppeSetRoomGlobals *)
  nWRoom:= n;
  DRoom:= d;
  HRoom:= h;
  bChanged:= true;
end (* TreppeSetRoomGlobals *);


Procedure TreppeSetRoom ( i: Integer; x, y: Real );

begin (* TreppeSetRoom *)
  WRoom [ i ].x:= x;
  WRoom [ i ].y:= y;
  bChanged:= true;
end (* TreppeSetRoom *);


Procedure TreppeGetRoom ( i: Integer; Var x, y: Real );

begin (* TreppeGetRoom *)
  x:= WRoom [ i ].x;
  y:= WRoom [ i ].y;
end (* TreppeGetRoom *);


procedure SzeneInit;

const
  ambient        : array [1..4] of GLfloat = ( 1.0; 1.0; 1.0; 1.0 );
  local_view     : array [1..2] of GLfloat = ( 0.0, 0.0 );

var
  diffuse  : array [1..4] of GLfloat = ( 1.0, 1.0, 1.0, 1.0 );
  temp     : GLfloat;
  i, j     : GLint;
  GL_LIGHT : GLenum;


begin
    { maximale Gre der Texturen abfragen }
    glGetFloatv(GL_MAX_TEXTURE_SIZE, @temp);
    {
    Writeln('Maximale Texturgroesse : ', temp:0:2);
    }
    MaxTextur := round(temp);


    for i:= 0 to MaxLightPos do
      begin
        (* Verfgbare Lichtquellen konfigurieren *)
        GL_LIGHT := LightPosName[i];
        glLightfv(GL_LIGHT, GL_AMBIENT, @ambient[1]);
        for j := 1 to 3 do
          diffuse[j] := LightIntensity[i] * IntensityFactor;
        glLightfv(GL_LIGHT, GL_DIFFUSE, @diffuse[1]);
        glLightfv(GL_LIGHT, GL_SPECULAR, @diffuse[1]);
        glLightfv(GL_LIGHT, GL_POSITION, @LightPos[i,1]);
        if LightIntensity[i] > 0 then
          glEnable(GL_LIGHT)
        else
          glDisable(GL_LIGHT);
      end (* for *);

    glEnable(GL_LIGHTING);

    { Beleuchtungsmodell }
    glLightModelfv(GL_LIGHT_MODEL_LOCAL_VIEWER, @local_view[1]);

    { FLAT oder SMOOTH (Goraud) }
    glShadeModel(GL_SMOOTH);

    { Beidseitige Beleuchtung nur fr Debugzwecke, }
    { da nur geschlossene Krper verwendet werden }
    #define TwoSideNo
    #ifdef TwoSideYes
      glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, Glint(GL_TRUE));
    #else
      glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, Glint(GL_FALSE));
    #endif

    { Orientierung der Flchen entgegen dem Uhrzeigersinn }
    glFrontFace(GL_CCW);

    { Rckseiten automatisch entfernen }
    glCullFace(GL_BACK);
    glEnable(GL_CULL_FACE);

    { Falls Rckseiten nicht entfernt werden vmLine !!! }
    glPolygonMode(GL_BACK, GL_LINE);

    { Automatische Normierung der Normalenvektoren }
    glEnable(GL_NORMALIZE);

    { Automatische Berechnung der Flchennormalen }
    glEnable(GL_AUTO_NORMAL);

    { Z-Buffer einschalten }
    glEnable(GL_DEPTH_TEST);
    glDepthFunc(GL_LESS);
end;


Procedure ZeichneWurst ( Wurst: WurstType; ambr, ambg, ambb, difr, difg, difb, specr, specg, specb, shine: glFloat );

Var
  mat: array [ 0..3 ] of glFloat;
  i, j: Integer;


Procedure UebergebeTexturKoordinaten ( Const F0, F1, F2, F: GLDoubleVector );

Const
  epsilon = 0.001;

Var
  uu, vv, ww, u, v, TF: GLDoubleVector;
  beta, r: Real;

begin (* UebergebeTexturKoordinaten *)
  uu.x:= F0.x - F1.x;
  uu.y:= F0.y - F1.y;
  uu.z:= F0.z - F1.z;
  vv.x:= F2.x - F1.x;
  vv.y:= F2.y - F1.y;
  vv.z:= F2.z - F1.z;
  ww.x:= F.x - F1.x;
  ww.y:= F.y - F1.y;
  ww.z:= F.z - F1.z;
  if abs ( uu.z ) > abs ( vv.z ) then
    begin
      u.x:= vv.x - ( vv.z / uu.z ) * uu.x;
      u.y:= vv.y - ( vv.z / uu.z ) * uu.y;
    end (* if *)
  else if abs ( vv.z ) >= epsilon then
    begin
      u.x:= uu.x - ( uu.z / vv.z ) * vv.x;
      u.y:= uu.y - ( uu.z / vv.z ) * vv.y;
    end (* else if *)
  else
    begin
      glTexCoord3d ( ww.x * scale3, ww.y * scale3, ww.z * scale3 );
      Exit
    end (* else *);
  u.z:= 0;
  if abs ( u.x * vv.x + u.y * vv.y ) < epsilon then
    begin
      glTexCoord3d ( ww.x * scale3, ww.y * scale3, ww.z * scale3 );
      Exit
    end (* if *);
  beta:= - ( u.x * uu.x + u.y * uu.y ) / ( u.x * vv.x + u.y * vv.y );
  v.x:= uu.x + beta * vv.x;
  v.y:= uu.y + beta * vv.y;
  v.z:= uu.z + beta * vv.z;
  r:= sqrt ( sqr ( u.x ) + sqr ( u.y ) + sqr ( u.z ) );
  u.x:= u.x / r;
  u.y:= u.y / r;
  u.z:= u.z / r;
  r:= sqrt ( sqr ( v.x ) + sqr ( v.y ) + sqr ( v.z ) );
  v.x:= v.x / r;
  v.y:= v.y / r;
  v.z:= v.z / r;
  TF.x:= ( ww.x * u.x + ww.y * u.y + ww.z * u.z ) * scale3;
  TF.y:= ( ww.x * v.x + ww.y * v.y + ww.z * v.z ) * scale3;
  TF.z:= 0;
  glTexCoord2d ( TF.x, TF.y );
end (* UebergebeTexturKoordinaten *);


begin (* ZeichneWurst *)
  with Wurst do
    begin
      if TexData [ Material ].enable = teOff then
        Exit;
{
      case TexData [ Material ].MatType of
        'm', 'a', 'g':  (* Metall *)
          begin
            if TextureOn and (TexData[Material].enable = teTexture) then begin
              mat[0] := 0.12; mat[1] := 0.12; mat[2] := 0.12; mat[3] := 1.0;
              glMaterialfv (GL_FRONT, GL_AMBIENT, @mat[0]);
              glEnable(GL_TEXTURE_2D);
              glBindTexture(GL_TEXTURE_2D, TexObj[Material]);
              glMatrixMode(GL_TEXTURE);
              glLoadIdentity;
              glMatrixMode(GL_MODELVIEW);
              mat[0] := 1.0; mat[1] := 1.0; mat[2] := 1.0;
              glMaterialfv (GL_FRONT, GL_DIFFUSE, @mat[0]);
            end
            else begin
              mat[0] := 0.1; mat[1] := 0.1; mat[2] := 0.1; mat[3] := 1.0;
              glMaterialfv (GL_FRONT, GL_AMBIENT, @mat[0]);
              glDisable(GL_TEXTURE_2D);
              with TexData[Material] do begin
                mat[0] := red; mat[1] := green; mat[2] := blue; mat[3] := 1.0;
              end;
              glMaterialfv (GL_FRONT, GL_DIFFUSE, @mat[0]);
            end;
            mat[0] := 0.9; mat[1] := 1; mat[2] := 1; mat[3] := 1;
            glMaterialfv (GL_FRONT, GL_SPECULAR, @mat[0]);
            glMaterialf (GL_FRONT, GL_SHININESS, 1*128.0);
          end (* 'm' *);
        'x':  (* mArmor, Andere, ... *)
          begin
            mat[0] := 0.1; mat[1] := 0.1; mat[2] := 0.1; mat[3] := 1.0;
            glMaterialfv (GL_FRONT, GL_AMBIENT, @mat[0]);
            mat[0] := 0.9; mat[1] := 0.9; mat[2] := 0.9; mat[3] := 1.0;
            glMaterialfv (GL_FRONT, GL_SPECULAR, @mat[0]);
            glMaterialf (GL_FRONT, GL_SHININESS, 0.7*128.0);
            if TextureOn and (TexData[Material].enable = teTexture) then
              begin
                glEnable(GL_TEXTURE_2D);
                glBindTexture(GL_TEXTURE_2D, TexObj[Material]);
                glMatrixMode(GL_TEXTURE);
                glLoadIdentity;
                glRotatef(MaterialWinkel, 0, 0, 1);
                glMatrixMode(GL_MODELVIEW);
                mat[0] := 1.0; mat[1] := 1.0; mat[2] := 1.0;
                glMaterialfv (GL_FRONT, GL_DIFFUSE, @mat[0]);
              end
            else
              begin
                with TexData[Material] do begin
                  mat[0] := red; mat[1] := green; mat[2] := blue;
                end;
                glMaterialfv (GL_FRONT, GL_DIFFUSE, @mat[0]);
              end
          end (* 'a' *);
        'h':  (* Holz *)
          begin
            if TextureOn and (TexData[Material].enable = teTexture) then begin
              glEnable(GL_TEXTURE_2D);
              glBindTexture(GL_TEXTURE_2D, TexObj[Material]);
              glMatrixMode(GL_TEXTURE);
              glLoadIdentity;
              glRotatef(MaterialWinkel, 0, 0, 1);
              glMatrixMode(GL_MODELVIEW);
              mat[0] := 1.0; mat[1] := 1.0; mat[2] := 1.0;
              glMaterialfv (GL_FRONT, GL_DIFFUSE, @mat[0]);
            end
            else begin
              glDisable(GL_TEXTURE_2D);
              with TexData[Material] do begin
                mat[0] := 0.1 + 0.2 * red;
                mat[1] := 0.1 + 0.2 * green;
                mat[2] := 0.1 + 0.2 * blue;
              end;
              glMaterialfv (GL_FRONT, GL_AMBIENT, @mat[0]);
              with TexData[Material] do begin
                mat[0] := 0.5 * red; mat[1] := 0.5 * green; mat[2] := 0.5 * blue;
              end;
              glMaterialfv (GL_FRONT, GL_DIFFUSE, @mat[0]);
              mat[0] := 1; mat[1] := 1; mat[2] := 1;
              glMaterialfv (GL_FRONT, GL_SPECULAR, @mat[0]);
              glMaterialf (GL_FRONT, GL_SHININESS, 0.6*128.0);
            end;
          end (* 'h' *);
      else
        (* Granit *)
        mat[0] := 0.1;  mat[1] := 0.1;  mat[2] := 0.1; mat[3] := 1.0;
        glMaterialfv (GL_FRONT, GL_AMBIENT, @mat[0]);
        mat[0] := 0.1; mat[1] := 0.9; mat[2] := 0.1; mat[3] := 1.0;
        glMaterialfv (GL_FRONT, GL_DIFFUSE, @mat[0]);
        mat[0] := 1; mat[1] := 1; mat[2] := 1; mat[3] := 1;
        glMaterialfv (GL_FRONT, GL_SPECULAR, @mat[0]);
        glMaterialf (GL_FRONT, GL_SHININESS, 1*128.0);
      end (* case *);
}
      if TextureOn
         and ( TexData[Material].enable in [ teTexture, teBoth ] ) then
        begin
          glEnable ( GL_TEXTURE_2D );
          glBindTexture ( GL_TEXTURE_2D, TexObj[Material] );
          glMatrixMode ( GL_TEXTURE );
          glLoadIdentity;
          glRotatef ( MaterialWinkel, 0, 0, 1 );
          glMatrixMode ( GL_MODELVIEW );
          if TexData [ Material ].enable = teBoth then
            with TexData [ Material ] do
              begin
                mat [ 0 ]:= 0.1 + 0.2 * red;
                mat [ 1 ]:= 0.1 + 0.2 * green;
                mat [ 2 ]:= 0.1 + 0.2 * blue;
                glMaterialfv ( GL_FRONT, GL_AMBIENT, @mat [ 0 ] );
                mat [ 0 ]:= 0.5 * red;
                mat [ 1 ]:= 0.5 * green;
                mat [ 2 ]:= 0.5 * blue;
                glMaterialfv ( GL_FRONT, GL_DIFFUSE, @mat[0] );
              end (* with *)
          else
            begin
              mat [ 0 ] := 0.3;
              mat [ 1 ] := 0.3;
              mat [ 2 ] := 0.3;
              glMaterialfv ( GL_FRONT, GL_AMBIENT, @mat [ 0 ] );
              mat [ 0 ] := 0.5;
              mat [ 1 ] := 0.5;
              mat [ 2 ] := 0.5;
              glMaterialfv ( GL_FRONT, GL_DIFFUSE, @mat[0] );
            end (* else *);
        end (* if *)
      else
        begin
          glDisable ( GL_TEXTURE_2D );
          with TexData [ Material ] do
            begin
              mat [ 0 ]:= 0.1 + 0.2 * red;
              mat [ 1 ]:= 0.1 + 0.2 * green;
              mat [ 2 ]:= 0.1 + 0.2 * blue;
              glMaterialfv ( GL_FRONT, GL_AMBIENT, @mat [ 0 ] );
              mat [ 0 ]:= 0.5 * red;
              mat [ 1 ]:= 0.5 * green;
              mat [ 2 ]:= 0.5 * blue;
              glMaterialfv ( GL_FRONT, GL_DIFFUSE, @mat [ 0 ] );
            end (* with *);
          mat [ 0 ]:= 1;
          mat [ 1 ]:= 1;
          mat [ 2 ]:= 1;
          glMaterialfv ( GL_FRONT, GL_SPECULAR, @mat [ 0 ] );
          glMaterialf ( GL_FRONT, GL_SHININESS, 0.6 * 128.0 );
        end (* else *);

      AktScheibe := VFlaeche;

      { Vorderflche }
      if (PolyOn or (AktScheibe^.Dreiecke.Anzahl = 0)) then
        with AktScheibe^ do
          begin
            { Wenn Linienmodus oder nicht trianguliert, }
            { Polygondarstellung }
            glBegin(GL_POLYGON);
            if NormalOn then
              glNormal3d(nv.x, nv.y, nv.z);
            for i := 0 to (AnzahlKanten-1) do
              begin
                if TextureOn then
                  UebergebeTexturKoordinaten ( Flaechen^[0], Flaechen^[1], Flaechen^[2],
                                               Flaechen^[i] );
{
                  glTexCoord3d((Flaechen^[i].x - Flaechen^[0].x) * scale3,
                               (Flaechen^[i].y - Flaechen^[0].y) * scale3,
                               (Flaechen^[i].z - Flaechen^[0].z) * scale3);
}
                glVertex3dv(@Flaechen^[i].x);
              end (* for *);
            glEnd;
          end (* with *)
      else
        with AktScheibe^ do
          begin
            { sonst die Dreiecke der Tesselation verwenden }
            glBegin(GL_TRIANGLES);
            if NormalOn then
              glNormal3d(nv.x, nv.y, nv.z);
              
            for i := 1 to Dreiecke.Anzahl do
              for j := 2 downto 0 do begin
                {
                writeln(i:10,j:10, Dreiecke.Ecken^[i][j].x:7:2, Dreiecke.Ecken^[i][j].y:7:2, Dreiecke.Ecken^[i][j].z:7:2);
                }
                if TextureOn then
                  UebergebeTexturKoordinaten ( Dreiecke.TexEcken^[i][2],
                                               Dreiecke.TexEcken^[i][1],
                                               Dreiecke.TexEcken^[i][0],
                                               Dreiecke.TexEcken^[i][j] );
{
                  glTexCoord3d(Dreiecke.TexEcken^[i][j].x * scale3,
                               Dreiecke.TexEcken^[i][j].y * scale3,
                               Dreiecke.TexEcken^[i][j].z * scale3);
}
                glVertex3dv(@Dreiecke.Ecken^[i][j].x);
              end;  
            glEnd;
          end (* with *);

      {
      mat[0] := 0.1; mat[1] := 1-difg; mat[2] := 1-difb;
      glMaterialfv (GL_FRONT, GL_DIFFUSE, @mat[0]);
      }

      { Zwischenflchen fr Debugging }
      (*
      for j := 1 to (AnzahlFlaechen-2) do
      glBegin(GL_POLYGON);
        for i := 0 to (AnzahlKanten-1) do
          glVertex3d(Flaechen[j,i].x,
                     Flaechen[j,i].y,
                     Flaechen[j,i].z);
      glEnd;
      *)

      (*
      { Auenhaut - Seitenflchen }
      for j := 0 to (AnzahlFlaechen-2) do begin
        glBegin(GL_QUAD_STRIP);
          for i := 0 to AnzahlKanten do begin
            if TextureOn then
              UebergebeTexturKoordinaten ( Flaechen[j,0], Flaechen[j,1], Flaechen[j,2],
                                           Flaechen[j,i] );
{
              glTexCoord3d((Flaechen[j  ,i].x - Flaechen[j  ,0].x)*scale3,
                           (Flaechen[j  ,i].y - Flaechen[j  ,0].y)*scale3,
                           (Flaechen[j  ,i].z - Flaechen[j  ,0].z)*scale3);
}
            if NormalOn then
              glNormal3d(Normalen[j,i].x,
                         Normalen[j,i].y,
                         Normalen[j,i].z);
            glVertex3d(Flaechen[j  ,i].x,
                       Flaechen[j  ,i].y,
                       Flaechen[j  ,i].z);
            if NormalOn then
              glNormal3d(Normalen[j,i].x,
                         Normalen[j,i].y,
                         Normalen[j,i].z);
            glVertex3d(Flaechen[j+1,i].x,
                       Flaechen[j+1,i].y,
                       Flaechen[j+1,i].z);
          end;
        glEnd;
      end;
      *)

      { Auenhaut - Seitenflchen - funktioniert genauso }
      for j := 0 to AnzahlFlaechen-2 do begin
        with AktScheibe^ do
        for i := 0 to AnzahlKanten-1 do
        if not Degeneriert^[i ] then begin
          glEnable(GL_AUTO_NORMAL);
          { Im Linienmodus }
          if TRUE then begin
          glBegin(GL_POLYGON);
            if NormalOn then
              glNormal3d(Normalen^[i ].x,
                         Normalen^[i ].y,
                         Normalen^[i ].z);

            if TextureOn then
              UebergebeTexturKoordinaten ( Flaechen^[i],
                                           NextScheibe^.Flaechen^[i],
                                           NextScheibe^.Flaechen^[i+1],
                                           Flaechen^[i] );
{
              glTexCoord3d((Flaechen^[i  ].x - Flaechen^[0  ].x)*scale3,
                           (Flaechen^[i  ].y - Flaechen^[0  ].y)*scale3,
                           (Flaechen^[i  ].z - Flaechen^[0  ].z)*scale3);
}
            glVertex3dv(@Flaechen^[i  ].x);

            if TextureOn then
              UebergebeTexturKoordinaten ( Flaechen^[i],
                                           NextScheibe^.Flaechen^[i],
                                           NextScheibe^.Flaechen^[i+1],
                                           NextScheibe^.Flaechen^[i] );
{
              glTexCoord3d((Flaechen^[i  ].x - Flaechen^[0  ].x)*scale3,
                           (Flaechen^[i  ].y - Flaechen^[0  ].y)*scale3,
                           (Flaechen^[i  ].z - Flaechen^[0  ].z)*scale3);
}
            glVertex3dv(@NextScheibe^.Flaechen^[i  ].x);

            if TextureOn then
              UebergebeTexturKoordinaten ( Flaechen^[i],
                                           NextScheibe^.Flaechen^[i],
                                           NextScheibe^.Flaechen^[i+1],
                                           NextScheibe^.Flaechen^[i+1] );
{
              glTexCoord3d((Flaechen^[i+1].x - Flaechen^[0].x)*scale3,
                           (Flaechen^[i+1].y - Flaechen^[0].y)*scale3,
                           (Flaechen^[i+1].z - Flaechen^[0].z)*scale3);
}
            glVertex3dv(@NextScheibe^.Flaechen^[i+1].x);

            if TextureOn then
              UebergebeTexturKoordinaten ( Flaechen^[i],
                                           NextScheibe^.Flaechen^[i],
                                           NextScheibe^.Flaechen^[i+1],
                                           Flaechen^[i+1] );
{
              glTexCoord3d((Flaechen^[i+1].x - Flaechen^[0].x)*scale3,
                           (Flaechen^[i+1].y - Flaechen^[0].y)*scale3,
                           (Flaechen^[i+1].z - Flaechen^[0].z)*scale3);
}
            glVertex3dv(@Flaechen^[i+1].x);

          glEnd;
          end else begin
          { Flchenmodus }
          glBegin(GL_TRIANGLES);
            if NormalOn then
              glNormal3d(Normalen^[i ].x,
                         Normalen^[i ].y,
                         Normalen^[i ].z);

            if TextureOn then
              glTexCoord3d((Flaechen^[i  ].x - Flaechen^[0  ].x)*scale3,
                           (Flaechen^[i  ].y - Flaechen^[0  ].y)*scale3,
                           (Flaechen^[i  ].z - Flaechen^[0  ].z)*scale3);
            glVertex3dv(@Flaechen^[i  ].x);

            if TextureOn then
              glTexCoord3d((Flaechen^[i  ].x - Flaechen^[0  ].x)*scale3,
                           (Flaechen^[i  ].y - Flaechen^[0  ].y)*scale3,
                           (Flaechen^[i  ].z - Flaechen^[0  ].z)*scale3);
            glVertex3dv(@NextScheibe^.Flaechen^[i  ].x);

            if TextureOn then
              glTexCoord3d((Flaechen^[i+1].x - Flaechen^[0].x)*scale3,
                           (Flaechen^[i+1].y - Flaechen^[0].y)*scale3,
                           (Flaechen^[i+1].z - Flaechen^[0].z)*scale3);
            glVertex3dv(@NextScheibe^.Flaechen^[i+1].x);
          glEnd;
          glBegin(GL_TRIANGLES);
            if NormalOn then
              glNormal3d(Normalen^[i ].x,
                         Normalen^[i ].y,
                         Normalen^[i ].z);

            if TextureOn then
              glTexCoord3d((Flaechen^[i  ].x - Flaechen^[0  ].x)*scale3,
                           (Flaechen^[i  ].y - Flaechen^[0  ].y)*scale3,
                           (Flaechen^[i  ].z - Flaechen^[0  ].z)*scale3);
            glVertex3dv(@Flaechen^[i  ].x);

            if TextureOn then
              glTexCoord3d((Flaechen^[i+1].x - Flaechen^[0].x)*scale3,
                           (Flaechen^[i+1].y - Flaechen^[0].y)*scale3,
                           (Flaechen^[i+1].z - Flaechen^[0].z)*scale3);
            glVertex3dv(@NextScheibe^.Flaechen^[i+1].x);

            if TextureOn then
              glTexCoord3d((Flaechen^[i+1].x - Flaechen^[0].x)*scale3,
                           (Flaechen^[i+1].y - Flaechen^[0].y)*scale3,
                           (Flaechen^[i+1].z - Flaechen^[0].z)*scale3);
            glVertex3dv(@Flaechen^[i+1].x);
          glEnd;
          end;
        end;
        AktScheibe := AktScheibe^.NextScheibe;
      end;

      (*
      VorScheibe := AktScheibe;
      AktScheibe := AktScheibe^.NextScheibe;
      *)

      { Hinterflche }
      if (PolyOn or (AktScheibe^.Dreiecke.Anzahl = 0)) then
        with AktScheibe^ do
          begin
            { Wenn Linienmodus oder nicht trianguliert, }
            { Polygondarstellung }
            glBegin(GL_POLYGON);
              if NormalOn then
                glNormal3d(nh.x, nh.y, nh.z);
              for i := (AnzahlKanten-1) downto 0 do begin
                if TextureOn then
                  UebergebeTexturKoordinaten ( Flaechen^[0], Flaechen^[1], Flaechen^[2],
                                               Flaechen^[i] );
{
                  glTexCoord3d((Flaechen^[i].x-Flaechen^[0].x)*scale3,
                               (Flaechen^[i].y-Flaechen^[0].y)*scale3,
                               (Flaechen^[i].z-Flaechen^[0].z)*scale3);
}
                glVertex3dv(@Flaechen^[i].x);
              end;
            glEnd;
          end (* with *)
      else
        with AktScheibe^ do
          begin 
            glBegin(GL_TRIANGLES);
            if NormalOn then
              glNormal3d(nh.x, nh.y, nh.z);
              
            for i := 1 to Dreiecke.Anzahl do
              for j := 0 to 2 do begin
                if TextureOn then
                  UebergebeTexturKoordinaten ( Dreiecke.TexEcken^[i][2],
                                               Dreiecke.TexEcken^[i][1],
                                               Dreiecke.TexEcken^[i][0],
                                               Dreiecke.TexEcken^[i][j] );
{
                  glTexCoord3d(Dreiecke.TexEcken^[i][j].x * scale3,
                               Dreiecke.TexEcken^[i][j].y * scale3,
                               Dreiecke.TexEcken^[i][j].z * scale3);
}
                glVertex3dv(@Dreiecke.Ecken^[i][j].x);
              end;  
            glEnd;
          end (* with *);
    end (* with *);
  if TextureOn then
    glDisable ( GL_TEXTURE_2D );
end (* ZeichneWurst *);


Procedure WurstProjektion ( Tafel: pGraphic; Wurst: WurstType;
                            ux, uy, uz, vx, vy, vz: Real );

Var
  i, j: Integer;
  xx, yy: Real;

begin (* WurstProjektion *)
  with Wurst do
    begin
      AktScheibe:= VFlaeche;

      (* Vorderflche *)
      if VorderOn then
        with AktScheibe^ do
          begin
            for i:= 0 to AnzahlKanten - 1 do
              begin
                with Flaechen^ [ i ] do
                  begin
                    xx:= ux * x + uy * y + uz * z;
                    yy:= vx * x + vy * y + vz * z;
                  end (* with *);
                if i = 0 then
                  Tafel^.MoveTo ( xx, yy )
                else
                  Tafel^.LineTo ( xx, yy );
              end (* for *);
            with Flaechen^ [ 0 ] do
              begin
                xx:= ux * x + uy * y + uz * z;
                yy:= vx * x + vy * y + vz * z;
              end (* with *);
            Tafel^.LineTo ( xx, yy );
          end (* with *);

      (* Auenhaut - Seitenflchen *)
      for j:= 0 to AnzahlFlaechen - 2 do
        begin
          with AktScheibe^ do
            for i:= 0 to AnzahlKanten - 1 do
              if not Degeneriert^ [ i ] then
                begin
                  with Flaechen^ [ i ] do
                    begin
                      xx:= ux * x + uy * y + uz * z;
                      yy:= vx * x + vy * y + vz * z;
                    end (* with *);
                  Tafel^.MoveTo ( xx, yy );
                  with NextScheibe^.Flaechen^ [ i ] do
                    begin
                      xx:= ux * x + uy * y + uz * z;
                      yy:= vx * x + vy * y + vz * z;
                    end (* with *);
                  Tafel^.LineTo ( xx, yy );
                end (* if *);
          AktScheibe:= AktScheibe^.NextScheibe;
        end (* for *);

      (* Hinterflche *)
      if HinterOn then
        with AktScheibe^ do
          begin
            for i:= AnzahlKanten - 1 downto 0 do
              begin
                with Flaechen^ [ i ] do
                  begin
                    xx:= ux * x + uy * y + uz * z;
                    yy:= vx * x + vy * y + vz * z;
                  end (* with *);
                if i = AnzahlKanten - 1 then
                  Tafel^.MoveTo ( xx, yy )
                else
                  Tafel^.LineTo ( xx, yy );
              end (* for *);
            with Flaechen^ [ AnzahlKanten - 1 ] do
              begin
                xx:= ux * x + uy * y + uz * z;
                yy:= vx * x + vy * y + vz * z;
              end (* with *);
            Tafel^.LineTo ( xx, yy );
          end (* with *);

    end (* with *);
end (* WurstProjektion *);


Procedure TreppeProjection ( Tafel: pGraphic;
                             ux, uy, uz, vx, vy, vz: Real );

Var
  j: Integer;

begin (* TreppeProjection *)
  AktWurst:= WurstListe;
  for j:= 1 to AnzahlWuerste do
    begin
      WurstProjektion ( Tafel, AktWurst^, ux, uy, uz, vx, vy, vz );
      AktWurst:= AktWurst^.NextWurst;
    end (* for *);
end (* TreppeProjection *);


procedure TreppeDraw;
var i, j: integer;
    GL_LIGHT : GLenum;
    lmodel_ambient : array [1..4] of GLfloat;
    ambient : array [1..4] of GLfloat = ( 0.1; 0.1; 0.1; 1.0 );
    diffuse : array [1..4] of GLfloat = ( 1.0, 1.0, 1.0, 1.0 );

Function DrawAbbruch: Boolean;

Const
  relevant = GR_M_KEYPRESS or GR_M_BUTTON_DOWN or GR_M_BUTTON_UP;

begin (* DrawAbbruch *)
{
  if PendingEvent.flags and relevant = 0 then
    GrMouseGetEventT ( GR_M_EVENT, @PendingEvent, 0 );
  DrawAbbruch:= PendingEvent.flags and relevant <> 0;
}
  DrawAbbruch:= false;
end (* DrawAbbruch *);

begin
    for j:= 1 to 3 do
      lmodel_ambient [ j ]:= 5.0 * LightAmbientIntensity;
    lmodel_ambient [ 4 ]:= 1.0;
    glLightModelfv(GL_LIGHT_MODEL_AMBIENT, @lmodel_ambient[1]);
    { Framebuffer und Z-Buffer lschen }
    glClearColor ( BackgroundColor [ 1 ], BackgroundColor [ 2 ],
                   BackgroundColor [ 3 ], 0.0 );
    glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

    glColor3d (ForegroundColor[1], ForegroundColor[2], ForegroundColor[3]);
    glPolygonMode(GL_FRONT, GL_LINE);
    glDepthFunc(GL_LESS);
    glDisable(GL_TEXTURE_2D);
    TextureOn := False;

    case ViewMode of
      vmLine   : begin
                   glDisable(GL_LIGHTING);
                   glDisable(GL_CULL_FACE);
                 end;
      vmLine2  : begin
                   glDisable(GL_LIGHTING);
                   glEnable(GL_CULL_FACE);
                 end;
      vmHidden : begin
                   glDisable(GL_LIGHTING);
                   glPolygonMode(GL_FRONT, GL_FILL);
                   glEnable(GL_CULL_FACE);
                 end;
      vmFlat   : begin
                   glEnable(GL_LIGHTING);
                   glShadeModel(GL_FLAT);
                   glPolygonMode(GL_FRONT, GL_FILL);
                   glEnable(GL_CULL_FACE);
                 end;
      vmSmooth : begin
                   glEnable(GL_LIGHTING);
                   glShadeModel(GL_SMOOTH);
                   glPolygonMode(GL_FRONT, GL_FILL);
                   glEnable(GL_CULL_FACE);
                 end;
      vmTextF  : begin
                   glEnable(GL_LIGHTING);
                   glShadeModel(GL_FLAT);
                   glPolygonMode(GL_FRONT, GL_FILL);
                   glEnable(GL_CULL_FACE);
                   TextureOn := True;
                 end;
      vmTextS  : begin
                   glEnable(GL_LIGHTING);
                   glShadeModel(GL_SMOOTH);
                   glPolygonMode(GL_FRONT, GL_FILL);
                   glEnable(GL_CULL_FACE);
                   TextureOn := True;
                 end;
    end;

    glPushMatrix;

    { Die "berechnete" Mitte des Bildes wird in den
      Koordinatenursprung verschoben, damit sich die
      Rotationen darauf beziehen knnen }
    { glTranslatef (Center.x, Center.y, Center.z); }

    if LookOn then
      gluLookAt(Eye.x, Eye.y, Eye.z,  { eye }
        { 0.0, 0.0, 0.0,}               { center }
        Center.x, Center.y, Center.z,
        0.0, 0.0, 1.0);            { up is in postivie Z direction }

    for i := 0 to MaxLightPos do
      begin
        GL_LIGHT := LightPosName[i];
        glLightfv(GL_LIGHT, GL_AMBIENT, @ambient[1]);
        for j := 1 to 3 do
          diffuse[j] := LightIntensity[i] * IntensityFactor;
        glLightfv(GL_LIGHT, GL_DIFFUSE, @diffuse[1]);
        glLightfv(GL_LIGHT, GL_SPECULAR, @diffuse[1]);
        glLightfv(GL_LIGHT, GL_POSITION, @LightPos[i,1]);
        if LightIntensity[i] > 0 then
          glEnable(GL_LIGHT)
        else
          glDisable(GL_LIGHT);
      end (* for *);

    glRotatef(RotX, 1, 0, 0);
    glRotatef(RotY, 0, 1, 0);
    glRotatef(RotZ, 0, 0, 1);

    { Alle Wrste sind schon da... }
    if ViewMode = vmHidden then begin
      { Flchen mit Hintergrundfarbe fllen }
      PolyOn := False;
      glColor3d (BackgroundColor[1], BackgroundColor[2], BackgroundColor[3]);
      glDepthFunc(GL_LESS);
      AktWurst := WurstListe;
      for j := 1 to AnzahlWuerste do begin
        if DrawAbbruch then
          Exit;
        ZeichneWurst({ Wuerste[j-1] } AktWurst^, 0.14725, 0.1995, 0.0745, 0.8, 0.8, 0.8, 0.528281, 0.555802, 0.366065, 0.4);
        AktWurst := AktWurst^.NextWurst;
      end;
      glColor3d (ForegroundColor[1], ForegroundColor[2], ForegroundColor[3]);
      PolyOn := True;
      glPolygonMode(GL_FRONT, GL_LINE);
      glDepthFunc(GL_LEQUAL);
    end;
    AktWurst := WurstListe;
    for j := 1 to AnzahlWuerste do begin
      {
      f := j / AnzahlWuerste;
      ZeichneWurst(Wuerste[AnzahlWuerste-j], 0.24725, 0.1995, 0.0745, f, 0.50648, 1-f, 0.628281, 0.555802, 0.366065, 0.4);
      }
      if DrawAbbruch then
        Exit;
      ZeichneWurst({ Wuerste[j-1] } AktWurst^, 0.14725, 0.1995, 0.0745, 0.8, 0.8, 0.8, 0.528281, 0.555802, 0.366065, 0.4);
      AktWurst := AktWurst^.NextWurst;
    end;

    glPopMatrix;
    glFlush;
    glutSwapBuffers;
    bChanged := False;
end;

procedure Treppe2POV(SaveName: Str255);
var
  i, j, k, Tapete: Integer;
  b: Boolean;
  n1, n2: GlDoubleVector;
begin
  if CreatePOVFile(SaveName,
                   BackgroundColor [ 1 ], BackgroundColor [ 2 ], BackgroundColor [ 3 ],
                   LightAmbientIntensity ) then
    begin
      AktWurst := WurstListe;
      for k := 0 to AnzahlWuerste - 1 do
        begin
          with { Wuerste[k] } AktWurst^ do
            begin
              if TexData [ Material ].enable <> teOff then
                begin  { Nur bestimmte Materialien bertragen }
                  if MaterialWinkel = 0 then
                    Tapete := Material
                  else
                    Tapete := -1;
                  b := WritePOVWurstStart (k);
                  AktScheibe := VFlaeche;
                  { Fehler in Vorder- und Hinterflche suchen }
                  if AnzahlKanten = 4 then
                    with AktScheibe^ do
                      begin
                        if not ((Flaechen^[0].x = Flaechen^[1].x)
                                and (Flaechen^[0].x = Flaechen^[2].x)
                                and (Flaechen^[0].x = Flaechen^[3].x))
                               or ((Flaechen^[0].y = Flaechen^[1].y)
                                   and (Flaechen^[0].y = Flaechen^[2].y)
                                   and (Flaechen^[0].y = Flaechen^[3].y))
                               or ((Flaechen^[0].z = Flaechen^[1].z)
                                    and (Flaechen^[0].z = Flaechen^[2].z)
                                    and (Flaechen^[0].z = Flaechen^[3].z)) then
                          b:= WritePOVKommentar ('Eventuell ungenaue Vorderflche');
                        n1 := BerechneFlaechenNormale3v(Flaechen^[0], Flaechen^[1], Flaechen^[2]);
                        n2 := BerechneFlaechenNormale3v(Flaechen^[0], Flaechen^[1], Flaechen^[3]);
                        if (n1.x <> n2.x)
                           or (n1.y <> n2.y)
                           or (n1.z <> n2.z) then
                          b:= WritePOVKommentar ('Eventuell deformierte Vorderflche');
                      end;
                  { Vorderflche }
                  b := WritePOVPolygon(AnzahlKanten, Pointer(AktScheibe^.Flaechen), Tapete);
                  { Auenhaut - Seitenflchen }
                  for j := 0 to AnzahlFlaechen - 2 do
                    begin
                      with AktScheibe^ do
                        for i := 0 to AnzahlKanten - 1 do
                          if not Degeneriert^[i] then
                            begin
                              b := WritePOVDreieck (Flaechen^[i], AktScheibe^.NextScheibe^.Flaechen^[i], AktScheibe^.NextScheibe^.Flaechen^[i+1], Tapete);
                              b := WritePOVDreieck (Flaechen^[i], AktScheibe^.NextScheibe^.Flaechen^[i+1], Flaechen^[i+1], Tapete);
                            end;
                      AktScheibe := AktScheibe^.NextScheibe;
                    end;
                  { Hinterflche }
                  b := WritePOVPolygon (AnzahlKanten, Pointer(AktScheibe^.Flaechen), Tapete);
                  b := WritePOVWurstEnde (Material, - MaterialWinkel)
                end;
            end;
          AktWurst := AktWurst^.NextWurst;
        end;
      { Lichtquellen bergeben }
      for i := 0 to MaxLightPos do
        b := WritePOVLight(LightPos[i], LightIntensity[i]);
      { b := WritePOVCamera(Eye, Center, NearP); }
      { Wegen Standardbrennweite }
      b := WritePOVCamera(Eye, Center, 1);
      if ClosePOVFile then;
    end;
end;

(*
procedure MyKeys(key: Char; w, h: Integer);
const RotStep = 2.5;
var
  DebugStr  : String[255];
  DebugStr2 : array[1..255] of char;
  i         : Integer;
begin
  case key of
    #27 : halt(0);
    'v' : VorderOn := not VorderOn;
    'V' : HinterOn := not HinterOn;
    'i' : RotX := RotX + RotStep;
    'm' : RotX := RotX - RotStep;
    'j' : RotY := RotY + RotStep;
    'k' : RotY := RotY - RotStep;
    'h' : RotZ := RotZ + RotStep;
    'l' : RotZ := RotZ - RotStep;
    'n' : NearP := NearP - 1;
    'N' : NearP := NearP + 1;
    'f' : FarP  := FarP  - 5;
    'F' : FarP  := FarP  + 5;
    'w' : TempWinkel:= TempWinkel - 2;
    'W' : TempWinkel:= TempWinkel + 2;
    '+' : scale  := scale + 0.2;
    '-' : scale  := scale - 0.2;
    's' : scale3 := scale3 + 0.01;
    'S' : scale3 := scale3 - 0.01;
    '8' : LightPos[2] := LightPos[2] + 20;
    '6' : LightPos[1] := LightPos[1] + 20;
    '9' : LightPos[3] := LightPos[3] + 20;
    '2' : LightPos[2] := LightPos[2] - 20;
    '4' : LightPos[1] := LightPos[1] - 20;
    '3' : LightPos[3] := LightPos[3] - 20;
    'e' : Eye.z := Eye.z - 10;
    'E' : Eye.z := Eye.z + 10;
    'x' : Eye.x := Eye.x - 10;
    'X' : Eye.x := Eye.x + 10;
    'y' : Eye.y := Eye.y - 10;
    'Y' : Eye.y := Eye.y + 10;
    '7' : Center.z := Center.z + 10;
    '1' : Center.z := Center.z - 10;
    ' ' : LookOn := not LookOn;
    '#' : NormalOn := not NormalOn;
    't' : begin
            Inc(SaveNum);
            WriteStr(SaveName, '_3Dt',SaveNum:0);
            New(TexturArray, SizeX * SizeY * 3);
            glReadPixels(0,0,SizeX,SizeY,GL_RGB,GL_UNSIGNED_BYTE,TexturArray);
            if SaveScreen2TGA(SaveName, TexturArray^, SizeX, SizeY) then;
            Dispose(TexturArray);
          end;
    'p' : begin
            WritePOVFile;
          end;
    '.' : begin
            Inc(ViewMode);
            if ViewMode > MaxViewMode then ViewMode := 0;
          end;
    'a' : begin
            WriteStr(SaveName, MaxTextur:0);
          end;
    'O' : begin
            glViewport(0, 0, SizeX, SizeY);
            glMatrixMode(GL_PROJECTION);
            glLoadIdentity;
            { glOrtho (-16.0*GLfloat(640)/GLfloat(480), 16.0*GLfloat(640)/GLfloat(480), -6.0, 26.0, NearP, FarP); }
            glOrtho (-(SizeX/SizeY)*200,(SizeX/SizeY)*200, -150, 150, NearP, FarP);
            glMatrixMode(GL_MODELVIEW);
          end;
    'P' : begin
            glViewport(0, 0, SizeX, SizeY);
            glMatrixMode(GL_PROJECTION);
            glLoadIdentity;
            { glFrustum (0.0, 16.0*GLfloat(640)/GLfloat(480), 0.0, 16.0,-20.0, 20.0); }
            glFrustum (-(SizeX/SizeY)*0.5,(SizeX/SizeY)*0.5,-0.5,0.5,NearP,FarP);
            { glFrustum (-(SizeX/SizeY)*5,(SizeX/SizeY)*5,-5,5,NearP,FarP); }
            glMatrixMode(GL_MODELVIEW);
          end;
  end;
end;
*)

procedure TreppeReshape(w, h: Integer);
begin
    SizeX := w;
    SizeY := h;
    { In OpenGL ist [0,0] leider unten links }
    glViewport(0, MaxTreppeY - h, w, h);

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity;
    { Fr verschiedene Brennweiten mte "*NearP" gendert werden }
    glFrustum (-(SizeX/SizeY)*0.5*NearP,(SizeX/SizeY)*0.5*NearP,-0.5*NearP,0.5*NearP,NearP,FarP);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity;
end;


(*  Main Loop
 *  Open window with initial window size, title bar,
 *  RGBA display mode, and handle input events.
 *)


Procedure TreppeSetup ( FileName: Str255 );

const
  ScaleWurst = 0.1;

var
  AnzFlaechen, j, i, k: Integer;
  (*$ifdef __DJGPP__ *)
    MemUsed: SizeType;
  (*$endif *)

begin
    Eye.x   := -400;
    Eye.y   := 400;
    Eye.z   := 400;
    WurstInit;
    (*$ifdef __DJGPP__ *)
      if dpmi_get_free_memory_information(MemInfo) = 0 then begin
        { Writeln('Freier Speicher              : ', MemInfo.largest_available_free_block_in_bytes / 1204.0:0:0, ' kB'); }
        MemUsed := round(MemInfo.largest_available_free_block_in_bytes / 1204.0);
      end;
    (*$endif *)
    { Parameter per Datei setzen }
    { Spter durch direkte Funktionsaufrufe }
    Parse(FileName);

    if ParsenAbgebrochen then
      Exit;

    { Szene an OpenGL bertragen }
    { WurstZahl := StartShow(Wuerste, Eye, Center, Up); }
    
    { Ausdehnung der Szene ermitteln }
    { und Flchen zhlen }
    AnzFlaechen := 5; { Boden und 4 Wnde }

    MaxRoom := { Wuerste[0] } WurstListe^.VFlaeche^.Flaechen^[0];
    MinRoom := { Wuerste[0] } WurstListe^.VFlaeche^.Flaechen^[0];
    AktWurst := WurstListe;
    for k := 0 to AnzahlWuerste -1 do begin
      AnzFlaechen := AnzFlaechen + 2;
      { Vorder und Hinterflche }
      AnzFlaechen := AnzFlaechen + ({ Wuerste[k] } AktWurst^.AnzahlFlaechen-1) * { Wuerste[k] } AktWurst^.AnzahlKanten;
      { alle Auenflchen }
      with { Wuerste[k] } AktWurst^ do begin
        AktScheibe := VFlaeche;
        for i := 0 to AnzahlFlaechen-1 do begin
          with AktScheibe^ do
          for j := 0 to AnzahlKanten-1 do begin
            MaxRoom.x := max(MaxRoom.x, Flaechen^[j].x);
            MaxRoom.y := max(MaxRoom.y, Flaechen^[j].y);
            MaxRoom.z := max(MaxRoom.z, Flaechen^[j].z);
            MinRoom.x := min(MinRoom.x, Flaechen^[j].x);
            MinRoom.y := min(MinRoom.y, Flaechen^[j].y);
            MinRoom.z := min(MinRoom.z, Flaechen^[j].z);
          end;
          AktScheibe := AktScheibe^.NextScheibe;
        end;
      end;
      AktWurst := AktWurst^.NextWurst;
    end;

    { grten Radius der Szene ermitteln }
    MaxRadius := sqrt( sqr(MaxRoom.X - MinRoom.X) + sqr(MaxRoom.Y - MinRoom.Y) + sqr(MaxRoom.Z - MinRoom.Z) ) * 0.5;
    #ifdef __DJGPP__
      if dpmi_get_free_memory_information(MemInfo) = 0 then begin
        { Writeln('Freier Speicher              : ', MemInfo.largest_available_free_block_in_bytes / 1204.0:0:0, ' kB'); }
        MemUsed := MemUsed - round(MemInfo.largest_available_free_block_in_bytes / 1204.0);
        { Writeln('Verbrauchter Speicher        : ', MemUsed:0, ' kB'); }
      end;
    #endif

    { Hier bernimmt OpenGL die Arbeit }
    RotX := 0;
    RotY := 0;
    RotZ := 0;
    scale  := 1;
    scale2 := 1;
    { generelle Skalierung der Texturen }
    scale3 := 0.02;

    NearP  := 1;
    FarP   := 800;

    TempWinkel := 40;

    LookOn := True;

    NormalOn := True;
    VorderOn := True;
    HinterOn := True;
    bChanged := False;

    SzeneInit;
end;


end.
